import { MenuItem, ThemeService } from '@dotglitch/ngx-common';
import { StackEditorComponent } from '../../editor.component';
import { MatDialog } from '@angular/material/dialog';
import { EditorActions } from '../../editor-actions';
import * as i0 from "@angular/core";
export declare class ToolbarComponent {
    readonly stackEditor: StackEditorComponent;
    private readonly dialog;
    readonly theme: ThemeService;
    get editor(): import("../../editor/vanilla-mirror").VanillaMirror;
    get wrapSelection(): (before?: string, after?: string, indent?: number, insertNewline?: boolean) => void;
    colorList: string[][];
    textSizeMenu: MenuItem[];
    diagramMenu: MenuItem[];
    cursorIsInHeading: boolean;
    cursorIsInBold: boolean;
    cursorIsInItalic: boolean;
    cursorIsInStrikethrough: boolean;
    cursorIsInUnderline: boolean;
    cursorIsInBlockquote: boolean;
    cursorIsInLink: boolean;
    cursorIsInOrderedList: boolean;
    cursorIsInList: boolean;
    cursorIsInChecklist: boolean;
    cursorIsInTable: boolean;
    cursorIsInInlineCode: boolean;
    cursorIsInCode: boolean;
    currentTextColor: string;
    actions: EditorActions;
    constructor(stackEditor: StackEditorComponent, dialog: MatDialog, theme: ThemeService);
    bindEditorEvents(): void;
    onSelectionChange(): Promise<void>;
    injectHeading(size: number): void;
    toggleTOC(): void;
    toggleEditor(): void;
    togglePreview(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<ToolbarComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<ToolbarComponent, "app-toolbar", never, { "colorList": { "alias": "colorList"; "required": false; }; }, {}, never, never, true, never>;
}
//# sourceMappingURL=toolbar.component.d.ts.map