import { EventEmittingClass } from './utils';
import { VanillaMirror } from './vanilla-mirror';
import type * as Monaco from 'monaco-editor';
export declare class Section {
    text: any;
    data: "list" | "main" | "blockquote";
    elt: HTMLDivElement;
    forceHighlighting: boolean;
    monaco: Monaco.editor.IStandaloneCodeEditor;
    get ulid(): string;
    constructor(text: string | any);
    setElement(elt: HTMLDivElement): void;
}
export declare class Highlighter extends EventEmittingClass {
    private editor;
    isComposing: number;
    trailingNode: HTMLElement;
    get contentElt(): HTMLElement;
    cancelComposition: any;
    sectionList: Section[];
    insertBeforeSection: Section;
    readonly trailingNodeTag = "div";
    readonly lfHtml = "<span class=\"lf\">\n</span>";
    constructor(editor: VanillaMirror);
    fixContent(modifiedSections: Section[], removedSections: Section[], noContentFix: boolean): void;
    addTrailingNode(): void;
    calcLineNumbers: () => void;
    sectionHighlighter(section: Section): string;
    parseSections(content: string, isInit?: boolean): Section[];
}
//# sourceMappingURL=highlighter.d.ts.map