import { EventEmittingClass } from './utils';
import { VanillaMirror } from './vanilla-mirror';
export declare class SelectionMgr extends EventEmittingClass {
    private editor;
    get contentElt(): HTMLElement;
    get scrollElt(): HTMLElement;
    get hasFocus(): boolean;
    lastSelectionStart: number;
    lastSelectionEnd: number;
    selectionStart: number;
    selectionEnd: number;
    selectionIsReverse: boolean;
    selectionStartNode: Node;
    selectionStartOffset: number;
    selectionEndNode: Node;
    selectionEndOffset: number;
    cursorCoordinates: {
        top: number;
        height: number;
        left: number;
    };
    adjustScroll: any;
    oldSelectionRange: any;
    constructor(editor: VanillaMirror);
    createRange(start: number | {
        node: any;
        offset: any;
    }, end: number | {
        node: any;
        offset: any;
    }): Range;
    updateCursorCoordinates(adjustScrollParam?: boolean): void;
    /**
     * Check if the selection has been changed,
     * if so, emit a `selectionChanged` event.
     */
    checkSelection(selectionRange: any): boolean;
    restoreSelection(): Range;
    setSelection(start?: number, end?: number): void;
    setSelectionStartEnd(start: number, end: number, restoreSelection?: boolean): Range;
    saveSelectionState(selection?: Selection): boolean | Range;
    getSelectedText(): string;
    private getCoordinates;
    getClosestWordOffset(offset: number): {
        start: number;
        end: number;
    };
}
//# sourceMappingURL=selection-manager.d.ts.map