import { UndoManager } from './undo-manager';
import { Watcher } from './watcher';
import { EventEmittingClass } from './utils';
import { Highlighter } from './highlighter';
import { SelectionMgr } from './selection-manager';
import { StackEditorComponent } from '../editor.component';
export declare class VanillaMirror extends EventEmittingClass {
    ngEditor: StackEditorComponent;
    private editorElt;
    private lastTextContent;
    ignoreUndo: boolean;
    noContentFix: boolean;
    skipSaveSelection: boolean;
    $markers: {};
    $keystrokes: any[];
    value: string;
    get $contentElt(): HTMLElement;
    watcher: Watcher;
    highlighter: Highlighter;
    diffMatchPatch: any;
    selectionMgr: SelectionMgr;
    undoMgr: UndoManager;
    mouseDownSelectionCoords: {
        selectionStart: number;
        selectionEnd: number;
    };
    turndownService: any;
    constructor(ngEditor: StackEditorComponent, editorElt: HTMLElement, lastTextContent?: string);
    destroy(): void;
    toggleEditable(isEditable: boolean): void;
    onMouseUp: (evt: MouseEvent) => void;
    onMouseDown: (evt: MouseEvent) => void;
    onWindowResize: () => void;
    onSelectionChange: () => void;
    init(): void;
    getNodeAndOffsetAtIndex(index: number): {
        node: Node;
        offset: number;
    };
    getContent(): string;
    onMutationObserved(mutations: MutationRecord[]): void;
    triggerSpellCheck: () => void;
    setSelection(start: number, end: number): void;
    scrollCursorIntoView(): void;
    keydownHandler(handler: any): (evt: any) => void;
    adjustCursorPosition(force?: any): void;
    replaceContent(selectionStart: any, selectionEnd: any, replacement: any): Range;
    addKeystroke(keystroke: any): void;
    setContent(value: string, noUndo?: boolean, maxStartOffsetOpt?: number): {
        start: number;
        end: number;
        range: Range;
    };
    insertTextAtCarat(text: string): void;
    replace(selectionStart: number, selectionEnd: number, replacement: string): void;
    replaceAll(search: string | RegExp, replacement: string, startOffset?: number): void;
    focus(): void;
    addMarker(marker: any): void;
    removeMarker(marker: any): void;
    onKeyDown(evt: any): void;
    onCompositionStart(): void;
    onCompositionEnd(): void;
    onPaste(evt: any): void;
    onCopy(evt: any): void;
    onCut(evt: any): void;
    /**
     * Return the line at a given character index
     * This is _not_ the line number, but the index of the char in the whole string.
     *
     * This will default in the case of an empty modal.
     */
    getLine(charIndex: number, text?: string): {
        lineStart: number;
        lineEnd: number;
        line: string;
    };
    /**
     * Wrap the current selection in text
     */
    wrapSelection(before?: string, after?: string, indent?: number, insertNewline?: boolean): void;
    /**
     * Replace the current selection with the given text.
     */
    replaceSelection(text: string): void;
    rebaseSelectionByPixel(x: number, y: number): void;
}
//# sourceMappingURL=vanilla-mirror.d.ts.map