import * as i0 from '@angular/core';
import { Component, Inject, Input, SecurityContext, InjectionToken, EventEmitter, Optional, ViewChild, Output } from '@angular/core';
import * as i2 from '@angular/material/icon';
import { MatIconModule } from '@angular/material/icon';
import * as i3 from '@angular/material/tooltip';
import { MatTooltipModule } from '@angular/material/tooltip';
import * as i2$1 from '@dotglitch/ngx-common';
import { TooltipDirective, MenuDirective } from '@dotglitch/ngx-common';
import * as i6 from '@angular/material/button';
import { MatButtonModule } from '@angular/material/button';
import * as i4 from '@angular/material/input';
import { MatInputModule } from '@angular/material/input';
import * as i1 from '@angular/material/dialog';
import { MAT_DIALOG_DATA } from '@angular/material/dialog';
import * as i7 from '@angular/material/progress-spinner';
import { MatProgressSpinnerModule } from '@angular/material/progress-spinner';
import * as i8 from '@angular/forms';
import { FormsModule } from '@angular/forms';
import * as i5 from '@angular/material/form-field';
import DiffMatchPatch from 'diff-match-patch';
import { ulid } from 'ulidx';
import Prism from 'prismjs';
import 'prismjs/components/prism-asciidoc';
import 'prismjs/components/prism-awk';
import 'prismjs/components/prism-bash';
import 'prismjs/components/prism-batch';
import 'prismjs/components/prism-c';
import 'prismjs/components/prism-cmake';
import 'prismjs/components/prism-csharp';
import 'prismjs/components/prism-cshtml';
import 'prismjs/components/prism-csp';
import 'prismjs/components/prism-css';
import 'prismjs/components/prism-csv';
import 'prismjs/components/prism-dns-zone-file';
import 'prismjs/components/prism-docker';
import 'prismjs/components/prism-erlang';
import 'prismjs/components/prism-excel-formula';
import 'prismjs/components/prism-graphql';
import 'prismjs/components/prism-gradle';
import 'prismjs/components/prism-groovy';
import 'prismjs/components/prism-hsts';
import 'prismjs/components/prism-http';
import 'prismjs/components/prism-icon';
import 'prismjs/components/prism-ini';
import 'prismjs/components/prism-java';
import 'prismjs/components/prism-javascript';
import 'prismjs/components/prism-jq';
import 'prismjs/components/prism-json';
import 'prismjs/components/prism-json5';
import 'prismjs/components/prism-jsonp';
import 'prismjs/components/prism-jsstacktrace';
import 'prismjs/components/prism-jsx';
import 'prismjs/components/prism-log';
import 'prismjs/components/prism-makefile';
import 'prismjs/components/prism-markdown';
import 'prismjs/components/prism-markup';
import 'prismjs/components/prism-mermaid';
import 'prismjs/components/prism-nginx';
import 'prismjs/components/prism-perl';
import 'prismjs/components/prism-plant-uml';
import 'prismjs/components/prism-powerquery';
import 'prismjs/components/prism-powershell';
import 'prismjs/components/prism-sql';
import 'prismjs/components/prism-properties';
import 'prismjs/components/prism-puppet';
import 'prismjs/components/prism-python';
import 'prismjs/components/prism-regex';
import 'prismjs/components/prism-rest';
import 'prismjs/components/prism-ruby';
import 'prismjs/components/prism-rust';
import 'prismjs/components/prism-sass';
import 'prismjs/components/prism-scheme';
import 'prismjs/components/prism-scss';
import 'prismjs/components/prism-toml';
import 'prismjs/components/prism-tsx';
import 'prismjs/components/prism-typescript';
import 'prismjs/components/prism-uri';
import 'prismjs/components/prism-yaml';
import MarkdownIt from 'markdown-it';
import TurndownService from 'turndown/lib/turndown.browser.umd';
import markdownitAbbr from 'markdown-it-abbr';
import markdownitDeflist from 'markdown-it-deflist';
import markdownitFootnote from 'markdown-it-footnote';
import markdownitMark from 'markdown-it-mark';
import markdownitSub from 'markdown-it-sub';
import markdownitSup from 'markdown-it-sup';
import mermaid from 'mermaid';
import * as i6$1 from 'ngx-scrollbar';
import { NgScrollbarModule } from 'ngx-scrollbar';
import * as i3$1 from '@angular/platform-browser';

var mermaidLayouts = [{
        label: "Flow Chart", value: `\n\`\`\`mermaid
flowchart LR
    markdown[This ** is ** _Markdown_]
    newLines["Line1
    Line 2
    Line 3"]
    markdown --> newLines
\`\`\``
    },
    {
        label: "Sequence Diagram", value: `\n\`\`\`mermaid
sequenceDiagram
    Alice ->> Bob: Hello Bob, how are you?
    Bob-->>John: How about you John?
    Bob--x Alice: I am good thanks!
    Bob-x John: I am good thanks!
    Note right of John: Bob thinks a long<br/>long time, so long<br/>that the text does<br/>not fit on a row.

    Bob-->Alice: Checking with John...
    Alice->John: Yes... John, how are you?
\`\`\``
    },
    {
        label: "Class Diagram", value: `\n\`\`\`mermaid
classDiagram
    note "From Duck till Zebra"
    Animal <|-- Duck
    note for Duck "can fly\ncan swim\ncan dive\ncan help in debugging"
    Animal <|-- Fish
    Animal <|-- Zebra
    Animal : +int age
    Animal : +String gender
    Animal: +isMammal()
    Animal: +mate()
    class Duck{
        +String beakColor
        +swim()
        +quack()
    }
    class Fish{
        -int sizeInFeet
        -canEat()
    }
    class Zebra{
        +bool is_wild
        +run()
    }
\`\`\``
    },
    {
        label: "State Diagram", value: `\n\`\`\`mermaid
stateDiagram-v2
    [*] --> Still
    Still --> [*]

    Still --> Moving
    Moving --> Still
    Moving --> Crash
    Crash --> [*]
\`\`\``
    },
    {
        label: "Entity Relationship Diagram", value: `\n\`\`\`mermaid
---
title: Order example
---
erDiagram
    CUSTOMER ||--o{ ORDER : places
    ORDER ||--|{ LINE-ITEM : contains
    CUSTOMER }|..|{ DELIVERY-ADDRESS : uses
\`\`\``
    },
    {
        label: "User Journey Diagram", value: `\n\`\`\`mermaid
journey
    title My working day
    section Go to work
      Make tea: 5: Me
      Go upstairs: 3: Me
      Do work: 1: Me, Cat
    section Go home
      Go downstairs: 5: Me
      Sit down: 5: Me
\`\`\``
    },
    {
        label: "Gantt Chart", value: `\n\`\`\`mermaid
gantt
    title A Gantt Diagram
    dateFormat YYYY-MM-DD
    section Section
        A task          :a1, 2014-01-01, 30d
        Another task    :after a1, 20d
    section Another
        Task in Another :2014-01-12, 12d
        another task    :24d
\`\`\``
    },
    {
        label: "Pie Chart", value: `\n\`\`\`mermaid
pie title Pets adopted by volunteers
    "Dogs": 386
    "Cats": 85
    "Rats": 15
\`\`\``
    },
    {
        label: "Requirement Diagram", value: `\n\`\`\`mermaid
requirementDiagram

    requirement test_req {
        id: 1
        text: the test text.
        risk: high
        verifymethod: test
    }

    element test_entity {
        type: simulation
    }

    test_entity - satisfies -> test_req
\`\`\``
    },
    {
        label: "Mindmap", value: `\n\`\`\`mermaid
mindmap
  root((mindmap))
    Origins
      Long history
      ::icon(fa fa-book)
      Popularisation
        British popular psychology author Tony Buzan
    Research
      On effectiveness<br/>and features
      On Automatic creation
        Uses
            Creative techniques
            Strategic planning
            Argument mapping
    Tools
      Pen and paper
      Mermaid
\`\`\``
    },
    {
        label: "Timeline", value: `\n\`\`\`mermaid
timeline
    title History of Social Media Platform
    2002 : LinkedIn
    2004 : Facebook
         : Google
    2005 : Youtube
    2006 : Twitter
\`\`\``
    }];

class ImageInsertComponent {
    dialogRef;
    data;
    isSaving = false;
    imageUrl = '';
    imagePlaceholder = '';
    stackEditor;
    constructor(dialogRef, data) {
        this.dialogRef = dialogRef;
        this.data = data;
        this.stackEditor = data.stackEditor;
        const editor = this.stackEditor.editorSvc.clEditor;
        this.imagePlaceholder = editor.getContent().slice(editor.selectionMgr.selectionStart, editor.selectionMgr.selectionEnd);
    }
    ngOnInit() {
    }
    onFileUpload(files) {
        this.stackEditor.onImageUpload.next({
            data: files,
            ...this.stackEditor.editorSvc.clEditor.selectionMgr,
            stackEditor: this.stackEditor
        });
        this.dialogRef.close();
    }
    async applyChanges() {
        this.stackEditor.editorSvc.clEditor.replaceSelection(`![${this.imagePlaceholder}](${this.imageUrl})`);
        this.dialogRef.close();
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "17.1.1", ngImport: i0, type: ImageInsertComponent, deps: [{ token: i1.MatDialogRef }, { token: MAT_DIALOG_DATA }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "17.0.0", version: "17.1.1", type: ImageInsertComponent, isStandalone: true, selector: "app-image-insert", ngImport: i0, template: "\n<div>\n    <mat-form-field>\n        <mat-label>Image URL</mat-label>\n        <input matInput type=\"text\" [(ngModel)]=\"imageUrl\">\n\n        <input #file type=\"file\" style=\"display: none;\">\n\n        @if (data.stackEditor.allowImageUpload) {\n            <button\n                mat-flat-button\n\n                (click)=\"file.click(); onFileUpload(file.files)\"\n                style=\"float: right\"\n            >\n                <mat-icon>upload_file</mat-icon>\n                Or upload an Image\n            </button>\n        }\n    </mat-form-field>\n</div>\n\n<mat-form-field>\n    <mat-label matTooltip=\"Text shown if the image fails to load\">Placeholder Text</mat-label>\n    <input matInput type=\"text\" [(ngModel)]=\"imagePlaceholder\">\n</mat-form-field>\n\n<div style=\"flex: 1\"></div>\n\n<div style=\"display: flex; justify-content: end;\">\n    <button mat-flat-button (click)=\"applyChanges()\">\n\n        @if (isSaving) {\n            <mat-progress-spinner\n                mode=\"indeterminate\"\n                [diameter]=\"18\"\n                style=\"display: inline\"\n            />\n        }\n        @else {\n            <mat-icon>check</mat-icon>\n        }\n\n        Ok\n    </button>\n    <button\n        mat-flat-button\n        (click)=\"dialogRef.close()\"\n    >\n        <mat-icon>close</mat-icon>\n        Cancel\n    </button>\n</div>\n", styles: [":host{padding:24px;width:500px;height:300px;display:flex;flex-direction:column}mat-form-field{width:100%}\n"], dependencies: [{ kind: "ngmodule", type: MatIconModule }, { kind: "component", type: i2.MatIcon, selector: "mat-icon", inputs: ["color", "inline", "svgIcon", "fontSet", "fontIcon"], exportAs: ["matIcon"] }, { kind: "ngmodule", type: MatTooltipModule }, { kind: "directive", type: i3.MatTooltip, selector: "[matTooltip]", inputs: ["matTooltipPosition", "matTooltipPositionAtOrigin", "matTooltipDisabled", "matTooltipShowDelay", "matTooltipHideDelay", "matTooltipTouchGestures", "matTooltip", "matTooltipClass"], exportAs: ["matTooltip"] }, { kind: "ngmodule", type: MatInputModule }, { kind: "directive", type: i4.MatInput, selector: "input[matInput], textarea[matInput], select[matNativeControl],      input[matNativeControl], textarea[matNativeControl]", inputs: ["disabled", "id", "placeholder", "name", "required", "type", "errorStateMatcher", "aria-describedby", "value", "readonly"], exportAs: ["matInput"] }, { kind: "component", type: i5.MatFormField, selector: "mat-form-field", inputs: ["hideRequiredMarker", "color", "floatLabel", "appearance", "subscriptSizing", "hintLabel"], exportAs: ["matFormField"] }, { kind: "directive", type: i5.MatLabel, selector: "mat-label" }, { kind: "ngmodule", type: MatButtonModule }, { kind: "component", type: i6.MatButton, selector: "    button[mat-button], button[mat-raised-button], button[mat-flat-button],    button[mat-stroked-button]  ", exportAs: ["matButton"] }, { kind: "ngmodule", type: MatProgressSpinnerModule }, { kind: "component", type: i7.MatProgressSpinner, selector: "mat-progress-spinner, mat-spinner", inputs: ["color", "mode", "value", "diameter", "strokeWidth"], exportAs: ["matProgressSpinner"] }, { kind: "ngmodule", type: FormsModule }, { kind: "directive", type: i8.DefaultValueAccessor, selector: "input:not([type=checkbox])[formControlName],textarea[formControlName],input:not([type=checkbox])[formControl],textarea[formControl],input:not([type=checkbox])[ngModel],textarea[ngModel],[ngDefaultControl]" }, { kind: "directive", type: i8.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { kind: "directive", type: i8.NgModel, selector: "[ngModel]:not([formControlName]):not([formControl])", inputs: ["name", "disabled", "ngModel", "ngModelOptions"], outputs: ["ngModelChange"], exportAs: ["ngModel"] }] });
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "17.1.1", ngImport: i0, type: ImageInsertComponent, decorators: [{
            type: Component,
            args: [{ selector: 'app-image-insert', imports: [
                        MatIconModule,
                        MatTooltipModule,
                        MatInputModule,
                        MatButtonModule,
                        MatProgressSpinnerModule,
                        FormsModule
                    ], standalone: true, template: "\n<div>\n    <mat-form-field>\n        <mat-label>Image URL</mat-label>\n        <input matInput type=\"text\" [(ngModel)]=\"imageUrl\">\n\n        <input #file type=\"file\" style=\"display: none;\">\n\n        @if (data.stackEditor.allowImageUpload) {\n            <button\n                mat-flat-button\n\n                (click)=\"file.click(); onFileUpload(file.files)\"\n                style=\"float: right\"\n            >\n                <mat-icon>upload_file</mat-icon>\n                Or upload an Image\n            </button>\n        }\n    </mat-form-field>\n</div>\n\n<mat-form-field>\n    <mat-label matTooltip=\"Text shown if the image fails to load\">Placeholder Text</mat-label>\n    <input matInput type=\"text\" [(ngModel)]=\"imagePlaceholder\">\n</mat-form-field>\n\n<div style=\"flex: 1\"></div>\n\n<div style=\"display: flex; justify-content: end;\">\n    <button mat-flat-button (click)=\"applyChanges()\">\n\n        @if (isSaving) {\n            <mat-progress-spinner\n                mode=\"indeterminate\"\n                [diameter]=\"18\"\n                style=\"display: inline\"\n            />\n        }\n        @else {\n            <mat-icon>check</mat-icon>\n        }\n\n        Ok\n    </button>\n    <button\n        mat-flat-button\n        (click)=\"dialogRef.close()\"\n    >\n        <mat-icon>close</mat-icon>\n        Cancel\n    </button>\n</div>\n", styles: [":host{padding:24px;width:500px;height:300px;display:flex;flex-direction:column}mat-form-field{width:100%}\n"] }]
        }], ctorParameters: () => [{ type: i1.MatDialogRef }, { type: undefined, decorators: [{
                    type: Inject,
                    args: [MAT_DIALOG_DATA]
                }] }] });

class LinkInsertComponent {
    dialogRef;
    data;
    isSaving = false;
    linkUrl = '';
    linkText = '';
    stackEditor;
    constructor(dialogRef, data) {
        this.dialogRef = dialogRef;
        this.data = data;
        this.stackEditor = data.stackEditor;
        const editor = this.stackEditor.editorSvc.clEditor;
        this.linkText = editor.getContent().slice(editor.selectionMgr.selectionStart, editor.selectionMgr.selectionEnd);
    }
    ngOnInit() {
    }
    async applyChanges() {
        this.stackEditor.editorSvc.clEditor.replaceSelection(`[${this.linkText}](${this.linkUrl})`);
        this.dialogRef.close();
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "17.1.1", ngImport: i0, type: LinkInsertComponent, deps: [{ token: i1.MatDialogRef }, { token: MAT_DIALOG_DATA }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "17.0.0", version: "17.1.1", type: LinkInsertComponent, isStandalone: true, selector: "app-link-insert", ngImport: i0, template: "<mat-form-field>\n    <mat-label matTooltip=\"Preview text for the link\">Link Text</mat-label>\n    <input matInput type=\"text\" [(ngModel)]=\"linkText\">\n</mat-form-field>\n\n<mat-form-field>\n    <mat-label matTooltip=\"URL that the link points to\">Link URL</mat-label>\n    <input matInput type=\"text\" [(ngModel)]=\"linkUrl\">\n</mat-form-field>\n\n<div style=\"flex: 1\"></div>\n\n<div style=\"display: flex; justify-content: end;\">\n    <button mat-flat-button (click)=\"applyChanges()\">\n\n        @if (isSaving) {\n            <mat-progress-spinner\n                mode=\"indeterminate\"\n                [diameter]=\"18\"\n                style=\"display: inline\"\n            />\n        }\n        @else {\n            <mat-icon>check</mat-icon>\n        }\n\n        Ok\n    </button>\n    <button mat-flat-button (click)=\"dialogRef.close()\">\n        <mat-icon>close</mat-icon>\n        Cancel\n    </button>\n</div>\n", styles: [":host{padding:24px;width:500px;height:300px;display:flex;flex-direction:column}mat-form-field{width:100%}\n"], dependencies: [{ kind: "ngmodule", type: MatIconModule }, { kind: "component", type: i2.MatIcon, selector: "mat-icon", inputs: ["color", "inline", "svgIcon", "fontSet", "fontIcon"], exportAs: ["matIcon"] }, { kind: "ngmodule", type: MatTooltipModule }, { kind: "directive", type: i3.MatTooltip, selector: "[matTooltip]", inputs: ["matTooltipPosition", "matTooltipPositionAtOrigin", "matTooltipDisabled", "matTooltipShowDelay", "matTooltipHideDelay", "matTooltipTouchGestures", "matTooltip", "matTooltipClass"], exportAs: ["matTooltip"] }, { kind: "ngmodule", type: MatInputModule }, { kind: "directive", type: i4.MatInput, selector: "input[matInput], textarea[matInput], select[matNativeControl],      input[matNativeControl], textarea[matNativeControl]", inputs: ["disabled", "id", "placeholder", "name", "required", "type", "errorStateMatcher", "aria-describedby", "value", "readonly"], exportAs: ["matInput"] }, { kind: "component", type: i5.MatFormField, selector: "mat-form-field", inputs: ["hideRequiredMarker", "color", "floatLabel", "appearance", "subscriptSizing", "hintLabel"], exportAs: ["matFormField"] }, { kind: "directive", type: i5.MatLabel, selector: "mat-label" }, { kind: "ngmodule", type: MatButtonModule }, { kind: "component", type: i6.MatButton, selector: "    button[mat-button], button[mat-raised-button], button[mat-flat-button],    button[mat-stroked-button]  ", exportAs: ["matButton"] }, { kind: "ngmodule", type: MatProgressSpinnerModule }, { kind: "component", type: i7.MatProgressSpinner, selector: "mat-progress-spinner, mat-spinner", inputs: ["color", "mode", "value", "diameter", "strokeWidth"], exportAs: ["matProgressSpinner"] }, { kind: "ngmodule", type: FormsModule }, { kind: "directive", type: i8.DefaultValueAccessor, selector: "input:not([type=checkbox])[formControlName],textarea[formControlName],input:not([type=checkbox])[formControl],textarea[formControl],input:not([type=checkbox])[ngModel],textarea[ngModel],[ngDefaultControl]" }, { kind: "directive", type: i8.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { kind: "directive", type: i8.NgModel, selector: "[ngModel]:not([formControlName]):not([formControl])", inputs: ["name", "disabled", "ngModel", "ngModelOptions"], outputs: ["ngModelChange"], exportAs: ["ngModel"] }] });
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "17.1.1", ngImport: i0, type: LinkInsertComponent, decorators: [{
            type: Component,
            args: [{ selector: 'app-link-insert', imports: [
                        MatIconModule,
                        MatTooltipModule,
                        MatInputModule,
                        MatButtonModule,
                        MatProgressSpinnerModule,
                        FormsModule
                    ], standalone: true, template: "<mat-form-field>\n    <mat-label matTooltip=\"Preview text for the link\">Link Text</mat-label>\n    <input matInput type=\"text\" [(ngModel)]=\"linkText\">\n</mat-form-field>\n\n<mat-form-field>\n    <mat-label matTooltip=\"URL that the link points to\">Link URL</mat-label>\n    <input matInput type=\"text\" [(ngModel)]=\"linkUrl\">\n</mat-form-field>\n\n<div style=\"flex: 1\"></div>\n\n<div style=\"display: flex; justify-content: end;\">\n    <button mat-flat-button (click)=\"applyChanges()\">\n\n        @if (isSaving) {\n            <mat-progress-spinner\n                mode=\"indeterminate\"\n                [diameter]=\"18\"\n                style=\"display: inline\"\n            />\n        }\n        @else {\n            <mat-icon>check</mat-icon>\n        }\n\n        Ok\n    </button>\n    <button mat-flat-button (click)=\"dialogRef.close()\">\n        <mat-icon>close</mat-icon>\n        Cancel\n    </button>\n</div>\n", styles: [":host{padding:24px;width:500px;height:300px;display:flex;flex-direction:column}mat-form-field{width:100%}\n"] }]
        }], ctorParameters: () => [{ type: i1.MatDialogRef }, { type: undefined, decorators: [{
                    type: Inject,
                    args: [MAT_DIALOG_DATA]
                }] }] });

class EditorActions {
    stackEditor;
    dialog;
    get editor() { return this.stackEditor.editorSvc.clEditor; }
    get wrapSelection() {
        return this.editor.wrapSelection.bind(this.editor);
    }
    colorizeText(color) {
        this.wrapSelection(`<span style="color: ${color}">`, "</span>");
    }
    setTextFont(font) {
        this.wrapSelection(`<span style="font-family: ${font}">`, "</span>");
    }
    boldText() {
        this.wrapSelection("**", "**");
    }
    italicizeText() {
        this.wrapSelection("_", "_");
    }
    strikethroughText() {
        this.wrapSelection("~~", "~~");
    }
    blockQuoteText() {
        this.wrapSelection("> ", '', null, true);
    }
    insertOrderedList() {
        this.wrapSelection(" 1. ", '', null, true);
    }
    insertList() {
        this.wrapSelection(" - ", '', null, true);
    }
    insertCheckList() {
        this.wrapSelection(" - [ ] ", '', null, true);
    }
    insertInlineCode() {
        this.wrapSelection("`", "`");
    }
    insertCodeBlock() {
        // TODO: align to start of line
        this.wrapSelection("```\n", "\n```", null, true);
    }
    insertComment() {
        this.wrapSelection("<!-- ", " -->", null, true);
    }
    /**
      * | Heading 1 |     |
        | ---       | --- |
        |           |     |
     */
    insertTable(cols, rows) {
        let text = [];
        for (let i = 0; i < rows + 2; i++) {
            // Empty cell
            let placeholder = ''.padStart(8 + (cols.toString().length), ' ');
            let cells = [];
            // If we're on the second row, we place dashes in the cell.
            if (i == 1)
                placeholder = ''.padStart(8 + (cols.toString().length), '-');
            for (let j = 0; j < cols; j++) {
                // If we're on the first row, we use "Heading 1" etc.
                if (i == 0)
                    placeholder = "Heading " + (j + 1);
                cells.push(placeholder);
            }
            text.push("| " + cells.join(" | ") + " |");
        }
        const table = text.join('\n');
        this.wrapSelection('', '\n' + table, null, true);
    }
    openImageDialog() {
        this.dialog.open(ImageInsertComponent, { data: { stackEditor: this.stackEditor } });
    }
    openLinkDialog() {
        this.dialog.open(LinkInsertComponent, { data: { stackEditor: this.stackEditor } });
    }
    constructor(stackEditor, dialog) {
        this.stackEditor = stackEditor;
        this.dialog = dialog;
    }
}

class ToolbarComponent {
    stackEditor;
    dialog;
    theme;
    get editor() { return this.stackEditor.editorSvc.clEditor; }
    get wrapSelection() {
        return this.editor.wrapSelection.bind(this.editor);
    }
    // 2D array of color hex codes that show up for the color picker.
    colorList = [
        // Gray  red     yellow  green   gcyan   lblue   dblue   violet  puke    brown
        "#000000 #4c4c4c #666666 #808080 #999999 #b3b3b3 #cccccc #e6e6e6 #f2f2f2 #ffffff".split(' '),
        "#d4dae4 #ffcdd2 #f9e6ad #bce4ce #bdf0e9 #b3e5fc #aec1ff #c5c0da #d6bdcc #d2c5c1".split(' '),
        "#b0b8cd #fe9998 #f4d679 #90d2af #92e7dc #81d4fa #88a3f9 #9f97c1 #c492ac #b4a09a".split(' '),
        "#949db1 #f35c4e #edb90f #33b579 #02d7c5 #29b6f6 #5874cd #7e6bad #a9537c #826358".split(' '),
        "#727a8c #e94633 #eaa100 #36955f #11b3a5 #039be5 #2349ae #584a8f #963a64 #624339".split(' '),
        "#5e6677 #d73c2d #ea8f00 #247346 #018b80 #0288d1 #163fa2 #4f4083 #81355a #5d4037".split(' '),
        "#3f4757 #ca3626 #ea7e00 #1d5b38 #026b60 #0277bd #083596 #473776 #6e3051 #4e342e".split(' '),
        "#1d2534 #bb2b1a #ea5d00 #17492d #024f43 #01579b #002381 #3a265f #4c2640 #3e2723".split(' ')
    ];
    textSizeMenu = [
        { label: "Heading 1", action: () => this.injectHeading(1) },
        { label: "Heading 2", action: () => this.injectHeading(2) },
        { label: "Heading 3", action: () => this.injectHeading(3) },
        { label: "Heading 4", action: () => this.injectHeading(4) },
        { label: "Heading 5", action: () => this.injectHeading(5) },
        { label: "Heading 6", action: () => this.injectHeading(6) }
    ];
    diagramMenu = [
        { label: "Mermaid Diagrams:" },
        { label: "Live Editor", link: "https://mermaid.live/edit", linkTarget: "_blank" },
        { label: "Examples", link: "https://mermaid.js.org/syntax/examples.html", linkTarget: "_blank" },
        "separator",
        ...mermaidLayouts.map(l => ({
            label: l.label,
            action: () => this.wrapSelection(l.value, '', null, true)
        }))
    ];
    cursorIsInHeading = false;
    cursorIsInBold = false;
    cursorIsInItalic = false;
    cursorIsInStrikethrough = false;
    cursorIsInUnderline = false;
    cursorIsInBlockquote = false;
    cursorIsInLink = false;
    cursorIsInOrderedList = false;
    cursorIsInList = false;
    cursorIsInChecklist = false;
    cursorIsInTable = false;
    cursorIsInInlineCode = false;
    cursorIsInCode = false;
    currentTextColor = "#f00";
    actions;
    constructor(stackEditor, dialog, theme) {
        this.stackEditor = stackEditor;
        this.dialog = dialog;
        this.theme = theme;
        this.actions = new EditorActions(stackEditor, dialog);
    }
    bindEditorEvents() {
        // Handle cursor position updates
        this.stackEditor.editorSvc.on("selectionRange", this.onSelectionChange.bind(this));
    }
    async onSelectionChange() {
        this.cursorIsInHeading = false;
        this.cursorIsInBold = false;
        this.cursorIsInItalic = false;
        this.cursorIsInStrikethrough = false;
        this.cursorIsInBlockquote = false;
        this.cursorIsInLink = false;
        this.cursorIsInOrderedList = false;
        this.cursorIsInList = false;
        this.cursorIsInChecklist = false;
        this.cursorIsInTable = false;
        this.cursorIsInInlineCode = false;
        this.cursorIsInCode = false;
        // Large selection -- don't perform evaluations
        if (this.stackEditor.editorSvc.clEditor.selectionMgr.selectionStart != this.stackEditor.editorSvc.clEditor.selectionMgr.selectionEnd) {
            return;
        }
        const { parentElement } = this.stackEditor.editorSvc?.selectionRange?.commonAncestorContainer || {};
        if (!parentElement)
            return;
        const inheritedClasses = [];
        let currentElement = parentElement;
        for (let i = 0; i < 10 && currentElement && !currentElement.classList.contains("cledit-section"); i++) {
            currentElement.classList.forEach(c => inheritedClasses.push(c));
            currentElement = currentElement.parentElement;
        }
        const content = this.stackEditor.editorSvc.clEditor.getContent();
        const matches = content.substring(0, this.stackEditor.editorSvc.clEditor.selectionMgr.selectionStart).split('\n');
        const currentLine = matches?.slice(-1)?.[0];
        if (['h1', 'h2', 'h3', 'h4', 'h5', 'h6'].some(c => inheritedClasses.includes(c)))
            this.cursorIsInHeading = true;
        if (inheritedClasses.includes("bold"))
            this.cursorIsInBold = true;
        if (inheritedClasses.includes("italic"))
            this.cursorIsInItalic = true;
        if (inheritedClasses.includes("strike"))
            this.cursorIsInStrikethrough = true;
        if (inheritedClasses.includes("blockquote") || currentLine.match(/^\s*>\s*/))
            this.cursorIsInBlockquote = true;
        if (inheritedClasses.includes("bold"))
            this.cursorIsInLink = true;
        // TODO: This detection will not work for nested items
        // These need custom markdown highlighting to work properly
        if (currentLine.match(/^\s*\d+\.\s*/))
            this.cursorIsInOrderedList = true;
        if (currentLine.match(/^\s*[\-*]\s*/))
            this.cursorIsInList = true;
        if (currentLine.match(/^\s*[\-*]\s*\[[ xX*]?\]\s*/)) {
            this.cursorIsInList = false;
            this.cursorIsInChecklist = true;
        }
        // Needs custom highlighting
        if (inheritedClasses.includes("table"))
            this.cursorIsInTable = true;
        if (inheritedClasses.includes("code-snippet"))
            this.cursorIsInInlineCode = true;
        if (inheritedClasses.includes("code-block"))
            this.cursorIsInCode = true;
    }
    injectHeading(size) {
        const headerString = ''.padStart(size, '#') + ' ';
        this.wrapSelection(headerString, '', null, true);
    }
    toggleTOC() {
        this.stackEditor.showToc = !this.stackEditor.showToc;
    }
    toggleEditor() {
        this.stackEditor.mode = this.stackEditor.mode == 'view' ? 'edit' : 'view';
        if (this.stackEditor.mode == 'view' && !this.stackEditor.showPreview)
            this.stackEditor.showPreview = !this.stackEditor.showPreview;
    }
    togglePreview() {
        this.stackEditor.showPreview = !this.stackEditor.showPreview;
        if (this.stackEditor.mode == 'view' && !this.stackEditor.showPreview)
            this.stackEditor.mode = this.stackEditor.mode == 'view' ? 'edit' : 'view';
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "17.1.1", ngImport: i0, type: ToolbarComponent, deps: [{ token: StackEditorComponent }, { token: i1.MatDialog }, { token: i2$1.ThemeService }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "17.0.0", version: "17.1.1", type: ToolbarComponent, isStandalone: true, selector: "app-toolbar", inputs: { colorList: "colorList" }, ngImport: i0, template: "<!-- Header -->\n<mat-icon [ngx-menu]=\"textSizeMenu\" [class.reflect]=\"cursorIsInHeading\" matTooltip=\"Headings\">format_size</mat-icon>\n<!-- Color -->\n<mat-icon [ngx-tooltip]=\"colorPopup\" [ngx-tooltip-config]=\"{ triggers: ['click'], position: 'bottom' }\">\n    <svg xmlns=\"http://www.w3.org/2000/svg\" height=\"24px\" viewBox=\"0 0 24 24\" width=\"24px\" style=\"margin-top: -3px;\">\n        <path [style.fill]=\"currentTextColor\" d=\"M2 20L2 24L22 24L22 20L2 20z\" />\n        <path fill=\"var(--text-color)\" d=\"M10.75 3L5.49 17L7.91 17L9.18 13.42L14.83 13.42L16.09 17L18.51 17L13.25 3L10.75 3z M11.94 5.6L12.06 5.6L14.09 11.39L9.91 11.39L11.94 5.6z\" />\n    </svg>\n</mat-icon>\n\n<ng-template #colorPopup let-dialog=\"dialog\">\n    @for (ctx of [{color: '#000'}]; track ctx) {\n        <div\n            class=\"table-popup\"\n        >\n            <div\n                [style.color]=\"ctx.color\"\n                [style.background-color]=\"\"\n            >\n                {{ctx.color}}\n            </div>\n            <div class=\"grouped\" style=\"display: flex; gap: 2px; flex-direction: column;\">\n                @for (row of colorList; track row) {\n                    <div class=\"table-row\">\n                        @for (color of row; track color) {\n                            <div\n\n                                class=\"col-cell\"\n                                style=\"width: 24px; height: 24px\"\n                                [style.background-color]=\"color + 'ee'\"\n                                [style.border-color]=\"color + ''\"\n                                (click)=\"actions.colorizeText(currentTextColor = color); dialog.close()\"\n                                (pointerenter)=\"ctx.color = color\"\n                            >\n                            </div>\n                        }\n                    </div>\n                }\n            </div>\n        </div>\n    }\n</ng-template>\n\n<!-- Bold -->\n<mat-icon\n    (mousedown)=\"actions.boldText(); $event.preventDefault()\"\n    [class.reflect]=\"cursorIsInBold\"\n    matTooltip=\"Bold\"\n>\n    format_bold\n</mat-icon>\n<!-- Italic -->\n<mat-icon\n    (mousedown)=\"actions.italicizeText(); $event.preventDefault()\"\n    [class.reflect]=\"cursorIsInItalic\"\n    matTooltip=\"Italic\"\n>\n    format_italic\n</mat-icon>\n<!-- Strikethrough -->\n<mat-icon\n    (mousedown)=\"actions.strikethroughText(); $event.preventDefault()\"\n    [class.reflect]=\"cursorIsInStrikethrough\"\n    matTooltip=\"Strikethrough\"\n>\n    format_strikethrough\n</mat-icon>\n<!-- Underscore -->\n<!-- <mat-icon>format_underlined</mat-icon> -->\n\n<!-- Quote -->\n<mat-icon\n    (mousedown)=\"actions.blockQuoteText(); $event.preventDefault()\"\n    [class.reflect]=\"cursorIsInBlockquote\"\n    matTooltip=\"Blockquote\"\n>\n    format_quote\n</mat-icon>\n<!-- Link -->\n<mat-icon\n    matTooltip=\"Insert a Link\"\n    [class.reflect]=\"cursorIsInLink\"\n    (mousedown)=\"actions.openLinkDialog(); $event.preventDefault()\"\n>\n    link\n</mat-icon>\n\n<!-- Ordered list -->\n<mat-icon (mousedown)=\"actions.insertOrderedList(); $event.preventDefault()\" [class.reflect]=\"cursorIsInOrderedList\" matTooltip=\"Ordered List\">format_list_numbered</mat-icon>\n<!-- Unordered list -->\n<mat-icon (mousedown)=\"actions.insertList(); $event.preventDefault()\" [class.reflect]=\"cursorIsInList\" matTooltip=\"Unordered list\">format_list_bulleted</mat-icon>\n<!-- Checklist -->\n<mat-icon (mousedown)=\"actions.insertCheckList(); $event.preventDefault()\" [class.reflect]=\"cursorIsInChecklist\" matTooltip=\"Checklist\">rule</mat-icon>\n\n<!-- Table -->\n<mat-icon [ngx-tooltip]=\"tablePopup\" [ngx-tooltip-config]=\"{ triggers: ['click'], position: 'bottom' }\" [class.reflect]=\"cursorIsInTable\">table_chart</mat-icon>\n<ng-template #tablePopup let-data=\"data\" let-dialog=\"dialog\">\n    @for (ctx of [{cols: 0, rows: 0}]; track ctx) {\n        <div\n\n            class=\"table-popup\"\n        >\n            <div>{{ctx.cols}}x{{ctx.rows}}</div>\n            <div class=\"grouped\">\n                @for (row of [1,2,3,4,5,6]; track row) {\n                    <div class=\"table-row\">\n                        @for (col of [1,2,3,4,5,6]; track col) {\n                            <div\n\n                                class=\"col-cell\"\n                                [class.selected]=\"ctx.cols >= col && ctx.rows >= row\"\n                                (pointerenter)=\"ctx.cols = col; ctx.rows = row\"\n                                (click)=\"actions.insertTable(ctx.cols, ctx.rows); dialog.close()\"\n                            ></div>\n                        }\n                    </div>\n                }\n            </div>\n        </div>\n    }\n</ng-template>\n\n<!-- Image -->\n<mat-icon\n    matTooltip=\"Insert an image\"\n    (mousedown)=\"actions.openImageDialog(); $event.preventDefault()\"\n>\n    add_photo_alternate\n</mat-icon>\n\n\n<!-- Inline code -->\n<mat-icon\n    (mousedown)=\"actions.insertInlineCode(); $event.preventDefault()\"\n    [class.reflect]=\"cursorIsInInlineCode\"\n    matTooltip=\"Inline highlight\"\n>\n    code\n</mat-icon>\n<!-- Code Block -->\n<mat-icon\n    (mousedown)=\"actions.insertCodeBlock(); $event.preventDefault()\"\n    [class.reflect]=\"cursorIsInCode\"\n    matTooltip=\"Code block\"\n>\n    data_object\n</mat-icon>\n\n<!-- Mermaid Diagrams... -->\n@if (stackEditor.showMermaid) {\n    <mat-icon\n        [ngx-menu]=\"diagramMenu\"\n        [ngx-menu-config]=\"{\n            customClass: ['mermaid-menu']\n        }\"\n        matTooltip=\"Diagrams\"\n    >\n        account_tree\n    </mat-icon>\n}\n\n<span style=\"flex: 1\">\n    <!-- {{stackEditor.editorSvc?.focus}}\n     //\n    {{stackEditor.editorSvc?.clEditor?.selectionMgr?.selectionStart}}::\n    {{stackEditor.editorSvc?.clEditor?.selectionMgr?.selectionEnd}} -->\n</span>\n\n@if (stackEditor.showToc != 'off') {\n    <mat-icon\n\n        (mousedown)=\"toggleTOC(); $event.preventDefault()\"\n        [matTooltip]=\"stackEditor.showToc ? 'Close Table of Contents' : 'Open Table of Contents'\"\n    >\n        toc\n    </mat-icon>\n}\n\n@if (stackEditor.showPreview != 'off' && stackEditor.mode != 'viewonly') {\n    <mat-icon\n        (mousedown)=\"toggleEditor(); $event.preventDefault()\"\n        matTooltip=\"Close Editor\"\n    >\n        check\n    </mat-icon>\n}\n\n@if (stackEditor.showPreview != 'off') {\n    <mat-icon\n        (mousedown)=\"togglePreview(); $event.preventDefault()\"\n        [matTooltip]=\"stackEditor.showPreview ? 'Hide Preview': 'Open Preview'\"\n    >\n        visibility_off\n    </mat-icon>\n}\n", styles: ["::ng-deep .light{--toolbar-background-color: #f0f0f0;--toolbar-icon-color: var(--text-color);--toolbar-icon-hover-color: var(--text-color);--toolbar-icon-hover-background-color: #fffc;--toolbar-table-border-color: #c1d1e1;--toolbar-table-border-hover-color: var(--primary-color);--toolbar-table-background-color: #0000;--toolbar-table-background-hover-color: #d7e0ff}::ng-deep .dark{--toolbar-background-color: #2c2c2c;--toolbar-icon-color: var(--text-color);--toolbar-icon-hover-color: var(--text-color);--toolbar-icon-hover-background-color: #555c;--toolbar-table-border-color: #003468;--toolbar-table-border-hover-color: var(--primary-color);--toolbar-table-background-color: #0000;--toolbar-table-background-hover-color: #00f6}:host{display:flex;height:100%;align-items:center;gap:4px;color:var(--toolbar-icon-color);background-color:var(--toolbar-background-color);overflow:hidden}:host mat-icon{cursor:pointer;line-height:24px;padding:6px;width:36px;height:36px;transition:background-color .2s ease;position:relative}:host mat-icon:hover{background-color:var(--toolbar-icon-hover-background-color);color:var(--toolbar-icon-hover-color)}:host mat-icon:after{content:\"\";position:absolute;bottom:0;height:2px;width:0px;transition:width .2s ease;left:50%;transform:translate(-50%);background:#007acc}:host mat-icon.reflect:after{width:100%}.link-popup,.photo-popup,.table-popup{background-color:var(--background-color);padding:12px;border-radius:6px}.table-popup .table-row,.table-popup .table-col{display:flex;gap:2px}.table-popup .col-cell{width:16px;height:16px;border:1px solid var(--toolbar-table-border-color);background-color:var(--toolbar-table-background-color);cursor:pointer;transition:background-color .2s ease,border-color .2s ease}.table-popup .col-cell.selected{background-color:var(--toolbar-table-background-hover-color);border-color:var(--toolbar-table-border-hover-color)}.link-popup .simple-input,.photo-popup .simple-input{position:relative}.link-popup .simple-input input,.photo-popup .simple-input input{width:100%;padding:10px 0;font-size:16px;color:var(--text-color);margin-bottom:30px;border:none;border-bottom:1px solid var(--text-color);outline:none;background:transparent}.link-popup .simple-input label,.photo-popup .simple-input label{position:absolute;top:0;left:0;padding:10px 0;font-size:16px;color:var(--text-color);pointer-events:none;transition:.5s}.link-popup .simple-input input:focus~label,.link-popup .simple-input input:valid~label,.photo-popup .simple-input input:focus~label,.photo-popup .simple-input input:valid~label{top:-20px;left:0;color:var(--primary-color);font-size:12px}\n"], dependencies: [{ kind: "ngmodule", type: MatIconModule }, { kind: "component", type: i2.MatIcon, selector: "mat-icon", inputs: ["color", "inline", "svgIcon", "fontSet", "fontIcon"], exportAs: ["matIcon"] }, { kind: "ngmodule", type: MatTooltipModule }, { kind: "directive", type: i3.MatTooltip, selector: "[matTooltip]", inputs: ["matTooltipPosition", "matTooltipPositionAtOrigin", "matTooltipDisabled", "matTooltipShowDelay", "matTooltipHideDelay", "matTooltipTouchGestures", "matTooltip", "matTooltipClass"], exportAs: ["matTooltip"] }, { kind: "ngmodule", type: MatButtonModule }, { kind: "directive", type: TooltipDirective, selector: "[ngx-tooltip]", inputs: ["ngx-tooltip", "ngx-tooltip-config", "ngx-tooltip-context"] }, { kind: "directive", type: MenuDirective, selector: "[ngx-contextmenu],[ngx-menu]", inputs: ["ngx-menu-context", "ngx-contextmenu", "ngx-menu", "ngx-menu-config"] }] });
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "17.1.1", ngImport: i0, type: ToolbarComponent, decorators: [{
            type: Component,
            args: [{ selector: 'app-toolbar', imports: [
                        MatIconModule,
                        MatTooltipModule,
                        MatButtonModule,
                        TooltipDirective,
                        MenuDirective
                    ], standalone: true, template: "<!-- Header -->\n<mat-icon [ngx-menu]=\"textSizeMenu\" [class.reflect]=\"cursorIsInHeading\" matTooltip=\"Headings\">format_size</mat-icon>\n<!-- Color -->\n<mat-icon [ngx-tooltip]=\"colorPopup\" [ngx-tooltip-config]=\"{ triggers: ['click'], position: 'bottom' }\">\n    <svg xmlns=\"http://www.w3.org/2000/svg\" height=\"24px\" viewBox=\"0 0 24 24\" width=\"24px\" style=\"margin-top: -3px;\">\n        <path [style.fill]=\"currentTextColor\" d=\"M2 20L2 24L22 24L22 20L2 20z\" />\n        <path fill=\"var(--text-color)\" d=\"M10.75 3L5.49 17L7.91 17L9.18 13.42L14.83 13.42L16.09 17L18.51 17L13.25 3L10.75 3z M11.94 5.6L12.06 5.6L14.09 11.39L9.91 11.39L11.94 5.6z\" />\n    </svg>\n</mat-icon>\n\n<ng-template #colorPopup let-dialog=\"dialog\">\n    @for (ctx of [{color: '#000'}]; track ctx) {\n        <div\n            class=\"table-popup\"\n        >\n            <div\n                [style.color]=\"ctx.color\"\n                [style.background-color]=\"\"\n            >\n                {{ctx.color}}\n            </div>\n            <div class=\"grouped\" style=\"display: flex; gap: 2px; flex-direction: column;\">\n                @for (row of colorList; track row) {\n                    <div class=\"table-row\">\n                        @for (color of row; track color) {\n                            <div\n\n                                class=\"col-cell\"\n                                style=\"width: 24px; height: 24px\"\n                                [style.background-color]=\"color + 'ee'\"\n                                [style.border-color]=\"color + ''\"\n                                (click)=\"actions.colorizeText(currentTextColor = color); dialog.close()\"\n                                (pointerenter)=\"ctx.color = color\"\n                            >\n                            </div>\n                        }\n                    </div>\n                }\n            </div>\n        </div>\n    }\n</ng-template>\n\n<!-- Bold -->\n<mat-icon\n    (mousedown)=\"actions.boldText(); $event.preventDefault()\"\n    [class.reflect]=\"cursorIsInBold\"\n    matTooltip=\"Bold\"\n>\n    format_bold\n</mat-icon>\n<!-- Italic -->\n<mat-icon\n    (mousedown)=\"actions.italicizeText(); $event.preventDefault()\"\n    [class.reflect]=\"cursorIsInItalic\"\n    matTooltip=\"Italic\"\n>\n    format_italic\n</mat-icon>\n<!-- Strikethrough -->\n<mat-icon\n    (mousedown)=\"actions.strikethroughText(); $event.preventDefault()\"\n    [class.reflect]=\"cursorIsInStrikethrough\"\n    matTooltip=\"Strikethrough\"\n>\n    format_strikethrough\n</mat-icon>\n<!-- Underscore -->\n<!-- <mat-icon>format_underlined</mat-icon> -->\n\n<!-- Quote -->\n<mat-icon\n    (mousedown)=\"actions.blockQuoteText(); $event.preventDefault()\"\n    [class.reflect]=\"cursorIsInBlockquote\"\n    matTooltip=\"Blockquote\"\n>\n    format_quote\n</mat-icon>\n<!-- Link -->\n<mat-icon\n    matTooltip=\"Insert a Link\"\n    [class.reflect]=\"cursorIsInLink\"\n    (mousedown)=\"actions.openLinkDialog(); $event.preventDefault()\"\n>\n    link\n</mat-icon>\n\n<!-- Ordered list -->\n<mat-icon (mousedown)=\"actions.insertOrderedList(); $event.preventDefault()\" [class.reflect]=\"cursorIsInOrderedList\" matTooltip=\"Ordered List\">format_list_numbered</mat-icon>\n<!-- Unordered list -->\n<mat-icon (mousedown)=\"actions.insertList(); $event.preventDefault()\" [class.reflect]=\"cursorIsInList\" matTooltip=\"Unordered list\">format_list_bulleted</mat-icon>\n<!-- Checklist -->\n<mat-icon (mousedown)=\"actions.insertCheckList(); $event.preventDefault()\" [class.reflect]=\"cursorIsInChecklist\" matTooltip=\"Checklist\">rule</mat-icon>\n\n<!-- Table -->\n<mat-icon [ngx-tooltip]=\"tablePopup\" [ngx-tooltip-config]=\"{ triggers: ['click'], position: 'bottom' }\" [class.reflect]=\"cursorIsInTable\">table_chart</mat-icon>\n<ng-template #tablePopup let-data=\"data\" let-dialog=\"dialog\">\n    @for (ctx of [{cols: 0, rows: 0}]; track ctx) {\n        <div\n\n            class=\"table-popup\"\n        >\n            <div>{{ctx.cols}}x{{ctx.rows}}</div>\n            <div class=\"grouped\">\n                @for (row of [1,2,3,4,5,6]; track row) {\n                    <div class=\"table-row\">\n                        @for (col of [1,2,3,4,5,6]; track col) {\n                            <div\n\n                                class=\"col-cell\"\n                                [class.selected]=\"ctx.cols >= col && ctx.rows >= row\"\n                                (pointerenter)=\"ctx.cols = col; ctx.rows = row\"\n                                (click)=\"actions.insertTable(ctx.cols, ctx.rows); dialog.close()\"\n                            ></div>\n                        }\n                    </div>\n                }\n            </div>\n        </div>\n    }\n</ng-template>\n\n<!-- Image -->\n<mat-icon\n    matTooltip=\"Insert an image\"\n    (mousedown)=\"actions.openImageDialog(); $event.preventDefault()\"\n>\n    add_photo_alternate\n</mat-icon>\n\n\n<!-- Inline code -->\n<mat-icon\n    (mousedown)=\"actions.insertInlineCode(); $event.preventDefault()\"\n    [class.reflect]=\"cursorIsInInlineCode\"\n    matTooltip=\"Inline highlight\"\n>\n    code\n</mat-icon>\n<!-- Code Block -->\n<mat-icon\n    (mousedown)=\"actions.insertCodeBlock(); $event.preventDefault()\"\n    [class.reflect]=\"cursorIsInCode\"\n    matTooltip=\"Code block\"\n>\n    data_object\n</mat-icon>\n\n<!-- Mermaid Diagrams... -->\n@if (stackEditor.showMermaid) {\n    <mat-icon\n        [ngx-menu]=\"diagramMenu\"\n        [ngx-menu-config]=\"{\n            customClass: ['mermaid-menu']\n        }\"\n        matTooltip=\"Diagrams\"\n    >\n        account_tree\n    </mat-icon>\n}\n\n<span style=\"flex: 1\">\n    <!-- {{stackEditor.editorSvc?.focus}}\n     //\n    {{stackEditor.editorSvc?.clEditor?.selectionMgr?.selectionStart}}::\n    {{stackEditor.editorSvc?.clEditor?.selectionMgr?.selectionEnd}} -->\n</span>\n\n@if (stackEditor.showToc != 'off') {\n    <mat-icon\n\n        (mousedown)=\"toggleTOC(); $event.preventDefault()\"\n        [matTooltip]=\"stackEditor.showToc ? 'Close Table of Contents' : 'Open Table of Contents'\"\n    >\n        toc\n    </mat-icon>\n}\n\n@if (stackEditor.showPreview != 'off' && stackEditor.mode != 'viewonly') {\n    <mat-icon\n        (mousedown)=\"toggleEditor(); $event.preventDefault()\"\n        matTooltip=\"Close Editor\"\n    >\n        check\n    </mat-icon>\n}\n\n@if (stackEditor.showPreview != 'off') {\n    <mat-icon\n        (mousedown)=\"togglePreview(); $event.preventDefault()\"\n        [matTooltip]=\"stackEditor.showPreview ? 'Hide Preview': 'Open Preview'\"\n    >\n        visibility_off\n    </mat-icon>\n}\n", styles: ["::ng-deep .light{--toolbar-background-color: #f0f0f0;--toolbar-icon-color: var(--text-color);--toolbar-icon-hover-color: var(--text-color);--toolbar-icon-hover-background-color: #fffc;--toolbar-table-border-color: #c1d1e1;--toolbar-table-border-hover-color: var(--primary-color);--toolbar-table-background-color: #0000;--toolbar-table-background-hover-color: #d7e0ff}::ng-deep .dark{--toolbar-background-color: #2c2c2c;--toolbar-icon-color: var(--text-color);--toolbar-icon-hover-color: var(--text-color);--toolbar-icon-hover-background-color: #555c;--toolbar-table-border-color: #003468;--toolbar-table-border-hover-color: var(--primary-color);--toolbar-table-background-color: #0000;--toolbar-table-background-hover-color: #00f6}:host{display:flex;height:100%;align-items:center;gap:4px;color:var(--toolbar-icon-color);background-color:var(--toolbar-background-color);overflow:hidden}:host mat-icon{cursor:pointer;line-height:24px;padding:6px;width:36px;height:36px;transition:background-color .2s ease;position:relative}:host mat-icon:hover{background-color:var(--toolbar-icon-hover-background-color);color:var(--toolbar-icon-hover-color)}:host mat-icon:after{content:\"\";position:absolute;bottom:0;height:2px;width:0px;transition:width .2s ease;left:50%;transform:translate(-50%);background:#007acc}:host mat-icon.reflect:after{width:100%}.link-popup,.photo-popup,.table-popup{background-color:var(--background-color);padding:12px;border-radius:6px}.table-popup .table-row,.table-popup .table-col{display:flex;gap:2px}.table-popup .col-cell{width:16px;height:16px;border:1px solid var(--toolbar-table-border-color);background-color:var(--toolbar-table-background-color);cursor:pointer;transition:background-color .2s ease,border-color .2s ease}.table-popup .col-cell.selected{background-color:var(--toolbar-table-background-hover-color);border-color:var(--toolbar-table-border-hover-color)}.link-popup .simple-input,.photo-popup .simple-input{position:relative}.link-popup .simple-input input,.photo-popup .simple-input input{width:100%;padding:10px 0;font-size:16px;color:var(--text-color);margin-bottom:30px;border:none;border-bottom:1px solid var(--text-color);outline:none;background:transparent}.link-popup .simple-input label,.photo-popup .simple-input label{position:absolute;top:0;left:0;padding:10px 0;font-size:16px;color:var(--text-color);pointer-events:none;transition:.5s}.link-popup .simple-input input:focus~label,.link-popup .simple-input input:valid~label,.photo-popup .simple-input input:focus~label,.photo-popup .simple-input input:valid~label{top:-20px;left:0;color:var(--primary-color);font-size:12px}\n"] }]
        }], ctorParameters: () => [{ type: StackEditorComponent }, { type: i1.MatDialog }, { type: i2$1.ThemeService }], propDecorators: { colorList: [{
                type: Input
            }] } });

/**
 * This file controls the editor syntax highlighting.
 *
 * The order keys are assigned is _important_!
 * The parser checks if a regex matches based on the order of the key in the containing object.
 */
const scanSpan = (text) => {
    let spanDepth = 0;
    const rootNode = {
        depth: 0,
        children: [],
        outerStartIndex: 0,
        innerStartIndex: 0,
        innerEndIndex: text.length,
        outerEndIndex: text.length
    };
    let spanTree = rootNode;
    for (let i = 0; i < text.length; i++) {
        // Only do semantic checking when an opening angle bracket is encountered
        if (text.charCodeAt(i) != 0x3c)
            continue;
        const chunk = text.slice(i);
        // Encountered the start of a node
        if (chunk.match(/^<\s*?span\s+?style\s*?=/)) {
            spanDepth++;
            const tagMatch = chunk.match(/^<\s*?span([\s]*?style\s*?=\s*?(?<style>"[^"]+"|'[']+'))\s*?[^>]*?>/);
            const newItem = {
                children: [],
                parent: spanTree,
                depth: spanDepth,
                outerStartIndex: i,
                innerStartIndex: i + tagMatch[0]?.length,
                innerEndIndex: -1,
                outerEndIndex: -1,
                nodeAttributes: tagMatch.groups
            };
            spanTree.children.push(newItem);
            spanTree = newItem;
        }
        // Navigate up the tree by one level
        else if (chunk.match(/^<\s*?\/\s*?span\s*?>/)) {
            spanDepth--;
            // This scenario can happen when there are more
            // closing span tags than there should be
            if (!spanTree.parent || spanDepth < 0) {
                break; // give up -- bad input
            }
            spanTree.innerEndIndex = i;
            spanTree.outerEndIndex = i + chunk.match(/^<\s*?\/\s*?span\s*?>/)[0].length;
            spanTree = spanTree.parent;
        }
    }
    return rootNode;
};
var customMarkdown = (Prism) => {
    const spanStyled = {
        // Regex match does not work as we need to match the closing </span> tag.
        // pattern: /<span style="color: #(?:[A-Fa-f0-9]{3}|[A-Fa-f0-9]{4}|[A-Fa-f0-9]{6}|[A-Fa-f0-9]{8})">.*?<\/span>/g,
        pattern: {
            /**
             * Instead we implement the exec method that Prism ultimately calls.
             * Return `null` if there are no matches, or the first match in the
             * format of a regex exec result.
             */
            exec: (str) => {
                const root = scanSpan(str);
                const match = root.children[0];
                if (!match)
                    return null;
                const res = [match].map(m => str.slice(m.outerStartIndex, m.outerEndIndex));
                res['index'] = match?.outerStartIndex;
                res['input'] = str;
                res['groups'] = { foo: 'bar' };
                return res;
            }
        },
        lookbehind: true,
        greedy: false,
        inside: {
            "color-hex": {
                pattern: /#(?:[A-Fa-f0-9]{3}|[A-Fa-f0-9]{4}|[A-Fa-f0-9]{6}|[A-Fa-f0-9]{8})(?=[^A-Fa-f0-9])/,
                lookbehind: true,
                greedy: true
            },
            "content": {
                pattern: /(?:<span style="color: #(?:[A-Fa-f0-9]{3}|[A-Fa-f0-9]{4}|[A-Fa-f0-9]{6}|[A-Fa-f0-9]{8})">).+(?=<\/span>)/,
                lookbehind: true,
                greedy: true,
                inside: Prism.languages.markdown
            },
            ['special-attr']: Prism.languages.markdown['special-attr'],
            punctuation: Prism.languages.markdown.punctuation,
            tag: Prism.languages.markdown.tag
        }
    };
    Prism.languages.insertBefore('markdown', 'url', {
        'img-url': {
            // [![<label>](<imgurl>)](<linkurl>)
            pattern: /\[!\[[^\]\n]+?\]\((?:\([^\)\n]+?\)|[^\(\)\n]+?)+?\)\]\([^\)\n]+?\)/,
            // pattern: /\[!\[[^\]]+\]\(/,
            lookbehind: true,
            greedy: true,
            inside: {
                'src': {
                    pattern: /(\()(?:\([^\)\r\n]+\)|[^\(\)\r\n])+?(?=\)$)/,
                    lookbehind: true
                }
            },
            alias: "token"
        },
        'img': {
            pattern: /!\[[^\]\r\n]+\]\((?:\([^\)\r\n]+\)|[^\(\)\r\n])+?\)/,
            lookbehind: true,
            greedy: true,
            inside: {
                'string': {
                    pattern: /(!\[)[^\]\r\n]+(?=\])/,
                    lookbehind: true,
                },
                'img-src': {
                    pattern: /(\]\()[^\r\n]+(?=\))/s,
                    lookbehind: true,
                },
                'punctuation': {
                    pattern: /[\[\]\(\)!]/,
                    greedy: true,
                    lookbehind: true
                }
            }
        },
        'link': {
            pattern: /\[[^\]]+?\]\([^)]+?\)/g,
            lookbehind: true,
            greedy: true,
            inside: {
                'string': {
                    pattern: /(\[)[^\]\r\n]+(?=\])/,
                    lookbehind: true,
                },
                'src': {
                    pattern: /(\]\()[^('" \t]+(?=[)'" \t])/,
                    lookbehind: true,
                    inside: {
                        'punctuation': {
                            pattern: /[\[\]\(\)]/,
                            greedy: true,
                            lookbehind: true
                        }
                    }
                },
                'punctuation': {
                    pattern: /[\[\]\(\)]/,
                    greedy: true,
                    lookbehind: true
                }
            }
        }
    });
    Prism.languages.markdown['code-snippet'].inside = {
        punctuation: {
            pattern: /`/,
            greedy: true,
            lookbehind: true
        }
    };
    Prism.languages.insertBefore('markdown', 'hr', {
        "linebreak": {
            pattern: /^[ ]{0,3}---/,
            greedy: true,
            lookbehind: true
        },
    });
    Prism.languages.insertBefore('markdown', 'comment', {
        'comment': /<!--.*?-->/s,
        'span-styled': spanStyled
    });
    const basicRules = {
        color: Prism.languages.markdown.color,
        bold: Prism.languages.markdown.bold,
        italic: Prism.languages.markdown.italic,
        strike: Prism.languages.markdown.strike,
        'code-snippet': Prism.languages.markdown['code-snippet'],
        'span-styled': Prism.languages.markdown['span-styled'],
        'img-url': Prism.languages.markdown['img-url'],
        'img': Prism.languages.markdown['img'],
        'link': Prism.languages.markdown['link']
    };
    Prism.languages.insertBefore('markdown', 'title', {
        'h6': {
            pattern: /^[ ]{0,3}######[ \t]*?.+$/gm,
            lookbehind: true,
            greedy: true
        },
        'h5': {
            pattern: /^[ ]{0,3}#####[ \t]*?.+$/gm,
            lookbehind: true,
            greedy: true
        },
        'h4': {
            pattern: /^[ ]{0,3}####[ \t]*?.+$/gm,
            lookbehind: true,
            greedy: true
        },
        'h3': {
            pattern: /^[ ]{0,3}###[ \t]*?.+$/gm,
            lookbehind: true,
            greedy: true
        },
        'h2': {
            pattern: /^[ ]{0,3}##[ \t]*?.+$/gm,
            lookbehind: true,
            greedy: true
        },
        'h1': {
            pattern: /^[ ]{0,3}#[ \t]*?.+$/gm,
            lookbehind: true,
            greedy: true
        },
    });
    // Order of assignment is quite important
    Prism.languages.markdown['img-url'].inside.img = Prism.languages.markdown['img'];
    Prism.languages.markdown['img-url'].inside.punctuation = {
        pattern: /[\[\]\(\)!]/,
        greedy: true,
        lookbehind: true
    };
    Prism.languages.insertBefore('markdown', 'comment', {
        'image-spinner': {
            pattern: /```img-spinner```/g,
            lookbehind: true,
            greedy: true
        },
        'table-block': {
            // Regex match does not work as we need to match the closing </span> tag.
            // pattern: /<span style="color: #(?:[A-Fa-f0-9]{3}|[A-Fa-f0-9]{4}|[A-Fa-f0-9]{6}|[A-Fa-f0-9]{8})">.*?<\/span>/g,
            pattern: /\s{0,3}\|(?:[^|]+\|)+\n(?:\s{0,3}\|\s*(?::?-+:?\s*\|)+)(?:\s{0,3}\|(?:[^|]+\|)+\n)+/s,
            lookbehind: true,
            greedy: false,
            inside: {
                'header-row': {
                    pattern: /^\s{0,3}\|(?:[^|\n]+\|)+\n(?=\s{0,3}\|\s*(?:-+\s*\|)+)/s,
                    lookbehind: true,
                    greedy: false,
                    inside: {
                        'cell': {
                            pattern: /(\|)[^|]+(?=\|)/,
                            lookbehind: true,
                            greedy: false,
                            inside: basicRules
                        },
                        'pipe': /\|/
                    }
                },
                'table-row': {
                    pattern: /\n\s{0,3}\|(?:[^|\n]+\|)+(?=\n|$)/s,
                    lookbehind: true,
                    greedy: false,
                    inside: {
                        'cell': {
                            pattern: /(\|)[^|]+(?=\|)/,
                            lookbehind: true,
                            greedy: false,
                            inside: basicRules
                        },
                        'pipe': /\|/
                    }
                },
                'break-row': {
                    pattern: /\s{0,3}\|\s*(?::?-+:?\s*\|)+/,
                    inside: {
                        'pipe': /\|/,
                        'dash': /\-+/,
                        'colon': /:/,
                    }
                }
            }
        },
        'blockquote': {
            pattern: /(^|\n)\s*>.+?(?=\n\s*\n|$)/s,
            lookbehind: true,
            greedy: true,
            inside: {
                'punctuation': /(^|\n)\s*>/,
                'content': {
                    pattern: /.+/
                }
            }
        },
        'injection-fence': {
            pattern: /\`\`\`<injected>(?:.+?)<\/injected>\s*\`\`\`/s,
            greedy: true,
            lookbehind: true
        },
        'number-list': {
            pattern: /^\s+\d+\.\s+.+$/s,
            lookbehind: true,
            greedy: true,
            inside: {
                'punctuation': /(\n|^)\s+\d+\./,
                ...basicRules
            }
        },
        'check-list': {
            pattern: /^\s+[-*]\s+\[[Xx ]?\]\s+.+$/s,
            lookbehind: true,
            greedy: true,
            inside: {
                'punctuation': /(\n|^)\s+[-*]\s+\[[Xx ]?\]/,
                ...basicRules
            }
        },
        'bullet-list': {
            pattern: /^\s+[-*]\s+.+$/s,
            lookbehind: true,
            greedy: true,
            inside: {
                'punctuation': /(\n|^)\s+[-*]/,
                ...basicRules
            }
        }
    });
    Prism.languages.markdown['span-styled'].inside.content.inside.color = Prism.languages.markdown['span-styled'];
    Prism.languages.markdown['blockquote'].inside.content.inside = Prism.languages.markdown;
    // Add inside highlighting to the header levels
    for (let i = 1; i <= 6; i++) {
        Prism.languages.markdown['h' + i].inside = {
            ...basicRules,
            hash: /#+/
        };
    }
    // Bypass the Prism wrapper on `code`
    // This disables markdown language prism highlighting
    // which is faster for us when we use the Monaco editor
    Prism.languages.markdown['code_custom'] = Prism.languages.markdown.code;
    const codeBlockRule = Prism.languages.markdown['code_custom'].find(c => !!c.inside)?.inside['code-block'];
    if (codeBlockRule) {
        codeBlockRule.pattern =
            /^(```.*(?:\n|\r\n?))[\s\S]+?(?:\n|\r\n?)(?=^```\n?$)/m;
        codeBlockRule.alias = "prism"; // add 'prism' class to code-blocks
        codeBlockRule.inside = undefined;
    }
    Prism.languages.markdown.code = undefined;
    Prism.hooks.add('wrap', (env) => {
        if (env.type == 'span-styled') {
            const { style } = env.content
                .replace(/<[^>]+?>/g, '')
                .match(/style="(?<style>[^"]+?)"/)?.groups || {};
            if (style)
                env.attributes['style'] = style;
        }
        else if (env.type == 'code_custom') {
            // Questionable mermaid diagram detection
            if (env.content.match(/^<span class="token punctuation">```<\/span><span class="token code-language">mermaid<\/span>/)) {
                env.classes.push("mermaid");
            }
        }
    });
};

customMarkdown(Prism);
const keywordSupport = {
    "import": {
        pattern: /^\s*import\s+[^;]+?(?:;|$|\n)/ms,
        greedy: true,
        lookbehind: true,
        inside: {
            "keyword": {
                pattern: /^import/,
                greedy: true,
                lookbehind: true
            },
            "string": {
                pattern: /(?:'[^']+?'|"[^"]+?"|`[^`]+?`)/,
                greedy: true,
                lookbehind: true
            },
            "subject": {
                pattern: /\{[^}]+?\}/,
                greedy: true,
                lookbehind: true,
                inside: {
                    "keyword": {
                        pattern: /import|from/,
                        greedy: true,
                        lookbehind: true
                    },
                    "punctuation": {
                        pattern: /[{},]/,
                        greedy: true,
                        lookbehind: true
                    }
                }
            },
            "default-subject": {
                pattern: /import\s*?([^'"`]+)\s*?(?:from|['"`])/,
                greedy: true,
                lookbehind: true,
                inside: {
                    "keyword": {
                        pattern: /import|from/,
                        greedy: true,
                        lookbehind: true
                    },
                    "punctuation": {
                        pattern: /[{},]/,
                        greedy: true,
                        lookbehind: true
                    }
                }
            },
            "punctuation": {
                pattern: /[,;]/,
                greedy: true,
                lookbehind: true
            },
            "keyword keyword-from": {
                pattern: /from/,
                greedy: true,
                lookbehind: true
            }
        }
    }
};
Prism.languages.insertBefore('typescript', 'keyword', keywordSupport);
Prism.languages.insertBefore('javascript', 'keyword', keywordSupport);

/**
 * This provides the HTML rendering for markdown preview content.
 */
const htmlSectionMarker = '\uF111\uF222\uF333\uF444';
const diffMatchPatch = new DiffMatchPatch();
// Create aliases for syntax highlighting
const languageAliases = ({
    js: 'javascript',
    json: 'javascript',
    html: 'markup',
    svg: 'markup',
    xml: 'markup',
    py: 'python',
    rb: 'ruby',
    yml: 'yaml',
    ps1: 'powershell',
    psm1: 'powershell',
});
Object.entries(languageAliases).forEach(([alias, language]) => {
    Prism.languages[alias] = Prism.languages[language];
});
// Add programming language parsing capability to markdown fences
const insideFences = {};
Object.entries(Prism.languages).forEach(([name, language]) => {
    if (Prism.util.type(language) === 'Object') {
        insideFences[`language-${name}`] = {
            pattern: new RegExp(`(\`\`\`|~~~)${name}\\W[\\s\\S]*`),
            inside: {
                'cl cl-pre': /(```|~~~).*/,
                rest: language,
            },
        };
    }
});
// Disable spell checking in specific tokens
const noSpellcheckTokens = Object.create(null);
[
    'code',
    'pre',
    'pre gfm',
    'math block',
    'math inline',
    'math expr block',
    'math expr inline',
    'latex block',
]
    .forEach((key) => {
    noSpellcheckTokens[key] = true;
});
Prism.hooks.add('wrap', (env) => {
    if (noSpellcheckTokens[env.type]) {
        env.attributes.spellcheck = 'false';
    }
});
function createFlagMap(arr) {
    return arr.reduce((map, type) => ({ ...map, [type]: true }), {});
}
const startSectionBlockTypeMap = createFlagMap([
    'paragraph_open',
    'blockquote_open',
    'heading_open',
    'code',
    'fence',
    'table_open',
    'html_block',
    'bullet_list_open',
    'ordered_list_open',
    'hr',
    'dl_open',
]);
const listBlockTypeMap = createFlagMap([
    'bullet_list_open',
    'ordered_list_open',
]);
const blockquoteBlockTypeMap = createFlagMap([
    'blockquote_open',
]);
const tableBlockTypeMap = createFlagMap([
    'table_open'
]);
const deflistBlockTypeMap = createFlagMap([
    'dl_open',
]);
function hashArray(arr, valueHash, valueArray) {
    const hash = [];
    arr.forEach((str) => {
        let strHash = valueHash[str];
        if (strHash === undefined) {
            strHash = valueArray.length;
            valueArray.push(str);
            valueHash[str] = strHash;
        }
        hash.push(strHash);
    });
    return String.fromCharCode.apply(null, hash);
}
var markdownConversionSvc = {
    /**
     * Creates a converter and init it with extensions.
     * @returns {Object} A converter.
     */
    createConverter() {
        // Let the listeners add the rules
        const converter = new MarkdownIt('zero');
        converter.core.ruler.enable([], true);
        converter.block.ruler.enable([], true);
        converter.inline.ruler.enable([], true);
        Object.keys(startSectionBlockTypeMap).forEach((type) => {
            const rule = converter.renderer.rules[type] || converter.renderer.renderToken;
            converter.renderer.rules[type] = (tokens, idx, opts, env, self) => {
                if (tokens[idx]['sectionDelimiter']) {
                    // Add section delimiter
                    return htmlSectionMarker + rule.call(converter.renderer, tokens, idx, opts, env, self);
                }
                return rule.call(converter.renderer, tokens, idx, opts, env, self);
            };
        });
        return converter;
    },
    /**
     * Parse markdown sections by passing the 2 first block rules of the markdown-it converter.
     * @param {Object} converter The markdown-it converter.
     * @param {String} text The text to be parsed.
     * @returns {Object} A parsing context to be passed to `convert`.
     */
    parseSections(converter, text) {
        const markdownState = new converter.core.State(text, converter, {});
        const markdownCoreRules = converter.core.ruler.getRules('');
        markdownCoreRules[0](markdownState); // Pass the normalize rule
        markdownCoreRules[1](markdownState); // Pass the block rule
        const lines = text.split('\n');
        if (!lines[lines.length - 1]) {
            // In cledit, last char is always '\n'.
            // Remove it as one will be added by addSection
            lines.pop();
        }
        const parsingCtx = {
            text,
            sections: [],
            converter,
            markdownState,
            markdownCoreRules,
        };
        let data = 'main';
        let i = 0;
        function addSection(maxLine) {
            const section = {
                text: '',
                data,
            };
            // Limit the execution of this lookup.
            for (; i < maxLine && i < 1000000; i += 1) {
                section.text += `${lines[i]}\n`;
            }
            parsingCtx.sections.push(section);
        }
        markdownState.tokens.forEach((token, index) => {
            // index === 0 means there are empty lines at the begining of the file
            if (token.level === 0 && startSectionBlockTypeMap[token.type]) {
                if (index > 0) {
                    token['sectionDelimiter'] = true;
                    addSection(token.map[0]);
                }
                if (listBlockTypeMap[token.type])
                    data = 'list';
                else if (blockquoteBlockTypeMap[token.type])
                    data = 'blockquote';
                else if (tableBlockTypeMap[token.type])
                    data = 'table';
                else if (deflistBlockTypeMap[token.type])
                    data = 'deflist';
                else
                    data = 'main';
            }
        });
        addSection(lines.length);
        return parsingCtx;
    },
    /**
     * Convert markdown sections previously parsed with `parseSections`.
     * @param {Object} parsingCtx The parsing context returned by `parseSections`.
     * @param {Object} previousConversionCtx The conversion context returned by a previous call
     * to `convert`, in order to calculate the `htmlSectionDiff` of the returned conversion context.
     * @returns {Object} A conversion context.
     */
    convert(parsingCtx, previousConversionCtx) {
        // This function can be called twice without editor modification
        // so prevent from converting it again.
        if (!parsingCtx.markdownState.isConverted) {
            // Skip 2 first rules previously passed in parseSections
            parsingCtx.markdownCoreRules.slice(2).forEach(rule => rule(parsingCtx.markdownState));
            parsingCtx.markdownState.isConverted = true;
        }
        const { tokens } = parsingCtx.markdownState;
        const html = parsingCtx.converter.renderer.render(tokens, parsingCtx.converter.options, parsingCtx.markdownState.env);
        const htmlSectionList = html.split(htmlSectionMarker);
        if (htmlSectionList[0] === '') {
            htmlSectionList.shift();
        }
        const valueHash = Object.create(null);
        const valueArray = [];
        const newSectionHash = hashArray(htmlSectionList, valueHash, valueArray);
        let htmlSectionDiff;
        if (previousConversionCtx) {
            const oldSectionHash = hashArray(previousConversionCtx.htmlSectionList, valueHash, valueArray);
            htmlSectionDiff = diffMatchPatch.diff_main(oldSectionHash, newSectionHash, false);
        }
        else {
            htmlSectionDiff = [
                [1, newSectionHash],
            ];
        }
        return {
            text: parsingCtx.text,
            sectionList: parsingCtx.sectionList,
            htmlSectionList,
            htmlSectionDiff,
        };
    },
    /**
     * Helper to highlight arbitrary markdown
     * @param {Object} markdown The markdown content to highlight.
     * @param {Object} converter An optional converter.
     * @param {Object} grammars Optional grammars.
     * @returns {Object} The highlighted markdown in HTML format.
     */
    highlight(markdown, converter = this.defaultConverter, grammars = this.defaultPrismGrammars) {
        const parsingCtx = this.parseSections(converter, markdown);
        return parsingCtx.sections
            .map(section => Prism.highlight(section.text, grammars[section.data])).join('');
    },
};

class SectionDimension {
    topOffset;
    height;
    constructor(topOffset, height) {
        this.topOffset = topOffset;
        this.height = height;
    }
}
var sectionUtils = {
    measureSectionDimensions(editorSvc) {
        const firstSectionDesc = editorSvc.previewCtx.sectionDescList?.[0];
        if (!firstSectionDesc)
            return;
        firstSectionDesc.editorDimension = new SectionDimension(0, firstSectionDesc.editorElt.offsetHeight);
        firstSectionDesc.previewDimension = new SectionDimension(0, firstSectionDesc.previewElt.offsetHeight);
        firstSectionDesc.tocDimension = new SectionDimension(0, firstSectionDesc.tocElt.offsetHeight);
        for (let i = 1; i < editorSvc.previewCtx.sectionDescList.length - 1; i++) {
            const nextSectionDesc = editorSvc.previewCtx.sectionDescList[i];
            nextSectionDesc.editorDimension = new SectionDimension(nextSectionDesc.editorElt.offsetTop, nextSectionDesc.editorElt.offsetHeight);
            nextSectionDesc.previewDimension = new SectionDimension(nextSectionDesc.previewElt.offsetTop, nextSectionDesc.previewElt.offsetHeight);
            nextSectionDesc.tocDimension = new SectionDimension(nextSectionDesc.tocElt.offsetTop, nextSectionDesc.tocElt.offsetHeight);
        }
    }
};

const isGecko = 'MozAppearance' in document.documentElement.style;
const isWebkit = 'WebkitAppearance' in document.documentElement.style;
const isMsie = 'msTransform' in document.documentElement.style;
const isMac = navigator.userAgent.indexOf('Mac OS X') !== -1;
const defer = (() => {
    const queue = new Array(1000);
    let queueLength = 0;
    function flush() {
        for (let i = 0; i < queueLength; i += 1) {
            try {
                queue[i]();
            }
            catch (e) {
                console.error(e.message, e.stack);
            }
            queue[i] = undefined;
        }
        queueLength = 0;
    }
    let iterations = 0;
    const observer = new window.MutationObserver(flush);
    const node = document.createTextNode('');
    observer.observe(node, { characterData: true });
    return (fn) => {
        queue[queueLength] = fn;
        queueLength += 1;
        if (queueLength === 1) {
            iterations = (iterations + 1) % 2;
            node.data = iterations;
        }
    };
})();
const debounce = (func, wait = 0) => {
    let timeoutId;
    let isExpected;
    return (wait
        ? () => {
            clearTimeout(timeoutId);
            timeoutId = setTimeout(func, wait);
        }
        : () => {
            if (!isExpected) {
                isExpected = true;
                defer(() => {
                    isExpected = false;
                    func();
                });
            }
        });
};
const findContainer = (elt, offset) => {
    let containerOffset = 0;
    let container;
    let child = elt;
    let limit = 0;
    do {
        container = child;
        child = child.firstChild;
        if (child) {
            let limit = 0;
            do {
                const len = child.textContent.length;
                if (containerOffset <= offset && containerOffset + len > offset) {
                    break;
                }
                containerOffset += len;
                child = child.nextSibling;
            } while (child && limit++ < 10000);
        }
    } while (child && child.firstChild && child.nodeType !== 3 && limit++ < 10000);
    if (child) {
        return {
            container: child,
            offsetInContainer: offset - containerOffset,
        };
    }
    limit = 0;
    while (container.lastChild && limit++ < 10000) {
        container = container.lastChild;
    }
    return {
        container,
        offsetInContainer: container.nodeType === 3 ? container.textContent.length : 0,
    };
};
class EventEmittingClass {
    listenerMap = Object.create(null);
    $trigger(eventType, ...args) {
        const listeners = this.listenerMap[eventType];
        if (listeners) {
            listeners.forEach((listener) => {
                // try {
                listener.apply(this, args);
                // } catch (e) {
                //     // eslint-disable-next-line no-console
                //     console.error(e.message, e.stack);
                // }
            });
        }
    }
    on(eventType, listener) {
        let listeners = this.listenerMap[eventType];
        if (!listeners) {
            listeners = [];
            this.listenerMap[eventType] = listeners;
        }
        listeners.push(listener);
    }
    off(eventType, listener) {
        const listeners = this.listenerMap[eventType];
        if (listeners) {
            const index = listeners.indexOf(listener);
            if (index !== -1) {
                listeners.splice(index, 1);
            }
        }
    }
}

class State {
    undoManager;
    patches;
    constructor(undoManager) {
        this.undoManager = undoManager;
    }
    // TODO: This is wired poorly, rewrite.
    addToUndoStack() {
        this.undoManager.undoStack.push(this);
        this.patches = this.undoManager.previousPatches;
        this.undoManager.previousPatches = [];
    }
    addToRedoStack() {
        this.undoManager.redoStack.push(this);
        this.patches = this.undoManager.previousPatches;
        this.undoManager.previousPatches = [];
    }
}
// Why is this a separate class?
class StateMgr {
    undoManager;
    currentTime;
    lastTime;
    lastMode;
    currentMode;
    constructor(undoManager) {
        this.undoManager = undoManager;
    }
    isBufferState() {
        this.currentTime = Date.now();
        return this.currentMode !== 'single' &&
            this.currentMode === this.lastMode &&
            this.currentTime - this.lastTime < this.undoManager.options.bufferStateUntilIdle;
    }
    setDefaultMode(mode) {
        this.currentMode = this.currentMode || mode;
    }
    resetMode() {
        this.currentMode = undefined;
        this.lastMode = undefined;
    }
    saveMode() {
        this.lastMode = this.currentMode;
        this.currentMode = undefined;
        this.lastTime = this.currentTime;
    }
}
class UndoManager extends EventEmittingClass {
    editor;
    diffMatchPatch = new DiffMatchPatch();
    selectionMgr;
    undoStack = [];
    redoStack = [];
    currentState;
    previousPatches = [];
    currentPatches = [];
    stateMgr = new StateMgr(this);
    get canUndo() { return this.undoStack.length != 0; }
    ;
    get canRedo() { return this.redoStack.length != 0; }
    ;
    options = {
        undoStackMaxSize: 200,
        bufferStateUntilIdle: 1000,
    };
    constructor(editor, options) {
        super();
        this.editor = editor;
        this.options = { ...options || {} };
        this.selectionMgr = editor.selectionMgr;
        this.currentState = this.currentState || new State(this);
    }
    setCurrentMode(mode) {
        this.stateMgr.currentMode = mode;
    }
    ;
    setDefaultMode = this.stateMgr.setDefaultMode.bind(this);
    addDiffs(oldContent, newContent, diffs) {
        const patches = this.diffMatchPatch.patch_make(oldContent, diffs);
        patches.forEach(patch => this.currentPatches.push(patch));
    }
    ;
    saveCurrentPatches() {
        // Move currentPatches into previousPatches
        Array.prototype.push.apply(this.previousPatches, this.currentPatches);
        this.currentPatches = [];
    }
    saveState = debounce(() => {
        this.redoStack.length = 0;
        if (!this.stateMgr.isBufferState()) {
            this.currentState.addToUndoStack();
            // Limit the size of the stack
            while (this.undoStack.length > this.options.undoStackMaxSize) {
                this.undoStack.shift();
            }
        }
        this.saveCurrentPatches();
        this.currentState = new State(this);
        this.stateMgr.saveMode();
        this.$trigger('undoStateChange');
    });
    restoreState(patchesParam, isForward = false) {
        let patches = patchesParam;
        // Update editor
        const content = this.editor.getContent();
        if (!isForward) {
            patches = this.diffMatchPatch.patch_deepCopy(patches).reverse();
            patches.forEach((patch) => {
                patch.diffs.forEach((diff) => {
                    // TODO: This might be a bug.
                    // @ts-ignore
                    diff[0] = -diff[0];
                });
            });
        }
        const newContent = this.diffMatchPatch.patch_apply(patches, content)[0];
        const newContentText = newContent.text || newContent;
        const range = this.editor.setContent(newContentText, true);
        const selection = newContent.selection || {
            start: range.end,
            end: range.end,
        };
        this.selectionMgr.setSelectionStartEnd(selection.start, selection.end);
        this.selectionMgr.updateCursorCoordinates(true);
        this.stateMgr.resetMode();
        this.$trigger('undoStateChange');
        this.editor.adjustCursorPosition();
    }
    undo() {
        const state = this.undoStack.pop();
        if (!state)
            return;
        this.saveCurrentPatches();
        this.currentState.addToRedoStack();
        this.restoreState(this.currentState.patches);
        this.previousPatches = state.patches;
        this.currentState = state;
    }
    redo() {
        const state = this.redoStack.pop();
        if (!state)
            return;
        this.currentState.addToUndoStack();
        this.restoreState(state.patches, true);
        this.previousPatches = state.patches;
        this.currentState = state;
    }
}

class Watcher {
    editor;
    listener;
    isWatching = false;
    contentObserver;
    constructor(editor, listener) {
        this.editor = editor;
        this.listener = listener;
    }
    startWatching = () => {
        this.stopWatching();
        this.isWatching = true;
        this.contentObserver = new MutationObserver(this.listener);
        this.contentObserver.observe(this.editor.$contentElt, {
            childList: true,
            subtree: true,
            characterData: true,
        });
    };
    stopWatching = () => {
        if (this.contentObserver) {
            this.contentObserver.disconnect();
            this.contentObserver = undefined;
        }
        this.isWatching = false;
    };
    noWatch = (cb) => {
        if (this.isWatching === true) {
            this.stopWatching();
            cb();
            this.startWatching();
        }
        else {
            cb();
        }
    };
}

class Section {
    text;
    data;
    elt;
    // AFAIK nothing ever sets this
    forceHighlighting = false;
    monaco;
    get ulid() {
        return this.elt.getAttribute("ulid");
    }
    constructor(text) {
        this.text = text.text === undefined ? text : text.text;
        this.data = text.data;
    }
    setElement(elt) {
        this.elt = elt;
        elt['section'] = this;
    }
}
class Highlighter extends EventEmittingClass {
    editor;
    isComposing = 0;
    trailingNode;
    get contentElt() { return this.editor.$contentElt; }
    ;
    cancelComposition;
    sectionList = [];
    insertBeforeSection;
    trailingNodeTag = 'div';
    lfHtml = `<span class="lf">\n</span>`;
    constructor(editor) {
        super();
        this.editor = editor;
    }
    fixContent(modifiedSections, removedSections, noContentFix) {
        modifiedSections.forEach((section) => {
            section.forceHighlighting = true;
            if (!noContentFix) {
                // if (isWebkit) {
                //     [...section.elt.getElementsByClassName('hd-lf')]
                //         .forEach(lfElt => lfElt.parentNode.removeChild(lfElt));
                //     [...section.elt.getElementsByTagName('br')]
                //         .forEach(brElt => brElt.parentNode.replaceChild(document.createTextNode('\n'), brElt));
                // }
                if (section.elt.textContent.slice(-1) !== '\n') {
                    section.elt.appendChild(document.createTextNode('\n'));
                }
            }
        });
    }
    addTrailingNode() {
        this.trailingNode = document.createElement(this.trailingNodeTag);
        this.contentElt.appendChild(this.trailingNode);
    }
    ;
    calcLineNumbers = debounce(() => {
        [...(this.editor.$contentElt?.querySelectorAll(".lf") || [])].forEach((e, i) => {
            e.setAttribute("data-linenumber", i + 1);
        });
    }, 25);
    sectionHighlighter(section) {
        const highlighted = Prism.highlight(section.text, Prism.languages.markdown, 'markdown');
        return `<div class="prism language-markdown">${highlighted}</div>`;
    }
    parseSections(content, isInit = false) {
        if (this.isComposing && !this.cancelComposition)
            return this.sectionList;
        this.cancelComposition = false;
        const { editorSvc } = this.editor.ngEditor;
        editorSvc.parsingCtx = markdownConversionSvc.parseSections(editorSvc.converter, content);
        const newSectionList = editorSvc.parsingCtx.sections
            .map(sectionText => new Section(sectionText));
        let modifiedSections = [];
        let sectionsToRemove = [];
        this.insertBeforeSection = undefined;
        if (isInit) {
            // Render everything if isInit
            sectionsToRemove = this.sectionList;
            this.sectionList = newSectionList;
            modifiedSections = newSectionList;
        }
        else {
            // Find modified section starting from top
            let leftIndex = this.sectionList.length;
            this.sectionList.find((section, index) => {
                const newSection = newSectionList[index];
                if (index >= newSectionList.length ||
                    section.forceHighlighting ||
                    // Check text modification
                    section.text !== newSection.text ||
                    // Check that section has not been detached or moved
                    section.elt.parentNode !== this.contentElt ||
                    // Check also the content since nodes can be injected in sections via copy/paste
                    section.elt.textContent !== newSection.text) {
                    leftIndex = index;
                    return true;
                }
                return false;
            });
            // Find modified section starting from bottom
            let rightIndex = -this.sectionList.length;
            this.sectionList.slice().reverse().find((section, index) => {
                const newSection = newSectionList[newSectionList.length - index - 1];
                if (index >= newSectionList.length ||
                    section.forceHighlighting ||
                    // Check modified
                    section.text !== newSection.text ||
                    // Check that section has not been detached or moved
                    section.elt.parentNode !== this.contentElt ||
                    // Check also the content since nodes can be injected in sections via copy/paste
                    section.elt.textContent !== newSection.text) {
                    rightIndex = -index;
                    return true;
                }
                return false;
            });
            if (leftIndex - rightIndex > this.sectionList.length) {
                // Prevent overlap
                rightIndex = leftIndex - this.sectionList.length;
            }
            const leftSections = this.sectionList.slice(0, leftIndex);
            modifiedSections = newSectionList.slice(leftIndex, newSectionList.length + rightIndex);
            const rightSections = this.sectionList.slice(this.sectionList.length + rightIndex, this.sectionList.length);
            this.insertBeforeSection = rightSections?.[0];
            sectionsToRemove = this.sectionList.slice(leftIndex, this.sectionList.length + rightIndex);
            this.sectionList = leftSections.concat(modifiedSections).concat(rightSections);
        }
        // TODO: All of the rendering logic for the editor should be unified.
        const highlight = (section) => {
            const initialMarkup = this.sectionHighlighter(section);
            const html = initialMarkup.replace(/\n/g, this.lfHtml);
            const sectionElt = document.createElement('div');
            sectionElt.className = 'cledit-section';
            sectionElt.innerHTML = html;
            section.setElement(sectionElt);
            this.$trigger('sectionHighlighted', section);
        };
        const newSectionEltList = document.createDocumentFragment();
        modifiedSections.forEach((section) => {
            section.forceHighlighting = false;
            highlight(section);
            newSectionEltList.appendChild(section.elt);
        });
        this.editor.watcher.noWatch(() => {
            try {
                if (isInit) {
                    this.contentElt.innerHTML = '';
                    this.contentElt.appendChild(newSectionEltList);
                    this.addTrailingNode();
                    return;
                }
                // Remove outdated sections
                sectionsToRemove.forEach((section) => {
                    // section may be already removed
                    if (section.elt.parentNode === this.contentElt) {
                        this.contentElt.removeChild(section.elt);
                    }
                    // To detect sections that come back with built-in undo
                    section.elt['section'] = undefined;
                });
                if (this.insertBeforeSection !== undefined) {
                    this.contentElt.insertBefore(newSectionEltList, this.insertBeforeSection.elt);
                }
                else {
                    this.contentElt.appendChild(newSectionEltList);
                }
                // Remove unauthorized nodes (text nodes outside of sections or
                // duplicated sections via copy/paste)
                let childNode = this.contentElt.firstChild;
                while (childNode) {
                    const nextNode = childNode.nextSibling;
                    if (!childNode['section']) {
                        this.contentElt.removeChild(childNode);
                    }
                    childNode = nextNode;
                }
                this.addTrailingNode();
                this.$trigger('highlighted');
                if (this.editor.selectionMgr.hasFocus) {
                    this.editor.selectionMgr.restoreSelection();
                    this.editor.selectionMgr.updateCursorCoordinates();
                }
                if (this.editor.ngEditor.showLineNumbers)
                    this.calcLineNumbers();
            }
            catch (err) {
                // Handle the error to prevent the watcher from failing.
                console.error(err);
            }
        });
        return this.sectionList;
    }
    ;
}

class SelectionMgr extends EventEmittingClass {
    editor;
    get contentElt() { return this.editor.$contentElt; }
    ;
    get scrollElt() { return this.editor.$contentElt.parentElement; }
    ;
    get hasFocus() { return this.contentElt === document.activeElement; }
    ;
    lastSelectionStart = 0;
    lastSelectionEnd = 0;
    selectionStart = 0;
    selectionEnd = 0;
    selectionIsReverse = false;
    selectionStartNode;
    selectionStartOffset;
    selectionEndNode;
    selectionEndOffset;
    cursorCoordinates = { top: 0, height: 0, left: 0 };
    adjustScroll;
    oldSelectionRange;
    constructor(editor) {
        super();
        this.editor = editor;
    }
    createRange(start, end) {
        let startContainer = typeof start === 'number'
            ? this.editor.getNodeAndOffsetAtIndex(start < 0 ? 0 : start)
            : start;
        startContainer = startContainer ?? this.editor.getNodeAndOffsetAtIndex(0);
        let endContainer = startContainer;
        if (start !== end) {
            endContainer = typeof end === 'number'
                ? this.editor.getNodeAndOffsetAtIndex(end < 0 ? 0 : end)
                : end;
        }
        const range = document.createRange();
        range.setStart(startContainer.node, startContainer.offset);
        range.setEnd(endContainer?.node ?? startContainer.node, endContainer?.offset ?? startContainer.offset);
        return range;
    }
    ;
    updateCursorCoordinates(adjustScrollParam = false) {
        this.adjustScroll = this.adjustScroll || adjustScrollParam;
        const startNodeOffset = this.editor.getNodeAndOffsetAtIndex(this.selectionStart);
        const endNodeOffset = this.selectionStart == this.selectionEnd
            ? startNodeOffset
            : this.editor.getNodeAndOffsetAtIndex(this.selectionEnd);
        const coordinates = this.getCoordinates(endNodeOffset);
        // Keep track of both the start and end offset nodes
        this.selectionStartNode = startNodeOffset.node;
        this.selectionStartOffset = startNodeOffset.offset;
        this.selectionEndNode = endNodeOffset.node;
        this.selectionEndOffset = endNodeOffset.offset;
        // This is the cardinal coordinates of the selection top-left point.
        // ? why is this even here
        if (this.cursorCoordinates.top !== coordinates.top ||
            this.cursorCoordinates.height !== coordinates.height ||
            this.cursorCoordinates.left !== coordinates.left) {
            this.cursorCoordinates = coordinates;
            this.$trigger('cursorCoordinatesChanged', coordinates);
        }
        // Scroll the coords into view
        if (this.adjustScroll) {
            // let scrollEltHeight = this.scrollElt.clientHeight;
            // if (typeof this.adjustScroll === 'number') {
            //     scrollEltHeight -= this.adjustScroll;
            // }
            // const adjustment = (scrollEltHeight / 2) * .15;
            // let cursorTop = this.cursorCoordinates.top + (this.cursorCoordinates.height / 2);
            // // Adjust cursorTop with contentElt position relative to scrollElt
            // cursorTop += (this.contentElt.getBoundingClientRect().top - this.scrollElt.getBoundingClientRect().top)
            //     + this.scrollElt.scrollTop;
            // const minScrollTop = cursorTop - adjustment;
            // const maxScrollTop = (cursorTop + adjustment) - scrollEltHeight;
            // if (this.scrollElt.scrollTop > minScrollTop) {
            //     this.scrollElt.scrollTop = minScrollTop;
            // }
            // else if (this.scrollElt.scrollTop < maxScrollTop) {
            //     this.scrollElt.scrollTop = maxScrollTop;
            // }
            const { top, height } = this.cursorCoordinates;
            const caretTop = top + height;
            // console.log(caretTop, this.scrollElt)
            if (caretTop > (this.scrollElt.scrollTop + this.scrollElt.clientHeight) - 24) {
                this.scrollElt.scrollTo({
                    top: Math.max(0, (caretTop - this.scrollElt.clientHeight) + 24)
                });
            }
        }
        this.adjustScroll = false;
    }
    ;
    /**
     * Check if the selection has been changed,
     * if so, emit a `selectionChanged` event.
     */
    checkSelection(selectionRange) {
        if (!this.oldSelectionRange ||
            this.oldSelectionRange.startContainer !== selectionRange.startContainer ||
            this.oldSelectionRange.startOffset !== selectionRange.startOffset ||
            this.oldSelectionRange.endContainer !== selectionRange.endContainer ||
            this.oldSelectionRange.endOffset !== selectionRange.endOffset) {
            this.oldSelectionRange = selectionRange;
            this.$trigger('selectionChanged', this.selectionStart, this.selectionEnd, selectionRange);
            return true;
        }
        return false;
    }
    ;
    restoreSelection() {
        const min = Math.min(this.selectionStart, this.selectionEnd);
        const max = Math.max(this.selectionStart, this.selectionEnd);
        const selectionRange = this.createRange(min, max);
        if (!document.contains(selectionRange.commonAncestorContainer)) {
            return null;
        }
        const selection = window.getSelection();
        selection.removeAllRanges();
        const isBackward = this.selectionStart > this.selectionEnd;
        if (isBackward && selection.extend) {
            const beginRange = selectionRange.cloneRange();
            beginRange.collapse(false);
            selection.addRange(beginRange);
            selection.extend(selectionRange.startContainer, selectionRange.startOffset);
        }
        else {
            selection.addRange(selectionRange);
        }
        this.checkSelection(selectionRange);
        return selectionRange;
    }
    ;
    setSelection(start = this.selectionStart, end = this.selectionEnd) {
        this.selectionStart = start < 0 ? 0 : start;
        this.selectionEnd = end < 0 ? 0 : end;
        this.lastSelectionStart = this.selectionStart;
        this.lastSelectionEnd = this.selectionEnd;
    }
    setSelectionStartEnd(start, end, restoreSelection = true) {
        this.setSelection(start, end);
        if (restoreSelection && this.hasFocus) {
            return this.restoreSelection();
        }
        return null;
    }
    saveSelectionState(selection = window.getSelection()) {
        if (!this.hasFocus) {
            return null;
        }
        let { selectionStart, selectionEnd } = this;
        if (selection.rangeCount <= 0) {
            return null;
        }
        const selectionRange = selection.getRangeAt(0);
        let node = selectionRange.startContainer;
        if (!(this.contentElt.compareDocumentPosition(node) & window.Node.DOCUMENT_POSITION_CONTAINED_BY)
            && this.contentElt !== node) {
            return null;
        }
        let offset = selectionRange.startOffset;
        if (node.firstChild && offset > 0) {
            node = node.childNodes[offset - 1];
            offset = node.textContent.length;
        }
        let container = node;
        while (node !== this.contentElt) {
            node = node.previousSibling;
            while (node) {
                offset += node.textContent?.length ?? 0;
                node = node.previousSibling;
            }
            node = container.parentNode;
            container = node;
        }
        let selectionText = selectionRange.toString();
        // Fix end of line when only br is selected
        const brElt = selectionRange.endContainer.firstChild;
        if (brElt && brElt['tagName'] === 'BR' && selectionRange.endOffset === 1) {
            selectionText += '\n';
        }
        const isBackwardsSelection = (() => {
            if (selection.anchorNode === selection.focusNode) {
                return selection.anchorOffset > selection.focusOffset;
            }
            const anchorTree = [];
            const focusTree = [];
            let _focusNode = selection.focusNode;
            let _anchorNode = selection.anchorNode;
            // Build two node paths
            do {
                focusTree.unshift(_focusNode?.parentElement);
                _focusNode = _focusNode?.parentElement;
            } while (_focusNode && _focusNode != this.editor.$contentElt);
            do {
                anchorTree.unshift(_anchorNode?.parentElement);
                _anchorNode = _anchorNode?.parentElement;
            } while (_anchorNode && _anchorNode != this.editor.$contentElt);
            // Walk down tree A until it diverges from tree B
            // Max 128 depth.
            for (let i = 0; i < 128; i++) {
                // The trees have diverged!
                if (!focusTree[i]) {
                    const commonElement = focusTree[i - 1];
                    const nodes = [...commonElement.childNodes];
                    return nodes.indexOf(selection.focusNode) < nodes.indexOf(anchorTree[i]);
                }
                // The trees have diverged!
                if (!anchorTree[i]) {
                    const commonElement = anchorTree[i - 1];
                    const nodes = [...commonElement.childNodes];
                    return nodes.indexOf(focusTree[i]) < nodes.indexOf(selection.anchorNode);
                }
                // The trees have diverged!
                if (anchorTree[i] != focusTree[i]) {
                    const commonElement = anchorTree[i - 1];
                    const nodes = [...commonElement.childNodes];
                    return nodes.indexOf(focusTree[i]) < nodes.indexOf(anchorTree[i]);
                }
            }
            return false;
        })();
        if (isBackwardsSelection) {
            selectionStart = offset + selectionText.length;
            selectionEnd = offset;
        }
        else {
            selectionStart = offset;
            selectionEnd = offset + selectionText.length;
        }
        if (selectionStart >= this.editor.value.length) {
            // If cursor is after the trailingNode
            selectionEnd = this.editor.value.length;
            selectionStart = selectionEnd;
            return this.setSelectionStartEnd(selectionStart, selectionEnd);
        }
        else {
            this.setSelection(selectionStart, selectionEnd);
            const result = this.checkSelection(selectionRange);
            // selectionRange doesn't change when selection is at the start of a section
            return result || this.lastSelectionStart !== this.selectionStart;
        }
    }
    getSelectedText() {
        const min = Math.min(this.selectionStart, this.selectionEnd);
        const max = Math.max(this.selectionStart, this.selectionEnd);
        return this.editor.getContent().substring(min, max);
    }
    ;
    getCoordinates(offset) {
        if (!offset)
            return {
                top: 0,
                height: 0,
                left: 0
            };
        const container = offset.node;
        const offsetInContainer = offset.offset;
        let containerElt = container;
        if (!containerElt.hasChildNodes() && container.parentNode) {
            containerElt = container.parentNode;
        }
        let isInvisible = false;
        while (!containerElt.offsetHeight) {
            isInvisible = true;
            if (containerElt.previousSibling) {
                containerElt = containerElt.previousSibling;
            }
            else {
                containerElt = containerElt.parentNode;
                if (!containerElt) {
                    return {
                        top: 0,
                        height: 0,
                        left: 0,
                    };
                }
            }
        }
        let rect;
        let left = 'left';
        if (isInvisible || container.textContent === '\n') {
            rect = containerElt.getBoundingClientRect();
        }
        else {
            const inputOffset = offset['editorOffset'];
            const selectedChar = this.editor.value[inputOffset];
            let startOffset = {
                node: container,
                offset: offsetInContainer,
            };
            let endOffset = {
                node: container,
                offset: offsetInContainer,
            };
            if (inputOffset > 0 && (selectedChar === undefined || selectedChar === '\n')) {
                left = 'right';
                if (startOffset.offset === 0) {
                    // Need to calculate offset-1
                    // TODO: This may be a bug
                    startOffset = inputOffset - 1;
                }
                else {
                    startOffset.offset -= 1;
                }
            }
            else if (endOffset.offset === container.textContent.length) {
                // When cursor starts at 0 ...?
                // Need to calculate offset+1
                endOffset = inputOffset + 1;
            }
            else {
                endOffset.offset += 1;
            }
            const range = this.createRange(startOffset, endOffset);
            rect = range.getBoundingClientRect();
        }
        const contentRect = this.contentElt.getBoundingClientRect();
        return {
            top: Math.round((rect.top - contentRect.top) + this.contentElt.scrollTop),
            height: Math.round(rect.height),
            left: Math.round((rect[left] - contentRect.left) + this.contentElt.scrollLeft),
        };
    }
    ;
    getClosestWordOffset(offset) {
        let offsetStart = 0;
        let offsetEnd = 0;
        let nextOffset = 0;
        this.editor.getContent().split(/\s/).find((word) => {
            if (word) {
                offsetStart = nextOffset;
                offsetEnd = nextOffset + word.length;
                if (offsetEnd > offset) {
                    return true;
                }
            }
            nextOffset += word.length + 1;
            return false;
        });
        return {
            start: offsetStart,
            end: offsetEnd,
        };
    }
    ;
}

function Keystroke(handler, priority) {
    this.handler = handler;
    this.priority = priority || 100;
}
let clearNewline;
const charTypes = Object.create(null);
// Word separators, as in Sublime Text
'./\\()"\'-:,.;<>~!@#$%^&*|+=[]{}`~?'.split('').forEach((wordSeparator) => {
    charTypes[wordSeparator] = 'wordSeparator';
});
charTypes[' '] = 'space';
charTypes['\t'] = 'space';
charTypes['\n'] = 'newLine';
function getNextWordOffset(text, offset, isBackward = false) {
    let previousType;
    let result = offset;
    while ((isBackward && result > 0) || (!isBackward && result < text.length)) {
        const currentType = charTypes[isBackward ? text[result - 1] : text[result]] || 'word';
        if (previousType && currentType !== previousType) {
            if (previousType === 'word' || currentType === 'space' || previousType === 'newLine' || currentType === 'newLine') {
                break;
            }
        }
        previousType = currentType;
        if (isBackward) {
            result -= 1;
        }
        else {
            result += 1;
        }
    }
    return result;
}
const defaultKeystrokes = [
    // CTRL+Z, CTRL+Y
    new Keystroke((evt, state, editor) => {
        if ((!evt.ctrlKey && !evt.metaKey) || evt.altKey) {
            return false;
        }
        let action;
        if (evt.key.toLowerCase() == "y")
            action = 'redo';
        if (evt.key.toLowerCase() == "z")
            action = evt.shiftKey ? 'redo' : 'undo';
        if (action) {
            evt.preventDefault();
            setTimeout(() => editor.undoMgr[action](), 10);
            return true;
        }
        return false;
    }),
    // Bracket matching  () {} []
    new Keystroke((evt, state, editor) => {
        if ((!evt.ctrlKey && !evt.metaKey) || evt.altKey) {
            return false;
        }
        const isInPrism = editor.selectionMgr;
        // let action;
        let boundChars;
        switch (evt.key) {
            case ("("):
                boundChars = ["(", ")"];
                break;
            case ("{"):
                boundChars = ["{", "}"];
                break;
            case ("["):
                boundChars = ["[", "]"];
                break;
            case ("<"):
                boundChars = ["<", ">"];
                break;
        }
        if (boundChars) {
        }
        //     action = 'redo';
        // if (evt.key.toLowerCase() == "y")
        //     action = evt.shiftKey ? 'redo' : 'undo';
        // if (action) {
        //     evt.preventDefault();
        //     setTimeout(() => editor.undoMgr[action](), 10);
        //     return true;
        // }
        return false;
    }),
    // TAB
    new Keystroke((evt, state, editor) => {
        if (evt.key !== 'Tab' || evt.metaKey || evt.ctrlKey) {
            return false;
        }
        const strSplice = (str, i, remove, add = '') => str.slice(0, i) + add + str.slice(i + (+remove || 0));
        evt.preventDefault();
        const isInverse = evt.shiftKey;
        const lf = state.before.lastIndexOf('\n') + 1;
        const indentText = ''.padStart(editor.ngEditor.tabSize, editor.ngEditor.tabChar);
        if (isInverse) {
            if (/\s/.test(state.before.charAt(lf))) {
                state.before = strSplice(state.before, lf, editor.ngEditor.tabSize);
            }
            state.selection = state.selection.replace(new RegExp(`^([ ]{${editor.ngEditor.tabSize}}|\t)`, 'gm'), '');
        }
        else if (state.selection) {
            // const beforeLen = state.selection.length;
            state.before = strSplice(state.before, lf, 0, indentText);
            state.selection = state.selection.replace(/\n(?=[\s\S])/g, '\n' + indentText);
            // const newChars = state.selection.length - beforeLen;
            // editor.getNodeAtIndex()
            // const sel = window.getSelection();
            // sel.extend(sel.anchorNode, sel.anchorOffset + newChars);
        }
        else {
            state.before += indentText;
        }
        return true;
    }),
    // ENTER
    new Keystroke((evt, state, editor) => {
        if (evt.key !== 'Enter') {
            clearNewline = false;
            return false;
        }
        const lf = state.before.lastIndexOf('\n') + 1;
        if (clearNewline) {
            state.before = state.before.substring(0, lf);
            state.selection = '';
            clearNewline = false;
            return true;
        }
        clearNewline = false;
        const previousLine = state.before.slice(lf);
        const currentLine = state.after.slice(0, state.after.indexOf('\n'));
        const indent = previousLine.match(/^\s*/)[0];
        const listRx = /^\s*[-*]\s*\S?/;
        const orderedListRx = /^\s*\d+\.\s*\S?/;
        const checkListRx = /^\s*-\s*\[[ xX]?\]\s*\S?/;
        const isList = listRx.test(previousLine) && !listRx.test(currentLine);
        const isOrderedList = orderedListRx.test(previousLine) && !orderedListRx.test(currentLine);
        const isCheckList = checkListRx.test(previousLine) && !checkListRx.test(currentLine);
        editor.undoMgr.setCurrentMode('single');
        let prefix = '';
        if (isList)
            prefix = '- ';
        if (isOrderedList) {
            const prevNumber = previousLine.match(/^\s*(?<num>\d+)\.\s*\S/)?.groups?.['num'];
            let num = parseInt(prevNumber);
            if (Number.isNaN(num))
                num = 1;
            else
                num++;
            prefix = num + '. ';
        }
        if (isCheckList)
            prefix = '- [ ] ';
        if (indent.length > 0 || isList || isOrderedList || isCheckList)
            clearNewline = true;
        state.before += `\n${indent}${prefix}`;
        state.selection = '';
        evt.preventDefault();
        setTimeout(() => {
            editor.selectionMgr.updateCursorCoordinates(true);
        }, 1);
        return true;
    }),
    // BACKSPACE, DELETE
    // new Keystroke((evt, state, editor) => {
    //     if (evt.key !== 'Backspace' && evt.key !== 'Delete') {
    //         return false;
    //     }
    //     editor.undoMgr.setCurrentMode('delete');
    //     if (!state.selection) {
    //         const isJump = (isMac && evt.altKey) || (!isMac && evt.ctrlKey);
    //         if (isJump) {
    //             // Custom kill word behavior
    //             const text = state.before + state.after;
    //             const offset = getNextWordOffset(text, state.before.length, evt.key === 'Backspace');
    //             if (evt.key === 'Backspace') {
    //                 state.before = state.before.slice(0, offset);
    //             }
    //             else {
    //                 state.after = state.after.slice(offset - text.length);
    //             }
    //             return true;
    //         }
    //         else if (evt.key == 'Backspace' && state.before.slice(-1) === '\n') {
    //             // Special treatment for end of lines
    //             state.before = state.before.slice(0, -1);
    //             evt.preventDefault();
    //             return true;
    //         }
    //         else if (evt.key == 'Delete' && state.after.slice(0, 1) === '\n') {
    //             state.after = state.after.slice(1);
    //             evt.preventDefault();
    //             return true;
    //         }
    //         return false;
    //     }
    //     else {
    //         state.selection = '';
    //         return true;
    //     }
    // }),
    // LEFT_ARROW, RIGHT_ARROW
    new Keystroke((evt, state, editor) => {
        if (evt.code !== 'ArrowLeft' && evt.code !== 'ArrowRight') {
            return false;
        }
        const isJump = (isMac && evt.altKey) || (!isMac && evt.ctrlKey);
        if (!isJump) {
            return false;
        }
        // Custom jump behavior
        const textContent = editor.getContent();
        const offset = getNextWordOffset(textContent, editor.selectionMgr.selectionEnd, evt.code == "ArrowLeft");
        if (evt.shiftKey) {
            // rebuild the state completely
            const min = Math.min(editor.selectionMgr.selectionStart, offset);
            const max = Math.max(editor.selectionMgr.selectionStart, offset);
            state.before = textContent.slice(0, min);
            state.after = textContent.slice(max);
            state.selection = textContent.slice(min, max);
            state.isBackwardSelection = editor.selectionMgr.selectionStart > offset;
        }
        else {
            state.before = textContent.slice(0, offset);
            state.after = textContent.slice(offset);
            state.selection = '';
        }
        evt.preventDefault();
        return true;
    }),
];

class VanillaMirror extends EventEmittingClass {
    ngEditor;
    editorElt;
    lastTextContent;
    ignoreUndo = false;
    noContentFix = false;
    skipSaveSelection;
    $markers = {};
    $keystrokes = [];
    value = '';
    get $contentElt() { return this.editorElt; }
    ;
    watcher = new Watcher(this, this.onMutationObserved.bind(this));
    highlighter = new Highlighter(this);
    diffMatchPatch = new DiffMatchPatch();
    selectionMgr = new SelectionMgr(this);
    undoMgr = new UndoManager(this);
    mouseDownSelectionCoords = {
        selectionStart: 0,
        selectionEnd: 0
    };
    turndownService = new TurndownService({
        "headingStyle": "atx",
        "hr": "----------",
        "bulletListMarker": "-",
        "codeBlockStyle": "fenced",
        "fence": "```",
        "emDelimiter": "_",
        "strongDelimiter": "**",
        "linkStyle": "inlined",
        "linkReferenceStyle": "full"
    });
    constructor(ngEditor, editorElt, lastTextContent = " ") {
        super();
        this.ngEditor = ngEditor;
        this.editorElt = editorElt;
        this.lastTextContent = lastTextContent;
        if (typeof this.lastTextContent != 'string')
            this.lastTextContent = '';
        if (!this.lastTextContent.endsWith("\n"))
            this.lastTextContent += "\n\n";
        window['editor'] = this;
        this.toggleEditable(true);
        // Disable escaping
        this.turndownService.escape = str => str;
        // This handles 'Enter' and keyboard arrow events.
        editorElt.addEventListener('keydown', this.keydownHandler((evt) => this.onKeyDown(evt)));
        editorElt.addEventListener('paste', (evt) => this.onPaste(evt));
        // Mouseup can happen outside the editor element
        editorElt.addEventListener('mouseup', this.onMouseUp);
        editorElt.addEventListener('mousedown', this.onMouseDown);
        // Resize provokes cursor coordinate changes
        window.addEventListener('resize', this.onWindowResize);
        document.addEventListener("selectionchange", this.onSelectionChange);
        this.addKeystroke(defaultKeystrokes);
        this.watcher.startWatching();
    }
    destroy() {
        this.watcher.stopWatching();
        window.removeEventListener('resize', this.onWindowResize);
        document.removeEventListener("selectionchange", this.onSelectionChange);
    }
    toggleEditable(isEditable) {
        this.editorElt.contentEditable = isEditable == null ? !this.editorElt.contentEditable : isEditable;
        this.editorElt.spellcheck = false;
    }
    onMouseUp = ((evt) => {
        const { selectionStart, selectionEnd } = this.mouseDownSelectionCoords;
        // If selection is unchanged, deselect the text.
        if (selectionStart == this.selectionMgr.lastSelectionStart &&
            selectionEnd == this.selectionMgr.lastSelectionEnd) {
            this.rebaseSelectionByPixel(evt.clientX, evt.clientY);
        }
    }).bind(this);
    onMouseDown = ((evt) => {
        const { selectionStart, selectionEnd } = this.selectionMgr;
        this.mouseDownSelectionCoords = {
            selectionStart, selectionEnd
        };
    }).bind(this);
    onWindowResize = (() => {
        this.selectionMgr.updateCursorCoordinates();
    }).bind(this);
    // TODO: may need to debounce this -- has been seen to cause CPU locking
    onSelectionChange = (() => {
        // If the editor isn't focused, don't perform updates
        if (!document.activeElement?.classList?.contains("editor-inner"))
            return;
        this.selectionMgr.saveSelectionState();
        this.selectionMgr.updateCursorCoordinates(true);
        const { selectionStart, selectionStartNode, selectionStartOffset, selectionEnd, selectionEndNode, selectionEndOffset } = this.selectionMgr;
        // console.log({
        //     selectionStartNode,
        //     selectionStartOffset,
        //     selectionEndNode,
        //     selectionEndOffset
        // })
        // Only check if we're in single selection mode.
        if (selectionStart != selectionEnd)
            return;
        // Skip if the editor isn't focused
        if (!this.editorElt.matches(':focus'))
            return;
        this.ngEditor.editorSvc.focus = "editorContentEditable";
        // Build a tree of nodes up until the section container
        let node = selectionEndNode.parentElement;
        const nodeTree = [node];
        while (node.parentElement && !node.classList.contains("cledit-section"))
            nodeTree.push(node = node.parentElement);
        const sectionElement = node;
        const ulid = sectionElement.getAttribute("ulid");
        const codeBlock = sectionElement.querySelector(".code-block");
        if (codeBlock && nodeTree.includes(codeBlock)) {
            const editor = codeBlock['_editor'];
            const text = this.value;
            const sectionIndex = this.ngEditor.editorSvc.sectionList
                .findIndex(s => s.ulid == ulid);
            const section = this.ngEditor.editorSvc.sectionList[sectionIndex];
            const beforeSections = this.ngEditor.editorSvc.sectionList.slice(0, Math.max(0, sectionIndex));
            const preLines = text.slice(0, selectionEnd).match(/[\r\n]/g)?.length || 0;
            const preSectionLines = beforeSections.map(s => s.text).join('').match(/[\r\n]/g)?.length || 0;
            const sectionLines = section.text.match(/[\r\n]/g)?.length || 0;
            let lineNo = preLines - preSectionLines;
            // Gets the line number of the current selection
            // Round to the beginning/end
            if (lineNo > sectionLines / 2)
                lineNo = sectionLines;
            else if (lineNo < sectionLines / 2)
                lineNo = 0;
            // console.log({
            //     selectionEndOffset,
            //     lineNo,
            //     preLines,
            //     preSectionLines
            // })
            this.ngEditor.editorSvc.focus = "monaco";
            editor.setSelection({
                startLineNumber: lineNo,
                startColumn: 0,
                endLineNumber: lineNo,
                endColumn: 0
            }, "stackedit");
            editor.focus();
        }
    }).bind(this);
    init() {
        const sectionList = this.highlighter.parseSections(this.lastTextContent, true);
        this.$trigger('contentChanged', this.lastTextContent, [0, this.lastTextContent], sectionList);
        this.setSelection(0, 0);
        this.selectionMgr.saveSelectionState();
    }
    getNodeAndOffsetAtIndex(index) {
        let i = 0;
        const recursivelyFindNode = (el) => {
            // This doesn't have children, so we can simply read the textContent
            if (el.nodeType != 1 || el.childNodes.length == 0) {
                const cl = el.textContent.length;
                if (index == 0 || i + cl > index) {
                    const offset = Math.max(index - i, 0);
                    return {
                        node: el,
                        offset,
                        editorOffset: index
                    };
                }
                else {
                    i += cl;
                }
                return null;
            }
            // This has childNodes, and no content override
            else {
                // @ts-ignore
                const children = [...el.childNodes];
                for (let i = 0; i < children.length; i++) {
                    const res = recursivelyFindNode(children[i]);
                    if (res)
                        return res;
                }
            }
            return null;
        };
        return recursivelyFindNode(this.editorElt);
    }
    getContent() {
        const recursivelyCollectChildrenText = (el) => {
            // This doesn't have children, so we can simply read the textContent
            if (el.nodeType != 1 || el.childNodes.length == 0) {
                return el.textContent;
            }
            // This has childNodes, and no content override
            else {
                const sections = [...el.childNodes].map(c => recursivelyCollectChildrenText(c));
                return sections.join('');
            }
        };
        const text = recursivelyCollectChildrenText(this.editorElt);
        // Markdown-it sanitization (Mac/DOS to Unix)
        // let textContent = contentElt.textContent.replace(/\r[\n\u0085]?|[\u2424\u2028\u0085]/g, '\n');
        let textContent = text.replace(/\r[\n\u0085]?|[\u2424\u2028\u0085]/g, '\n');
        // Append a newline at the end if one isn't present.
        if (textContent.slice(-1) !== '\n') {
            textContent += '\n';
        }
        return this.value = textContent;
    }
    onMutationObserved(mutations) {
        this.watcher.noWatch(() => {
            const removedSections = [];
            const modifiedSections = [];
            const markModifiedSection = (node) => {
                let currentNode = node;
                while (currentNode && currentNode !== this.editorElt) {
                    if (currentNode.section) {
                        const array = currentNode.parentNode ? modifiedSections : removedSections;
                        if (array.indexOf(currentNode.section) === -1) {
                            array.push(currentNode.section);
                        }
                        return;
                    }
                    currentNode = currentNode.parentNode;
                }
            };
            mutations.forEach((mutation) => {
                markModifiedSection(mutation.target);
                mutation.addedNodes.forEach(markModifiedSection);
                mutation.removedNodes.forEach(markModifiedSection);
            });
            this.highlighter.fixContent(modifiedSections, removedSections, this.noContentFix);
            this.noContentFix = false;
        });
        if (!this.skipSaveSelection) {
            this.selectionMgr.saveSelectionState();
        }
        this.skipSaveSelection = false;
        const newTextContent = this.getContent();
        const diffs = this.diffMatchPatch.diff_main(this.lastTextContent, newTextContent);
        Object.entries(this.$markers).forEach(([key, marker]) => {
            marker.adjustOffset(diffs);
        });
        const sectionList = this.highlighter.parseSections(newTextContent);
        this.$trigger('contentChanged', newTextContent, diffs, sectionList);
        if (!this.ignoreUndo) {
            this.undoMgr.addDiffs(this.lastTextContent, newTextContent, diffs);
            this.undoMgr.setDefaultMode('typing');
            this.undoMgr.saveState();
        }
        this.ignoreUndo = false;
        this.lastTextContent = newTextContent;
        this.triggerSpellCheck();
    }
    // TODO: use better spell checker ?
    triggerSpellCheck = debounce(() => {
        // Hack for Chrome to trigger the spell checker
        const selection = window.getSelection();
        if (this.selectionMgr.hasFocus
            && !this.highlighter.isComposing
            && this.selectionMgr.selectionStart === this.selectionMgr.selectionEnd
            && selection.modify) {
            if (this.selectionMgr.selectionStart) {
                selection.modify('move', 'backward', 'character');
                selection.modify('move', 'forward', 'character');
            }
            else {
                selection.modify('move', 'forward', 'character');
                selection.modify('move', 'backward', 'character');
            }
        }
    }, 10);
    // Detect editor changes
    setSelection(start, end) {
        this.selectionMgr.setSelectionStartEnd(start, end == null ? start : end);
        this.selectionMgr.updateCursorCoordinates();
    }
    scrollCursorIntoView() {
        this.selectionMgr.updateCursorCoordinates(true);
    }
    keydownHandler(handler) {
        return (evt) => {
            if (!['Control', 'Alt', 'Shift', 'Cmd'].includes(evt.key)) {
                handler(evt);
            }
        };
    }
    adjustCursorPosition(force) {
        this.selectionMgr.saveSelectionState();
    }
    replaceContent(selectionStart, selectionEnd, replacement) {
        const min = Math.min(selectionStart, selectionEnd);
        const max = Math.max(selectionStart, selectionEnd);
        const range = this.selectionMgr.createRange(min, max);
        const rangeText = `${range}`;
        // Range can contain a br element, which is not taken into account in rangeText
        if (rangeText.length === max - min && rangeText === replacement) {
            return null;
        }
        range.deleteContents();
        range.insertNode(document.createTextNode(replacement));
        return range;
    }
    addKeystroke(keystroke) {
        const keystrokes = Array.isArray(keystroke) ? keystroke : [keystroke];
        this.$keystrokes = this.$keystrokes
            .concat(keystrokes)
            .sort((keystroke1, keystroke2) => keystroke1.priority - keystroke2.priority);
    }
    setContent(value, noUndo, maxStartOffsetOpt) {
        if (value === null || value === undefined)
            value = '\n';
        this.value = value;
        const textContent = this.getContent();
        const maxStartOffset = maxStartOffsetOpt != null && maxStartOffsetOpt < textContent.length
            ? maxStartOffsetOpt
            : textContent.length - 1;
        const startOffset = Math.min(this.diffMatchPatch.diff_commonPrefix(textContent, value), maxStartOffset);
        const endOffset = Math.min(this.diffMatchPatch.diff_commonSuffix(textContent, value), textContent.length - startOffset, value.length - startOffset);
        const replacement = value.substring(startOffset, value.length - endOffset);
        const range = this.replaceContent(startOffset, textContent.length - endOffset, replacement);
        if (range) {
            this.ignoreUndo = noUndo;
            this.noContentFix = true;
        }
        return {
            start: startOffset,
            end: value.length - endOffset,
            range,
        };
    }
    insertTextAtCarat(text) {
        const { selectionStart, selectionEnd } = this.selectionMgr;
        const content = this.getContent();
        const before = content.slice(0, selectionStart);
        const selection = content.slice(selectionStart, selectionEnd);
        const after = content.slice(selectionEnd);
        const patchedText = before + text + after;
        this.setContent(patchedText);
        const afterPoint = before.length + text.length;
        this.selectionMgr.setSelectionStartEnd(afterPoint, afterPoint);
    }
    replace(selectionStart, selectionEnd, replacement) {
        this.undoMgr.setDefaultMode('single');
        this.replaceContent(selectionStart, selectionEnd, replacement);
        const startOffset = Math.min(selectionStart, selectionEnd);
        const endOffset = startOffset + replacement.length;
        this.selectionMgr.setSelectionStartEnd(endOffset, endOffset);
        this.selectionMgr.updateCursorCoordinates(true);
    }
    replaceAll(search, replacement, startOffset = 0) {
        if (typeof search == 'string')
            search = new RegExp(search, 'gm');
        this.undoMgr.setDefaultMode('single');
        const text = this.getContent();
        const subtext = text.slice(startOffset);
        const value = subtext.replace(search, replacement);
        if (value !== subtext) {
            const offset = this.setContent(text.slice(0, startOffset) + value);
            this.selectionMgr.setSelectionStartEnd(offset.end, offset.end);
            this.selectionMgr.updateCursorCoordinates(true);
        }
    }
    focus() {
        this.selectionMgr.restoreSelection();
        this.editorElt.focus();
    }
    addMarker(marker) {
        this.$markers[marker.id] = marker;
    }
    removeMarker(marker) {
        delete this.$markers[marker.id];
    }
    onKeyDown(evt) {
        this.selectionMgr.saveSelectionState();
        // Perform keystroke
        let contentChanging = false;
        const textContent = this.getContent();
        let min = Math.min(this.selectionMgr.selectionStart, this.selectionMgr.selectionEnd);
        let max = Math.max(this.selectionMgr.selectionStart, this.selectionMgr.selectionEnd);
        const state = {
            before: textContent.slice(0, min),
            after: textContent.slice(max),
            selection: textContent.slice(min, max),
            isBackwardSelection: this.selectionMgr.selectionStart > this.selectionMgr.selectionEnd,
        };
        this.$keystrokes.find((keystroke) => {
            if (!keystroke.handler(evt, state, this)) {
                return false;
            }
            const newContent = state.before + state.selection + state.after;
            if (newContent !== this.getContent()) {
                this.setContent(newContent, false, min);
                contentChanging = true;
                this.skipSaveSelection = true;
                this.highlighter.cancelComposition = true;
            }
            min = state.before.length;
            max = min + state.selection.length;
            this.selectionMgr.setSelectionStartEnd(state.isBackwardSelection ? max : min, state.isBackwardSelection ? min : max, !contentChanging);
            return true;
        });
        /// WTF does this shit even do?!
        if (!contentChanging) {
            // Optimization to avoid saving selection
            // this.adjustCursorPosition();
        }
    }
    onCompositionStart() {
        this.highlighter.isComposing += 1;
    }
    onCompositionEnd() {
        setTimeout(() => {
            if (this.highlighter.isComposing) {
                this.highlighter.isComposing -= 1;
                if (!this.highlighter.isComposing) {
                    this.onMutationObserved([]);
                }
            }
        }, 1);
    }
    onPaste(evt) {
        this.undoMgr.setCurrentMode('single');
        evt.preventDefault();
        const clipboardData = evt.clipboardData;
        let data = clipboardData.getData('text/plain');
        const files = [...clipboardData.files];
        // TODO: should this be interleaved with text paste?
        if (files.length > 0 && this.ngEditor.allowImageUpload) {
            this.insertTextAtCarat("```img-spinner```");
            this.ngEditor.onImageUpload.next({ data: files, ...this.selectionMgr, stackEditor: this.ngEditor });
            return;
        }
        // TODO: Re-enable after paste dialog is added.
        if (false && this.turndownService) {
            try {
                const html = clipboardData.getData('text/html');
                if (html) {
                    // TODO: Add a popup dialog to choose using whatever we
                    // end up with, after using Turndown, or raw HTML propagation
                    // Inject a custom fence around pasted content
                    // data = `\n\`\`\`<injected>\n${html}\n</injected>\n\`\`\`\n`;
                    // const sanitizedHtml = htmlSanitizer.sanitizeHtml(html)
                    //     .replace(/&#160;/g, ' '); // Replace non-breaking spaces with classic spaces
                    // if (sanitizedHtml) {
                    //     data = this.turndownService.turndown(sanitizedHtml);
                    //     // Handle double newlines added on HTML paste.
                    //     // TODO: Check if this needs to be placed elsewhere.
                    //     data = data
                    //         // Fix duplicate newlines that are inserted
                    //         .replace(/\n\n/g, '\n')
                    //         // Fix duplicate spaces that get inserted
                    //         .replace(/(?<!^)  /gm, ' ');
                    // }
                }
            }
            catch (e) {
                // Ignore
            }
        }
        if (!data) {
            return;
        }
        this.replace(this.selectionMgr.selectionStart, this.selectionMgr.selectionEnd, data);
        this.adjustCursorPosition();
    }
    onCopy(evt) {
        if (evt.clipboardData) {
            evt.clipboardData.setData('text/plain', this.selectionMgr.getSelectedText());
            evt.preventDefault();
        }
    }
    onCut(evt) {
        if (evt.clipboardData) {
            evt.clipboardData.setData('text/plain', this.selectionMgr.getSelectedText());
            evt.preventDefault();
            this.replace(this.selectionMgr.selectionStart, this.selectionMgr.selectionEnd, '');
        }
        else {
            this.undoMgr.setCurrentMode('single');
        }
        this.adjustCursorPosition();
    }
    /**
     * Return the line at a given character index
     * This is _not_ the line number, but the index of the char in the whole string.
     *
     * This will default in the case of an empty modal.
     */
    getLine(charIndex, text = this.getContent()) {
        const lines = text.split(/[\r\n]/g);
        const number = text.slice(0, charIndex).match(/[\r\n]/g)?.length || 0;
        const line = lines[number] || '';
        const lineStart = lines.slice(0, number).map(l => l.length).reduce((a, b) => a + b, 0) + (number);
        const lineEnd = lineStart + line.length;
        return {
            lineStart,
            lineEnd,
            line
        };
    }
    /**
     * Wrap the current selection in text
     */
    wrapSelection(before = '', after = '', indent, insertNewline = false) {
        const { selectionStart, selectionEnd } = this.selectionMgr;
        const text = this.getContent();
        const { lineStart, lineEnd, line } = (selectionStart == selectionEnd)
            ? this.getLine(selectionStart, text)
            : {};
        const startIndex = lineStart ?? Math.min(selectionStart, selectionEnd);
        const endIndex = lineEnd ?? Math.max(selectionStart, selectionEnd);
        const selectionText = line ?? text.slice(startIndex, endIndex);
        let preString = text.slice(0, startIndex);
        let postString = text.slice(endIndex);
        // Check if this is a duplicate invocation that should remove the decoration effect
        const isRemoval = preString.endsWith(before) && postString.startsWith(after);
        if (isRemoval) {
            // Strip out the previously added before and after text
            preString = preString.slice(0, preString.length - before.length);
            postString = postString.slice(after.length);
            // Move the selection to what was before adding the text
            this.selectionMgr.selectionStart -= before.length;
            this.selectionMgr.selectionEnd -= (before.length + after.length);
            // Clear before and after for re-use of the update logic.
            before = '';
            after = '';
            indent = null;
            insertNewline = false;
        }
        else {
            this.selectionMgr.selectionStart += before.length;
            this.selectionMgr.selectionEnd += before.length;
        }
        let updatedSelection = selectionText;
        if (indent) {
            // Indent all lines in the selection
            updatedSelection = selectionText
                .split('\n')
                .map(l => ''.padStart(indent, ' ') + l)
                .join('\n');
        }
        if (insertNewline && before) {
            // Insert a newline at the start if we're in the middle of a selection.
            if (!preString.endsWith('\n'))
                before = "\n" + before;
        }
        const patchedText = preString +
            before +
            updatedSelection +
            after +
            postString;
        this.setContent(patchedText);
        this.selectionMgr.setSelectionStartEnd(this.selectionMgr.selectionStart, this.selectionMgr.selectionEnd);
    }
    /**
     * Replace the current selection with the given text.
     */
    replaceSelection(text) {
        const { selectionStart, selectionEnd } = this.selectionMgr;
        let content = this.getContent();
        const startIndex = Math.min(selectionStart, selectionEnd);
        const endIndex = Math.max(selectionStart, selectionEnd);
        const preString = content.slice(0, startIndex);
        const postString = content.slice(endIndex);
        const patchedText = preString +
            text +
            postString;
        this.setContent(patchedText);
    }
    rebaseSelectionByPixel(x, y) {
        let selection = window.getSelection();
        // TODO: There may be a better way to collapse the selection.
        let range;
        // All webkit browsers support this properly. (incl. Safari)
        if (typeof document.caretRangeFromPoint == "function") {
            range = document.caretRangeFromPoint(x, y);
            if (range)
                selection.collapse(range.startContainer, range.startOffset);
        }
        // Ugly stepchild named Firefox needs this mess.
        else if (typeof document['caretPositionFromPoint'] == "function") {
            range = document['caretPositionFromPoint'](x, y);
            if (range)
                selection.collapse(range.offsetNode, range.offset);
        }
        // Fallthrough if we can't get the nearest range to the pointer click.
        // Occurs in rare edge cases, and would occur if browsers ever actually deprecate
        // caretRangeFromPoint
        else if (!range) {
            selection.collapse(selection.focusNode, selection.focusOffset);
        }
        this.selectionMgr.saveSelectionState();
    }
}

/**
 * Original: https://github.com/revin/markdown-it-task-lists/blob/master/index.js (Sep 22, 2023)
 * (ISC License)
 *
 */
let disableCheckboxes = true;
let useLabelWrapper = false;
let useLabelAfter = false;
const render$1 = (md, options) => {
    if (options) {
        disableCheckboxes = !options.enabled;
        useLabelWrapper = !!options.label;
        useLabelAfter = !!options.labelAfter;
    }
    md.core.ruler.after('inline', 'github-task-lists', function (state) {
        const tokens = state.tokens;
        for (let i = 2; i < tokens.length; i++) {
            if (isTodoItem(tokens, i)) {
                todoify(tokens[i], state.Token);
                attrSet(tokens[i - 2], 'class', 'task-list-item' + (!disableCheckboxes ? ' enabled' : ''));
                attrSet(tokens[parentToken(tokens, i - 2)], 'class', 'contains-task-list');
            }
        }
    });
};
function attrSet(token, name, value) {
    const index = token.attrIndex(name);
    const attr = [name, value];
    if (index < 0) {
        token.attrPush(attr);
    }
    else {
        token.attrs[index] = attr;
    }
}
function parentToken(tokens, index) {
    const targetLevel = tokens[index].level - 1;
    for (let i = index - 1; i >= 0; i--) {
        if (tokens[i].level === targetLevel) {
            return i;
        }
    }
    return -1;
}
function isTodoItem(tokens, index) {
    return isInline(tokens[index]) &&
        isParagraph(tokens[index - 1]) &&
        isListItem(tokens[index - 2]) &&
        startsWithTodoMarkdown(tokens[index]);
}
function todoify(token, TokenConstructor) {
    token.children.unshift(makeCheckbox(token, TokenConstructor));
    token.children[1].content = token.children[1].content.slice(3);
    token.content = token.content.slice(3);
    if (useLabelWrapper) {
        if (useLabelAfter) {
            token.children.pop();
            // Use large random number as id property of the checkbox.
            const id = 'task-item-' + Math.ceil(Math.random() * (10000 * 1000) - 1000);
            token.children[0].content = token.children[0].content.slice(0, -1) + ' id="' + id + '">';
            token.children.push(afterLabel(token.content, id, TokenConstructor));
        }
        else {
            token.children.unshift(beginLabel(TokenConstructor));
            token.children.push(endLabel(TokenConstructor));
        }
    }
}
function makeCheckbox(token, TokenConstructor) {
    const checkbox = new TokenConstructor('html_inline', '', 0);
    const disabledAttr = disableCheckboxes ? ' disabled="" ' : '';
    if (token.content.indexOf('[ ] ') === 0) {
        checkbox.content = '<input class="task-list-item-checkbox"' + disabledAttr + 'type="checkbox">';
    }
    else if (token.content.indexOf('[x] ') === 0 || token.content.indexOf('[X] ') === 0) {
        checkbox.content = '<input class="task-list-item-checkbox" checked=""' + disabledAttr + 'type="checkbox">';
    }
    return checkbox;
}
// these next two functions are kind of hacky; probably should really be a
// true block-level token with .tag=='label'
function beginLabel(TokenConstructor) {
    const token = new TokenConstructor('html_inline', '', 0);
    token.content = '<label>';
    return token;
}
function endLabel(TokenConstructor) {
    const token = new TokenConstructor('html_inline', '', 0);
    token.content = '</label>';
    return token;
}
function afterLabel(content, id, TokenConstructor) {
    const token = new TokenConstructor('html_inline', '', 0);
    token.content = '<label class="task-list-item-label" for="' + id + '">' + content + '</label>';
    token.attrs = [{ for: id }];
    return token;
}
function isInline(token) { return token.type === 'inline'; }
function isParagraph(token) { return token.type === 'paragraph_open'; }
function isListItem(token) { return token.type === 'list_item_open'; }
function startsWithTodoMarkdown(token) {
    // leading whitespace in a list item is already trimmed off by markdown-it
    return token.content.indexOf('[ ] ') === 0 || token.content.indexOf('[x] ') === 0 || token.content.indexOf('[X] ') === 0;
}

var markdownitAnchor = (md) => {
    md.core.ruler.before('replacements', 'anchors', (state) => {
        const anchorHash = {};
        let headingOpenToken;
        let headingContent;
        state.tokens.forEach((token) => {
            if (token.type === 'heading_open') {
                headingContent = '';
                headingOpenToken = token;
            }
            else if (token.type === 'heading_close') {
                headingOpenToken.headingContent = headingContent;
                // According to http://pandoc.org/README.html#extension-auto_identifiers
                let slug = headingContent
                    .replace(/\s/g, '-') // Replace all spaces and newlines with hyphens
                    .replace(/[\0-,/:-@[-^`{-~]/g, '') // Remove all punctuation, except underscores, hyphens, and periods
                    .toLowerCase(); // Convert all alphabetic characters to lowercase
                // Remove everything up to the first letter
                let i;
                for (i = 0; i < slug.length; i += 1) {
                    const charCode = slug.charCodeAt(i);
                    if ((charCode >= 0x61 && charCode <= 0x7A) || charCode > 0x7E) {
                        break;
                    }
                }
                // If nothing left after this, use `section`
                slug = slug.slice(i) || 'section';
                let anchor = slug;
                let index = 1;
                while (Object.prototype.hasOwnProperty.call(anchorHash, anchor)) {
                    anchor = `${slug}-${index}`;
                    index += 1;
                }
                anchorHash[anchor] = true;
                headingOpenToken.headingAnchor = anchor;
                headingOpenToken.attrs = [
                    ['id', anchor],
                ];
                headingOpenToken = undefined;
            }
            else if (headingOpenToken) {
                headingContent += token.children.reduce((result, child) => {
                    if (child.type !== 'footnote_ref') {
                        return result + child.content;
                    }
                    return result;
                }, '');
            }
        });
    });
};

const coreBaseRules = [
    'normalize',
    'block',
    'inline',
    'linkify',
    'replacements',
    'smartquotes',
];
const blockBaseRules = [
    'code',
    'fence',
    'blockquote',
    'hr',
    'list',
    'reference',
    'heading',
    'lheading',
    'html_block',
    'table',
    'paragraph',
];
const inlineBaseRules = [
    'text',
    'newline',
    'escape',
    'backticks',
    'strikethrough',
    'emphasis',
    'link',
    'image',
    'autolink',
    'html_inline',
    'entity',
];
const inlineBaseRules2 = [
    'balance_pairs',
    'strikethrough',
    'emphasis',
    // 'text_collapse'
];
var markdownGFM = (editorSvc) => {
    // editorSvc.onGetOptions((options, properties) => Object
    //     .assign(options, properties.extensions.markdown));
    editorSvc.onInitConverter(0, (markdown, options) => {
        markdown.set({
            html: true,
            breaks: true,
            linkify: true,
            typographer: true,
            langPrefix: 'prism language-',
        });
        markdown.core.ruler.enable(coreBaseRules);
        const blockRules = blockBaseRules.slice();
        markdown.block.ruler.enable(blockRules);
        const inlineRules = inlineBaseRules.slice();
        const inlineRules2 = inlineBaseRules2.slice();
        markdown.inline.ruler.enable(inlineRules);
        markdown.inline.ruler2.enable(inlineRules2);
        if (options.imgsize) {
            // TODO: Restore this without having a stroke
            // >> Module not found: Error: Can't resolve 'fs' in '/home/knackstedt/source/@dotglitch/stackedit/node_modules/markdown-it-imsize/lib/imsize/types'
            // markdown.use(markdownitImgsize);
        }
        markdown.use(markdownitAbbr);
        markdown.use(markdownitDeflist);
        markdown.use(markdownitFootnote);
        markdown.use(markdownitMark);
        markdown.use(markdownitSub);
        markdown.use(markdownitSup);
        markdown.use(render$1);
        markdown.use(markdownitAnchor);
        // Transform style into align attribute to pass the HTML sanitizer
        const textAlignLength = 'text-align:'.length;
        markdown.renderer.rules['td_open'] = (tokens, idx, opts) => {
            const token = tokens[idx];
            if (token.attrs && token.attrs.length && token.attrs[0][0] === 'style') {
                token.attrs = [
                    ['align', token.attrs[0][1].slice(textAlignLength)],
                ];
            }
            return markdown.renderer.renderToken(tokens, idx, opts);
        };
        markdown.renderer.rules['th_open'] = markdown.renderer.rules['td_open'];
        markdown.renderer.rules['footnote_ref'] = (tokens, idx) => {
            const n = `${Number(tokens[idx].meta.id + 1)}`;
            let id = `fnref${n}`;
            if (tokens[idx].meta.subId > 0) {
                id += `:${tokens[idx].meta.subId}`;
            }
            return `<sup class="footnote-ref"><a href="#fn${n}" id="${id}">${n}</a></sup>`;
        };
    });
    editorSvc.onSectionPreview((elt, options, isEditor) => {
        // Highlight with Prism
        elt.querySelectorAll('.prism').forEach((prismElt) => {
            if (!prismElt.$highlightedWithPrism) {
                Prism.highlightElement(prismElt);
                prismElt.$highlightedWithPrism = true;
                // Save as piktuuure
                if (prismElt.classList.contains("language-mermaid")) {
                    const copyButton = document.createElement('mat-icon');
                    copyButton.classList.add("material-icons");
                    copyButton.classList.add("copy-button");
                    copyButton.innerHTML = "download";
                    copyButton.onclick = () => {
                        const ulid = elt.getAttribute("ulid");
                        const diagram = editorSvc.previewElt.querySelector(`[ulid="${ulid}"] .language-mermaid svg`);
                        const svg = diagram.outerHTML
                            .replace(/<br>/g, '<br/>');
                        const blob = new Blob([svg], { type: 'image/svg+xml' });
                        const a = document.createElement('a');
                        a.href = URL.createObjectURL(blob);
                        a.download = `mermaid-diagram.svg`;
                        a.style.position = 'fixed';
                        a.style.left = '-1000vw';
                        a.target = '_blank';
                        a.setAttribute("rel", 'noopener');
                        document.body.appendChild(a);
                        a.click();
                        a.remove();
                    };
                    prismElt.parentElement.parentElement.append(copyButton);
                }
                else {
                    const copyButton = document.createElement('mat-icon');
                    copyButton.classList.add("material-icons");
                    copyButton.classList.add("copy-button");
                    copyButton.innerHTML = "content_copy";
                    copyButton.onclick = () => {
                        navigator.clipboard.writeText(prismElt.textContent);
                    };
                    prismElt.parentElement.append(copyButton);
                }
            }
        });
        // Transform task spans into checkboxes
        elt.querySelectorAll('.task-list-item-checkbox').forEach((spanElt) => {
            const target = spanElt.parentElement;
            const label = target.textContent.replace(/^[☑☐]\s?/, '');
            const isChecked = spanElt.getAttribute("checked") != null;
            target.innerHTML = `<input type="checkbox" ${isChecked ? 'checked="true"' : ''}><label> ${label}</label>`;
        });
    });
};

// Cloned from Mermaid's playground sourcecode
const setupMermaidLanguage = (monacoEditor) => {
    monacoEditor.languages.register({ id: 'mermaid' });
    const requirementDiagrams = [
        'requirement',
        'functionalRequirement',
        'interfaceRequirement',
        'performanceRequirement',
        'physicalRequirement',
        'designConstraint'
    ];
    const keywords = {
        flowchart: {
            typeKeywords: ['flowchart', 'flowchart-v2', 'graph'],
            blockKeywords: ['subgraph', 'end'],
            keywords: [
                'TB',
                'TD',
                'BT',
                'RL',
                'LR',
                'click',
                'call',
                'href',
                '_self',
                '_blank',
                '_parent',
                '_top',
                'linkStyle',
                'style',
                'classDef',
                'class',
                'direction',
                'interpolate'
            ]
        },
        sequenceDiagram: {
            typeKeywords: ['sequenceDiagram'],
            blockKeywords: ['alt', 'par', 'and', 'loop', 'else', 'end', 'rect', 'opt', 'alt', 'rect'],
            keywords: [
                'participant',
                'as',
                'Note',
                'note',
                'right of',
                'left of',
                'over',
                'activate',
                'deactivate',
                'autonumber',
                'title',
                'actor',
                'accDescription',
                'link',
                'links'
            ]
        },
        classDiagram: {
            typeKeywords: ['classDiagram', 'classDiagram-v2'],
            blockKeywords: ['class'],
            keywords: [
                'link',
                'click',
                'callback',
                'call',
                'href',
                'cssClass',
                'direction',
                'TB',
                'BT',
                'RL',
                'LR',
                'title',
                'accDescription',
                'order'
            ]
        },
        stateDiagram: {
            typeKeywords: ['stateDiagram', 'stateDiagram-v2'],
            blockKeywords: ['state', 'note', 'end'],
            keywords: ['state', 'as', 'hide empty description', 'direction', 'TB', 'BT', 'RL', 'LR']
        },
        erDiagram: {
            typeKeywords: ['erDiagram'],
            blockKeywords: [],
            keywords: ['title', 'accDescription']
        },
        journey: {
            typeKeywords: ['journey'],
            blockKeywords: ['section'],
            keywords: ['title']
        },
        info: {
            typeKeywords: ['info'],
            blockKeywords: [],
            keywords: ['showInfo']
        },
        gantt: {
            typeKeywords: ['gantt'],
            blockKeywords: [],
            keywords: [
                'title',
                'dateFormat',
                'axisFormat',
                'todayMarker',
                'section',
                'excludes',
                'inclusiveEndDates'
            ]
        },
        requirementDiagram: {
            typeKeywords: ['requirement', 'requirementDiagram'],
            blockKeywords: [...requirementDiagrams, 'element'],
            keywords: []
        },
        gitGraph: {
            typeKeywords: ['gitGraph'],
            blockKeywords: [],
            keywords: [
                'accTitle',
                'accDescr',
                'commit',
                'cherry-pick',
                'branch',
                'merge',
                'reset',
                'checkout',
                'LR',
                'BT',
                'id',
                'msg',
                'type',
                'tag',
                'NORMAL',
                'REVERSE',
                'HIGHLIGHT'
            ]
        },
        pie: {
            typeKeywords: ['pie'],
            blockKeywords: [],
            keywords: ['showData', 'title', 'accDescr', 'accTitle']
        },
        c4Diagram: {
            typeKeywords: ['C4Context', 'C4Container', 'C4Component', 'C4Dynamic', 'C4Deployment'],
            blockKeywords: [
                'Boundary',
                'Enterprise_Boundary',
                'System_Boundary',
                'Container_Boundary',
                'Node',
                'Node_L',
                'Node_R'
            ],
            keywords: [
                'title',
                'accDescription',
                'direction',
                'TB',
                'BT',
                'RL',
                'LR',
                'Person_Ext',
                'Person',
                'SystemQueue_Ext',
                'SystemDb_Ext',
                'System_Ext',
                'SystemQueue',
                'SystemDb',
                'System',
                'ContainerQueue_Ext',
                'ContainerDb_Ext',
                'Container_Ext',
                'ContainerQueue',
                'ContainerDb',
                'Container',
                'ComponentQueue_Ext',
                'ComponentDb_Ext',
                'Component_Ext',
                'ComponentQueue',
                'ComponentDb',
                'Component',
                'Deployment_Node',
                'Rel',
                'BiRel',
                'Rel_Up',
                'Rel_U',
                'Rel_Down',
                'Rel_D',
                'Rel_Left',
                'Rel_L',
                'Rel_Right',
                'Rel_R',
                'Rel_Back',
                'RelIndex'
            ]
        },
        sankey: {
            typeKeywords: ['sankey-beta'],
            blockKeywords: [],
            keywords: []
        }
    };
    const configDirectiveHandler = [
        /^\s*%%(?={)/,
        {
            token: 'string',
            next: '@configDirective',
            nextEmbedded: 'javascript'
        }
    ];
    // Register a tokens provider for the mermaid language
    monacoEditor.languages.setMonarchTokensProvider('mermaid', {
        ...Object.entries(keywords)
            .map((entry) => Object.fromEntries(Object.entries(entry[1]).map((deepEntry) => [
            entry[0] + deepEntry[0][0].toUpperCase() + deepEntry[0].slice(1),
            deepEntry[1]
        ])))
            // eslint-disable-next-line unicorn/no-array-reduce
            .reduce((overallKeywords, nextKeyword) => ({
            ...overallKeywords,
            ...nextKeyword
        }), {}),
        tokenizer: {
            root: [
                [/^\s*gitGraph/m, 'typeKeyword', 'gitGraph'],
                [/^\s*info/m, 'typeKeyword', 'info'],
                [/^\s*pie/m, 'typeKeyword', 'pie'],
                [/^\s*(flowchart|flowchart-v2|graph)/m, 'typeKeyword', 'flowchart'],
                [/^\s*sequenceDiagram/, 'typeKeyword', 'sequenceDiagram'],
                [/^\s*classDiagram(-v2)?/, 'typeKeyword', 'classDiagram'],
                [/^\s*journey/, 'typeKeyword', 'journey'],
                [/^\s*gantt/, 'typeKeyword', 'gantt'],
                [/^\s*stateDiagram(-v2)?/, 'typeKeyword', 'stateDiagram'],
                [/^\s*er(Diagram)?/, 'typeKeyword', 'erDiagram'],
                [/^\s*requirement(Diagram)?/, 'typeKeyword', 'requirementDiagram'],
                [/^\s*sankey-beta/m, 'typeKeyword', 'sankey'],
                [
                    /^\s*(C4Context|C4Container|C4Component|C4Dynamic|C4Deployment)/m,
                    'typeKeyword',
                    'c4Diagram'
                ],
                configDirectiveHandler,
                [/%%[^${].*$/, 'comment']
            ],
            configDirective: [[/%%$/, { token: 'string', next: '@pop', nextEmbedded: '@pop' }]],
            gitGraph: [
                configDirectiveHandler,
                [/option(?=s)/, { token: 'typeKeyword', next: 'optionsGitGraph' }],
                [/(accTitle|accDescr)(\s*:)(\s*[^\n\r]+$)/, ['keyword', 'delimiter.bracket', 'string']],
                [
                    /(^\s*branch)(.*?)(\s+order)(:\s*)(\d+\s*$)/,
                    ['keyword', 'variable', 'keyword', 'delimiter.bracket', 'number']
                ],
                [/".*?"/, 'string'],
                [
                    /(^\s*)(branch|reset|merge|checkout)(\s*\S+)/m,
                    ['delimiter.bracket', 'keyword', 'variable']
                ],
                [
                    /[A-Za-z][\w$]*/,
                    {
                        cases: {
                            '@gitGraphBlockKeywords': 'typeKeyword',
                            '@gitGraphKeywords': 'keyword'
                        }
                    }
                ],
                [/%%[^$]([^%]*(?!%%$)%?)*$/, 'comment'],
                [/\^/, 'delimiter.bracket']
            ],
            optionsGitGraph: [
                [
                    /s$/,
                    {
                        token: 'typeKeyword',
                        nextEmbedded: 'json'
                    }
                ],
                ['end', { token: 'typeKeyword', next: '@pop', nextEmbedded: '@pop' }]
            ],
            info: [
                [
                    /[A-Za-z][\w$]*/,
                    {
                        cases: {
                            '@infoBlockKeywords': 'typeKeyword',
                            '@infoKeywords': 'keyword'
                        }
                    }
                ]
            ],
            pie: [
                configDirectiveHandler,
                [/(title|accDescription)(.*$)/, ['keyword', 'string']],
                [
                    /[A-Za-z][\w$]*/,
                    {
                        cases: {
                            '@pieBlockKeywords': 'typeKeyword',
                            '@pieKeywords': 'keyword'
                        }
                    }
                ],
                [/".*?"/, 'string'],
                [/\s*\d+/, 'number'],
                [/:/, 'delimiter.bracket'],
                [/%%[^$]([^%]*(?!%%$)%?)*$/, 'comment']
            ],
            flowchart: [
                configDirectiveHandler,
                [/[ox]?(--+|==+)[ox]/, 'transition'],
                [
                    /[A-Za-z][\w$]*/,
                    {
                        cases: {
                            '@flowchartBlockKeywords': 'typeKeyword',
                            '@flowchartKeywords': 'keyword',
                            '@default': 'variable'
                        }
                    }
                ],
                [/\|+.+?\|+/, 'string'],
                [/\[+(\\.+?[/\\]|\/.+?[/\\])]+/, 'string'],
                [/[>[]+[^[\]|]+?]+/, 'string'],
                [/{+.+?}+/, 'string'],
                [/\(+.+?\)+/, 'string'],
                [/-\.+->?/, 'transition'],
                [/(-[.-])([^>-][^-]+?)(-{3,}|-{2,}>|\.-+>)/, ['transition', 'string', 'transition']],
                [/(==+)([^=]+?)(={3,}|={2,}>)/, ['transition', 'string', 'transition']],
                [/<?(--+|==+)>|===+|---+/, 'transition'],
                [/:::/, 'transition'],
                [/[&;]/, 'delimiter.bracket'],
                [/".*?"/, 'string'],
                [/%%[^$]([^%]*(?!%%$)%?)*$/, 'comment']
            ],
            sequenceDiagram: [
                configDirectiveHandler,
                [/(title:?|accDescription)([^\n\r;]*$)/, ['keyword', 'string']],
                [/(autonumber)([^\S\n\r]+off[^\S\n\r]*$)/, ['keyword', 'keyword']],
                [/(autonumber)((?:[^\S\n\r]+\d+){2}[^\S\n\r]*$)/, ['keyword', 'number']],
                [/(autonumber)([^\S\n\r]+\d+[^\S\n\r]*$)/, ['keyword', 'number']],
                [
                    /(link\s+)(.*?)(:)(\s*.*?)(\s*@)(\s*[^\n\r;]+)/,
                    ['keyword', 'variable', 'delimiter.bracket', 'string', 'delimiter.bracket', 'string']
                ],
                [
                    /((?:links|properties)\s+)([^\n\r:]*?)(:\s+)/,
                    [
                        { token: 'keyword' },
                        { token: 'variable' },
                        {
                            token: 'delimiter.bracket',
                            nextEmbedded: 'javascript',
                            next: '@sequenceDiagramLinksProps'
                        }
                    ]
                ],
                [
                    /[A-Za-z][\w$]*/,
                    {
                        cases: {
                            '@sequenceDiagramBlockKeywords': 'typeKeyword',
                            '@sequenceDiagramKeywords': 'keyword',
                            '@default': 'variable'
                        }
                    }
                ],
                [/(--?>?>|--?[)x])[+-]?/, 'transition'],
                [/(:)([^\n:]*?$)/, ['delimiter.bracket', 'string']],
                [/%%[^$]([^%]*(?!%%$)%?)*$/, 'comment']
            ],
            sequenceDiagramLinksProps: [
                // [/^:/, { token: 'delimiter.bracket', nextEmbedded: 'json' }],
                [/$|;/, { nextEmbedded: '@pop', next: '@pop', token: 'delimiter.bracket' }]
            ],
            classDiagram: [
                configDirectiveHandler,
                [/(^\s*(?:title|accDescription))(\s+.*$)/, ['keyword', 'string']],
                [
                    /(\*|<\|?|o|)(--|\.\.)(\*|\|?>|o|)([\t ]*[A-Za-z]+[\t ]*)(:)(.*?$)/,
                    ['transition', 'transition', 'transition', 'variable', 'delimiter.bracket', 'string']
                ],
                [/(?!class\s)([A-Za-z]+)(\s+[A-Za-z]+)/, ['type', 'variable']],
                [/(\*|<\|?|o)?(--|\.\.)(\*|\|?>|o)?/, 'transition'],
                [/^\s*class\s(?!.*{)/, 'keyword'],
                [
                    /[A-Za-z][\w$]*/,
                    {
                        cases: {
                            '@classDiagramBlockKeywords': 'typeKeyword',
                            '@classDiagramKeywords': 'keyword',
                            '@default': 'variable'
                        }
                    }
                ],
                [/%%[^$]([^%]*(?!%%$)%?)*$/, 'comment'],
                [/(<<)(.+?)(>>)/, ['delimiter.bracket', 'annotation', 'delimiter.bracket']],
                [/".*?"/, 'string'],
                [/:::/, 'transition'],
                [/:|\+|-|#|~|\*\s*$|\$\s*$|\(|\)|{|}/, 'delimiter.bracket']
            ],
            journey: [
                configDirectiveHandler,
                [/(title)(.*)/, ['keyword', 'string']],
                [/(section)(.*)/, ['typeKeyword', 'string']],
                [
                    /[A-Za-z][\w$]*/,
                    {
                        cases: {
                            '@journeyBlockKeywords': 'typeKeyword',
                            '@journeyKeywords': 'keyword',
                            '@default': 'variable'
                        }
                    }
                ],
                [
                    /(^\s*.+?)(:)(.*?)(:)(.*?)([$,])/,
                    [
                        'string',
                        'delimiter.bracket',
                        'number',
                        'delimiter.bracket',
                        'variable',
                        'delimiter.bracket'
                    ]
                ],
                [/,/, 'delimiter.bracket'],
                [/(^\s*.+?)(:)([^:]*?)$/, ['string', 'delimiter.bracket', 'variable']],
                [/%%[^$]([^%]*(?!%%$)%?)*$/, 'comment']
            ],
            gantt: [
                configDirectiveHandler,
                [/(title)(.*)/, ['keyword', 'string']],
                [/(section)(.*)/, ['typeKeyword', 'string']],
                [/^\s*([^\n:]*?)(:)/, ['string', 'delimiter.bracket']],
                [
                    /[A-Za-z][\w$]*/,
                    {
                        cases: {
                            '@ganttBlockKeywords': 'typeKeyword',
                            '@ganttKeywords': 'keyword'
                        }
                    }
                ],
                [/%%[^$]([^%]*(?!%%$)%?)*$/, 'comment'],
                [/:/, 'delimiter.bracket']
            ],
            stateDiagram: [
                configDirectiveHandler,
                [/note[^:]*$/, { token: 'typeKeyword', next: 'stateDiagramNote' }],
                ['hide empty description', 'keyword'],
                [/^\s*state\s(?!.*{)/, 'keyword'],
                [/(<<)(fork|join|choice)(>>)/, 'annotation'],
                [/(\[\[)(fork|join|choice)(]])/, ['delimiter.bracket', 'annotation', 'delimiter.bracket']],
                [
                    /[A-Za-z][\w$]*/,
                    {
                        cases: {
                            '@stateDiagramBlockKeywords': 'typeKeyword',
                            '@stateDiagramKeywords': 'keyword',
                            '@default': 'variable'
                        }
                    }
                ],
                [/".*?"/, 'string'],
                [/(:)([^\n:]*?$)/, ['delimiter.bracket', 'string']],
                [/{|}/, 'delimiter.bracket'],
                [/%%[^$]([^%]*(?!%%$)%?)*$/, 'comment'],
                [/-->/, 'transition'],
                [/\[.*?]/, 'string']
            ],
            stateDiagramNote: [
                [/^\s*end note$/, { token: 'typeKeyword', next: '@pop' }],
                [/.*/, 'string']
            ],
            erDiagram: [
                configDirectiveHandler,
                [/(title|accDescription)(.*$)/, ['keyword', 'string']],
                [/[|}][o|](--|\.\.)[o|][{|]/, 'transition'],
                [/".*?"/, 'string'],
                [/(:)(.*?$)/, ['delimiter.bracket', 'string']],
                [/[:{}]/, 'delimiter.bracket'],
                [/([A-Za-z]+)(\s+[A-Za-z]+)/, ['type', 'variable']],
                [/%%[^$]([^%]*(?!%%$)%?)*$/, 'comment'],
                [/[A-Z_a-z-][\w$]*/, 'variable']
            ],
            requirementDiagram: [
                configDirectiveHandler,
                [/->|<-|-/, 'transition'],
                [/(\d+\.)*\d+/, 'number'],
                [
                    /[A-Z_a-z-][\w$]*/,
                    {
                        cases: {
                            '@requirementDiagramBlockKeywords': 'typeKeyword',
                            '@default': 'variable'
                        }
                    }
                ],
                [/[/:{}]/, 'delimiter.bracket'],
                [/%%[^$]([^%]*(?!%%$)%?)*$/, 'comment'],
                [/".*?"/, 'string']
            ],
            c4Diagram: [
                configDirectiveHandler,
                [/(title|accDescription)(.*$)/, ['keyword', 'string']],
                [/\(/, { token: 'delimiter.bracket', next: 'c4DiagramParenthesis' }],
                [
                    /[A-Z_a-z-][\w$]*/,
                    {
                        cases: {
                            '@c4DiagramBlockKeywords': 'typeKeyword',
                            '@c4DiagramKeywords': 'keyword',
                            '@default': 'variable'
                        }
                    }
                ],
                [/%%[^$]([^%]*(?!%%$)%?)*$/, 'comment']
            ],
            c4DiagramParenthesis: [
                [/,/, 'delimiter.bracket'],
                [/\)/, { next: '@pop', token: 'delimiter.bracket' }],
                [/[^),]/, 'string']
            ],
            sankey: [
                configDirectiveHandler,
                [/(title)(.*)/, ['keyword', 'string']],
                [/(accTitle|accDescr)(\s*:)(\s*[^\n\r]+$)/, ['keyword', 'delimiter.bracket', 'string']],
                [/".*?"/, 'string'],
                [/[A-Za-z]+/, 'string'],
                [/\s*\d+/, 'number'],
                [/,/, 'delimiter.bracket'],
                [/%%[^$]([^%]*(?!%%$)%?)*$/, 'comment']
            ]
        }
    });
    monacoEditor.editor.defineTheme('mermaid-dark', {
        base: 'vs-dark',
        inherit: true,
        colors: {},
        rules: [
            { token: 'typeKeyword', foreground: '9650c8', fontStyle: 'bold' },
            { token: 'transition', foreground: '008800', fontStyle: 'bold' },
            { token: 'identifier', foreground: '9cdcfe' }
        ]
    });
    monacoEditor.editor.defineTheme('mermaid', {
        base: 'vs',
        inherit: true,
        colors: {},
        rules: [
            { token: 'typeKeyword', foreground: '9650c8', fontStyle: 'bold' },
            { token: 'keyword', foreground: '649696' },
            { token: 'custom-error', foreground: 'ff0000', fontStyle: 'bold' },
            { token: 'string', foreground: 'AA8500' },
            { token: 'transition', foreground: '008800', fontStyle: 'bold' },
            { token: 'delimiter.bracket', foreground: '000000', fontStyle: 'bold' },
            { token: 'annotation', foreground: '4b4b96' },
            { token: 'number', foreground: '4b4b96' },
            { token: 'comment', foreground: '888c89' },
            { token: 'variable', foreground: 'A22889' },
            { token: 'type', foreground: '2BDEA8' },
            { token: 'identifier', foreground: '9cdcfe' }
        ]
    });
    monacoEditor.languages.registerCompletionItemProvider('mermaid', {
        provideCompletionItems: () => {
            return {
                suggestions: []
            };
        }
    });
    monacoEditor.languages.setLanguageConfiguration('mermaid', {
        autoClosingPairs: [
            {
                open: '(',
                close: ')'
            },
            {
                open: '{',
                close: '}'
            },
            {
                open: '[',
                close: ']'
            }
        ],
        brackets: [
            ['(', ')'],
            ['{', '}'],
            ['[', ']']
        ],
        comments: {
            lineComment: '%%'
        }
    });
};

const basicFlags = [
    // +*?
    // Mark invalid quantifiers
    [/[+?*][+?][+*?]/, "invalid"],
    [/[+?*][*]/, "invalid"],
    [/[+?*][+?]?/, "quantifier"],
    [/\|/, "alternator"],
    [/\\u[A-F0-9a-f]{2}/, "unicode"],
    [/\\x[A-F0-9a-f]{4}/, "unicode"],
    [/\\\d{3}/, "octal"],
    [/\\./, "escape"],
    [/\(\?#/, { token: "comment", bracket: '@open', next: "@comment" }],
    [/\(/, { token: "group-terminator", bracket: '@open', next: "@group" }],
    [/\{/, { token: "quantifier", bracket: '@open', next: "@quantifier" }],
    [/\[\[:/, { token: "posix", bracket: '@open', next: "@posix" }],
    [/\[\^/, { token: "neg-literal", bracket: '@open', next: '@negativeLiteral' }],
    [/\[/, { token: "literal", bracket: '@open', next: '@literal' }],
];
function setupRegexLanguage(monaco) {
    monaco.languages.register({ id: 'rgx' });
    monaco.languages.setMonarchTokensProvider('rgx', {
        defaultToken: "basic",
        tokenPostfix: ".rgx",
        tokenizer: {
            root: [
                ...basicFlags
            ],
            group: [
                [/\?:/, { token: "non-capture-group", bracket: '@open', next: "@nonCaptureGroup" }],
                [/\?=/, { token: "lookahead", bracket: '@open', next: "@lookahead" }],
                [/\?<=/, { token: "lookbehind", bracket: '@open', next: "@lookbehind" }],
                [/\?</, { token: "group-name", bracket: '@open', next: "@namedGroup" }],
                [/\?!/, { token: "negative-lookahead", bracket: '@open', next: "@negativeLookahead" }],
                // [/\(/, { token: "capture-group", bracket: '@open', next: "@captureGroup" }],
                ...basicFlags,
                [/\)/, { token: "group-terminator", bracket: "@close", next: '@pop' }]
            ],
            //(?#...)
            comment: [
                [/\\./, "comment"],
                [/\)/, { token: "comment", bracket: "@close", next: '@pop' }],
                [/./, 'comment'],
            ],
            //(...)
            captureGroup: [
                ...basicFlags,
            ],
            //(?:...)
            nonCaptureGroup: [
                ...basicFlags,
                [/\)/, { token: "group-terminator", bracket: "@close", next: '@pop' }]
            ],
            //(?=...)
            lookahead: [
                ...basicFlags,
                [/\)/, { token: "group-terminator", bracket: "@close", next: '@pop' }]
            ],
            //(?<foobar>baz)
            namedGroup: [
                [/\\./, "group-name"],
                [/>/, { token: "group-name", bracket: "@close", next: '@pop' }],
                [/./, 'group-name'],
            ],
            //(?<=...)
            lookbehind: [
                ...basicFlags,
                [/\)/, { token: "group-terminator", bracket: "@close", next: '@pop' }]
            ],
            //(?!...)
            negativeLookahead: [
                ...basicFlags,
                [/\)/, { token: "group-terminator", bracket: "@close", next: '@pop' }]
            ],
            // {1,99} {99} {,99} {99,}
            quantifier: [
                [/\d+/, 'quantifier'],
                [/,/, 'quantifier'],
                [/\}/, { token: "quantifier", bracket: "@close", next: '@pop' }]
            ],
            // [[:alnum:]]
            posix: [
                [/./, "posix-operator"],
                [/:\]\]/, { token: "posix", bracket: "@close", next: '@pop' }],
            ],
            // [a-z] [abcdef()] [^abcdef] [abc\]def]
            literal: [
                [/\\x[A-F0-9a-f]{2}(?:-)/i, { token: "unicode-range", bracket: '@open', next: "@unicodeRange" }],
                [/\\u[A-F0-9a-f]{4}(?:-)/i, { token: "unicode-range", bracket: '@open', next: "@unicodeRange" }],
                [/\\\d{3}(?:-)/i, { token: "octal-range", bracket: '@open', next: "@unicodeRange" }],
                [/\\x[A-F0-9a-f]{2}/, "literal-unicode"],
                [/\\u[A-F0-9a-f]{4}/, "literal-unicode"],
                [/\\\d{3}/, "octal"],
                [/\\./, "literal-escape"],
                [/.(?:-)/i, { token: "char-range", bracket: '@open', next: "@charRange" }],
                // [/(?<=\/)\]/, "literal"],
                [/\]/, { token: "literal", bracket: "@close", next: '@pop' }],
                [/./, 'literal']
            ],
            negativeLiteral: [
                [/\\x[A-F0-9a-f]{2}(?=-)/i, { token: "unicode-range", bracket: '@open', next: "@unicodeRange" }],
                [/\\u[A-F0-9a-f]{4}(?=-)/i, { token: "unicode-range", bracket: '@open', next: "@unicodeRange" }],
                [/\\\d{3}(?=-)/i, { token: "octal-range", bracket: '@open', next: "@unicodeRange" }],
                [/\\x[A-F0-9a-f]{2}/, "neg-literal-unicode"],
                [/\\u[A-F0-9a-f]{4}/, "neg-literal-unicode"],
                [/\\\d{3}/, "octal"],
                [/\\./, "literal-escape"],
                [/.(?:-)/i, { token: "char-range", bracket: '@open', next: "@charRange" }],
                [/\]/, { token: "neg-literal", bracket: "@close", next: '@pop' }],
                [/./, 'neg-literal']
            ],
            octalRange: [
                [/-/, "octal-range"],
                [/\\\d{3}/, { token: "octal-range", bracket: "@close", next: '@pop' }],
            ],
            unicodeRange: [
                [/-/, "unicode-range"],
                [/\\x[a-f0-9A-F]{2}/, { token: "unicode-range", bracket: "@close", next: '@pop' }],
                [/\\u[a-f0-9A-F]{4}/, { token: "unicode-range", bracket: "@close", next: '@pop' }],
            ],
            charRange: [
                [/-/, "char-range"],
                [/\\x[a-f0-9A-F]{2}/, { token: "char-range", bracket: "@close", next: '@pop' }],
                [/\\u[a-f0-9A-F]{4}/, { token: "char-range", bracket: "@close", next: '@pop' }],
                [/./, { token: "char-range", bracket: "@close", next: '@pop' }],
            ]
        }
    });
    monaco.editor.defineTheme('vs-dark', {
        base: 'vs-dark',
        inherit: true,
        colors: {},
        rules: [
            { token: 'basic.rgx', foreground: '#aedaae', },
            { token: 'unicode.rgx', foreground: '#ffa500' },
            { token: 'invalid.rgx', foreground: '#ff0000', fontStyle: 'italic' },
            { token: 'comment.rgx', foreground: '#6a9955', fontStyle: 'italic' },
            { token: 'posix.rgx', foreground: '#8eff8e', },
            { token: 'posix-operator.rgx', foreground: '#8eff8e' },
            { token: 'literal.rgx', foreground: '#dcdc96' },
            { token: 'literal-unicode.rgx', foreground: '#ffa500', fontStyle: "italic" },
            { token: 'literal-escape.rgx', foreground: '#8eff8e' },
            { token: 'octal.rgx', foreground: '#ff00ff', fontStyle: "italic" },
            { token: 'octal-range.rgx', foreground: '#ffff00', fontStyle: "italic" },
            { token: 'char-range.rgx', foreground: '#f0f064' },
            { token: 'unicode-range.rgx', foreground: '#f0f064', fontStyle: "italic" },
            { token: 'neg-literal.rgx', foreground: '#d27878' },
            { token: 'neg-literal-unicode.rgx', foreground: '#eb6464', fontStyle: "italic" },
            { token: 'quantifier.rgx', foreground: '#80c4ff' },
            { token: 'escape.rgx', foreground: '#8e8eff' },
            { token: 'alternator.rgx', foreground: '#ffffff' },
            { token: 'negative-lookahead.rgx', foreground: '#999999', fontStyle: "italic" },
            { token: 'capture-group.rgx', foreground: '#999999', fontStyle: "italic" },
            { token: 'non-capture-group.rgx', foreground: '#999999', fontStyle: "italic" },
            { token: 'lookahead.rgx', foreground: '#999999', fontStyle: "italic" },
            { token: 'lookbehind.rgx', foreground: '#999999', fontStyle: "italic" },
        ],
    });
    monaco.editor.defineTheme('vs', {
        base: 'vs',
        inherit: true,
        colors: {},
        rules: [
            { token: 'basic.rgx', foreground: '#aedaae', },
            { token: 'unicode.rgx', foreground: '#ffa500' },
            { token: 'invalid.rgx', foreground: '#ff0000', fontStyle: 'italic' },
            { token: 'comment.rgx', foreground: '#6a9955', fontStyle: 'italic' },
            { token: 'posix.rgx', foreground: '#8eff8e', },
            { token: 'posix-operator.rgx', foreground: '#8eff8e' },
            { token: 'literal.rgx', foreground: '#dcdc96' },
            { token: 'literal-unicode.rgx', foreground: '#ffa500', fontStyle: "italic" },
            { token: 'literal-escape.rgx', foreground: '#8eff8e' },
            { token: 'octal.rgx', foreground: '#ff00ff', fontStyle: "italic" },
            { token: 'octal-range.rgx', foreground: '#ffff00', fontStyle: "italic" },
            { token: 'char-range.rgx', foreground: '#f0f064' },
            { token: 'unicode-range.rgx', foreground: '#f0f064', fontStyle: "italic" },
            { token: 'neg-literal.rgx', foreground: '#d27878' },
            { token: 'neg-literal-unicode.rgx', foreground: '#eb6464', fontStyle: "italic" },
            { token: 'quantifier.rgx', foreground: '#80c4ff' },
            { token: 'escape.rgx', foreground: '#8e8eff' },
            { token: 'alternator.rgx', foreground: '#ffffff' },
            { token: 'negative-lookahead.rgx', foreground: '#999999', fontStyle: "italic" },
            { token: 'capture-group.rgx', foreground: '#999999', fontStyle: "italic" },
            { token: 'non-capture-group.rgx', foreground: '#999999', fontStyle: "italic" },
            { token: 'lookahead.rgx', foreground: '#999999', fontStyle: "italic" },
            { token: 'lookbehind.rgx', foreground: '#999999', fontStyle: "italic" },
        ],
    });
}

// ! Extremely helpful demonstrations:
// https://microsoft.github.io/monaco-editor/monarch.html
/** Important notes:
 *  - Regex flags do not effect tokenization. You must specify both lowercase and uppercase text.
 *  - Tokenization does not effect link detection.
 */
function setupLogLanguage(monaco) {
    monaco.languages.register({ id: 'log' });
    monaco.languages.setMonarchTokensProvider('log', {
        defaultToken: "",
        tokenPostfix: ".log",
        tokenizer: {
            root: [
                // Match exception "at"
                [/^(  at|\tat|    at| --- at) /gm, { token: 'exception-stack', bracket: '@open', next: '@exception' }],
                // Known Types.
                [/\b(TypeError|Generator|Promise|httpAdapter|Axios|Function|JSON|Require stack|<anonymous>)\b/g, "type"],
                // Common NodeJS System Errors.
                // https://nodejs.org/api/errors.html
                [/(EACCES|EADDRINUSE|ECONNREFUSED|ECONNRESET|EEXIST|EISDIR|EMFILE|ENOENT|ENOTDIR|ENOTEMPTY|ENOTFOUND|EPERM|EPIPE|ETIMEDOUT)/, "system-error"],
                // socket timeout exception: java.net.NoRouteToHostException
                [/\b(FILE_NOT_FOUND)\b/, "system-error"],
                [/\b(GET|POST|PUT|PATCH|DELETE|COPY|HEAD|OPTIONS|LINK|UNLINK|PURGE|LOCK|UNLOCK|PROPFIND|VIEW)\b/, "http-method"],
                // Technology specific Exceptions
                [/\b(java\.[a-z0-9A-Z]+?\.[A-Za-z]+?Exception)\b/, "severity-error"],
                // Trace/Verbose
                [/[\b:\s\[](TRACE|[Tt]race|verb|verbose)[\b:\s\]]/, "severity-verbose"],
                // DEBUG
                [/[\b\[\s](debug|DEBUG)[\b\s\]]/, "severity-debug"],
                // INFO
                [/[\b\s\[](INFO|EVENT|hint|info|INFO|information|notice)[\b:\s\]]/, "severity-info"],
                // Warn
                [/[\b\[\s](WARNING|[Ww]arning|[Ww]arn|WARN)[\b:\s\]]/, "severity-warning"],
                // Error
                [/[\[\b\s](error|fatal|alert|critical|crash|emergency|PROTERR|ERROR)[\b:\s\]]/, "severity-error"],
                // Match the GMT log format from (apache)?
                // e.g. Fri, 03 Dec 2021 15:31:37 GMT
                // Monarch is ignoring the case-insensitive flag.
                [/([mM]on|[tT]ue|[wW]ed|[tT]hu|[fF]ri|[sS]at|[sS]un), \d\d ([jJ]an|[fF]eb|[mM]ar|[aA]pr|[mM]ay|[jJ]un|[jJ]ul|[aA]ug|[sS]ep|[oO]ct|[nN]ov|[dD]ec) 20\d\d \d\d:\d\d:\d\d [A-Z]{3}/i, "date"],
                // ISO dates ("2020-01-01")
                [/\b\d{4}-\d{2}-\d{2}(T|\b)/, "date"],
                // Culture specific dates ("01/01/2020", "01.01.2020")
                [/\b\d{2}[^\w\s]\d{2}[^\w\s]\d{4}\b/, "date"],
                // Clock times with optional timezone ("01:01:01", "01:01:01.001", "01:01:01+01:01")
                [/\d{1,2}:\d{2}(:\d{2}([.,]\d{1,})?)?(Z| ?[+-]\d{1,2}:\d{2})?\b/, "date"],
                [/\d{9,10}0000/, "date"],
                // 20171223-23:55:24:443
                [/2[01]\d{6}-\d{1,2}:\d{1,2}:\d{1,2}:\d{1,3}/, "date"],
                // [Mon Dec 05 19:00:54 2005]
                [/\[[A-Z][a-z]{2} [A-Z][a-z]{2} \d\d \d\d:\d\d:\d\d 2[01]\d\d\]/, "date"],
                // Jul 27 14:41:59 | Jul  9 22:53:22
                [/[A-Z][a-z]{2} [\d ]\d \d\d:\d\d:\d\d/, "date"],
                // 17/06/09 20:11:10
                [/\d\d\/\d\d\/\d\d \d\d:\d\d:\d\d/, "date"],
                // 1131567328 2005.11.09
                [/\d{9,14} 2[01]\d\d\.\d\d\.\d\d/, "date"],
                // Nov 9 12:11:23
                [/[A-Z][a-z]{2} \d \d\d:\d\d:\d\d/, "date"],
                // TODO: Sat Feb 19 07:28:05 UTC 2022
                // API scope matching
                // e.g. [Library]
                [/\[[^\]]+\]+/, "scope"],
                [/\|[a-zA-Z0-9_]+\|/, "scope"],
                [/\*{3,}/, "scope"],
                // Git commit hashes of length 40, 10, or 7
                [/[\b ]([0-9a-fA-F]{40}|[0-9a-fA-F]{10}|[0-9a-fA-F]{7})[\b \n,]/, "constant"],
                // Guids
                [/[0-9a-fA-F]{8}[-]?([0-9a-fA-F]{4}[-]?){3}[0-9a-fA-F]{12}/, "constant"],
                // Constants
                [/[\b ]([0-9a-f]{16}|true|false|null|new)[\b \n,]/, "constant"],
                // Addresses such as 0x00000000002ec640
                [/[\b ](\u0040?0x[0-9a-fA-F]{2,64})[\b \n,]/g, "constant"],
                // Nan and Undefined may be important.
                [/NaN|[Uu]ndefiend/, "severity-warning"],
                // Match numbers
                [/\d+(s|ms|b)/g, "number"],
                [/[\b ](\d\.\d+)[\b \n,]/g, "number"],
                [/[\b ](\d+)[\b \n,]/g, "number"],
                [/[\b ](\(\d+\))[\b \n,]/g, "number"],
                [/[\b ]([0-9A-F]{28})[\b \n,]/g, "number"],
                // 0x08701021
                // TODO: ip:55dccd85bc63 sp:7ffc3c6eaf40
                // Strings
                [/"[^"]*"/, "string"],
                // Regex not supported in webview
                // [/(?<![\w])'[^']*'/, "string"],
                // Match remote Urls
                // Fully qualified with protocol
                [/(https?|ftps?|sftp|ftpes|tls|ssh|git|file|pop3?):\/\/\S+/, "file-uri1"],
                [/(https?|ftps?|hfds):\/\/[^ \n]+/, "file-uri2"],
                // C:\
                //
                [/([A-Z]:\\|\/[a-z]\/)(([^\\\/\n])+?[\\\/])+([^\\\/\n])+?[^\s\[\]\(\)\,\#]+/, "file-uri3"],
                // [/([A-Z]:\\|\/[a-z]\/)(([^\\\/\n])+?[\\\/])+([^\\\/\n])+?\.[a-z0-9]{2,12}/, "file-uri"],
                // TODO: /usr/share/fonts/truetype/freefont
                // linux-headers-6.2.0-76060200-generic:amd64
                // (6.2.0-76060200.202302191831~1677858327~22.04~3cea1be)
                [/(>= |= )[\d\.~\-a-z]+/, "version-map"],
                // Intercept BEFORE ip address.
                // CurrentState:112
                // Match IP addresses
                //      [::ffff:192.168.1.107]                                                           [2001:0db8:85a3:0000:0000:8a2e:0370:7334]
                // ::ffff:127.0.0.1
                // IPv6
                [/\b(::1|::ffff:(([12]\d\d|\d\d?)\.([12]\d\d|\d\d?)\.([12]\d\d|\d\d?)\.([12]\d\d|\d\d?))|([a-f0-9]{0,4}:){1,7}[a-f0-9]{1,4})(:\d{2,5})?\b/g, "ip-address"],
                // IPv4
                [/\b(([12]\d\d|\d\d?)\.([12]\d\d|\d\d?)\.([12]\d\d|\d\d?)\.([12]\d\d|\d\d?))(:\d{2,5})?\b/g, "ip-address"],
                // /apps/x86_64/system/ganglia-3.0.1/sbin/gmetad
                // [/[\b :](\/[^\/\\\[\]:\n]+)+\/?/, "file-uri4"],
                [/\b\.\.\.\b/, "muted"],
                // @ref http_logging section.
                [/\(/, "control", "@http_logging"],
            ],
            exception: [
                [/(\s{2,4}|\t)at/, 'exception-stack'],
                [/([A-Z]:\\|\/[a-z]\/)?[a-zA-Z0-9\/\\_~.\-\u0040 ]+?\.(js|ts|go)/, 'file-uri5'],
                [/:\d+:\d+/, 'file-position'],
                [/[\b ]([0-9a-f]{16}|true|false|null|new)[\b \n,]/, "constant"],
                [/^(?=[^\s]{4})/, { token: "control", bracket: '@close', next: "@pop" }]
            ],
            http_logging: [
                [/GET|POST|PUT|PATCH|DELETE|COPY|HEAD|OPTIONS|LINK|UNLINK|PURGE|LOCK|UNLOCK|PROPFIND|VIEW/i, "http-method"],
                [/ -?\d+ |-?\d{4,99}|\b\d{1,2}\b/g, "number"],
                [/[\b ]0x[0-9a-fA-F]{2,64}[\b ]/g, "number"],
                [/1\d\d/i, "severity-verbose"],
                [/2\d\d/i, "severity-debug"],
                [/3\d\d/i, "constant"],
                [/4\d\d/i, "severity-warning"],
                [/5\d\d/i, "severity-error"],
                [/\)|\s/, 'control', '@pop']
            ]
        }
    });
    monaco.editor.defineTheme('vs-dark', {
        base: 'vs-dark',
        inherit: true,
        colors: {},
        rules: [
            { token: 'severity-verbose.log', foreground: '#90a4ae' },
            { token: 'severity-debug.log', foreground: '#7cace8' },
            { token: 'severity-info.log', foreground: '#4caf50' },
            { token: 'severity-error.log', foreground: '#e43e3e', fontStyle: 'bold' },
            { token: 'severity-warning.log', foreground: '#ff9800' },
            { token: 'date.log', foreground: '#00bfae' },
            { token: 'scope.log', foreground: '#aaaaaa' },
            { token: 'code.log', foreground: '#8aacbc' },
            { token: 'exception-stack.log', foreground: '#ff9800', fontStyle: 'bold' },
            { token: 'file-uri.log', foreground: '#90caf9', fontStyle: 'italic' },
            { token: 'file-uri1.log', foreground: '#90caf8', fontStyle: 'italic' },
            { token: 'file-uri2.log', foreground: '#90caf7', fontStyle: 'italic' },
            { token: 'file-uri3.log', foreground: '#90caf6', fontStyle: 'italic' },
            { token: 'file-uri4.log', foreground: '#90caf5', fontStyle: 'italic' },
            { token: 'file-uri5.log', foreground: '#90caf4', fontStyle: 'italic' },
            { token: 'file-uri6.log', foreground: '#90caf3', fontStyle: 'italic' },
            { token: 'file-uri7.log', foreground: '#90caf2', fontStyle: 'italic' },
            { token: 'ip-address.log', foreground: '#90f998', fontStyle: 'italic' },
            { token: 'file-position.log', foreground: '#b6e7ff' },
            { token: 'type.log', foreground: '#2196f3' },
            { token: 'http-method.log', foreground: '#bdbdbd' },
            { token: 'system-error.log', foreground: '#ffc107' },
            { token: 'muted.log', foreground: '#777777' },
        ],
    });
    monaco.editor.defineTheme('vs', {
        base: 'vs',
        inherit: true,
        colors: {},
        rules: [
            { token: 'severity-verbose.log', foreground: '#90a4ae' },
            { token: 'severity-debug.log', foreground: '#7cace8' },
            { token: 'severity-info.log', foreground: '#4caf50' },
            { token: 'severity-error.log', foreground: '#e43e3e', fontStyle: 'bold' },
            { token: 'severity-warning.log', foreground: '#ff9800' },
            { token: 'date.log', foreground: '#00bfae' },
            { token: 'scope.log', foreground: '#aaaaaa' },
            { token: 'code.log', foreground: '#8aacbc' },
            { token: 'exception-stack.log', foreground: '#ff9800', fontStyle: 'bold' },
            { token: 'file-uri.log', foreground: '#90caf9', fontStyle: 'italic' },
            { token: 'file-uri1.log', foreground: '#90caf8', fontStyle: 'italic' },
            { token: 'file-uri2.log', foreground: '#90caf7', fontStyle: 'italic' },
            { token: 'file-uri3.log', foreground: '#90caf6', fontStyle: 'italic' },
            { token: 'file-uri4.log', foreground: '#90caf5', fontStyle: 'italic' },
            { token: 'file-uri5.log', foreground: '#90caf4', fontStyle: 'italic' },
            { token: 'file-uri6.log', foreground: '#90caf3', fontStyle: 'italic' },
            { token: 'file-uri7.log', foreground: '#90caf2', fontStyle: 'italic' },
            { token: 'ip-address.log', foreground: '#90f998', fontStyle: 'italic' },
            { token: 'file-position.log', foreground: '#b6e7ff' },
            { token: 'type.log', foreground: '#2196f3' },
            { token: 'http-method.log', foreground: '#bdbdbd' },
            { token: 'system-error.log', foreground: '#ffc107' },
            { token: 'muted.log', foreground: '#777777' },
        ],
    });
}

let isMonacoInstalled = false;
const installationLocation = '/lib/monaco/vs';
function installMonaco() {
    if (isMonacoInstalled || window['monaco'])
        return;
    // Monaco has a UMD loader that requires this
    // Merge with any pre-existing global require objects.
    if (!window['require'])
        window['require'] = {};
    if (!window['require']['paths'])
        window['require']['paths'] = {};
    window['require']['paths'].vs = installationLocation;
    const monacoFiles = [
        'loader.js',
        'editor/editor.main.nls.js',
        'editor/editor.main.js',
    ];
    for (let i = 0; i < monacoFiles.length; i++) {
        const script = document.createElement("script");
        script.setAttribute("defer", "");
        script.setAttribute("src", installationLocation + '/' + monacoFiles[i]);
        document.body.append(script);
    }
    isMonacoInstalled = true;
}
function waitForMonacoInstall() {
    return new Promise((res, rej) => {
        let count = 0;
        let i = window.setInterval(() => {
            count++;
            if (window['monaco'] != undefined) {
                window.clearInterval(i);
                setupMermaidLanguage(window['monaco']);
                setupRegexLanguage(window['monaco']);
                setupLogLanguage(window['monaco']);
                res(true);
            }
            if (count >= 100) {
                window.clearInterval(i);
                res(false);
            }
        }, 100);
    });
}
const MonacoAliasMap = {
    'ts': 'typescript',
    'js': 'javascript',
    'sh': 'shell',
    'bash': 'shell',
    'ash': 'shell',
    'zsh': 'shell',
    'yml': 'yaml',
    'rb': 'ruby',
    'ps1': 'powershell',
    'pwsh': 'powershell',
    'py': 'python',
    'py2': 'python',
    'py3': 'python',
    'python2': 'python',
    'python3': 'python',
    'md': 'markdown',
    'c#': 'csharp',
    'cs': 'csharp',
    'c++': 'cpp',
    'h': 'cpp',
    'regex': 'rgx',
    'pcre': 'rgx',
    'rx': 'rgx'
};
// .sh.js.ts.py.bat.ps1.rb.lua.r
const invokableLanguages = [
    "javascript"
];

const config = {
    logLevel: 5,
    startOnLoad: false,
    arrowMarkerAbsolute: false,
    theme: 'base',
    securityLevel: "strict",
    wrap: true,
    htmlLabels: true,
    fontSize: 20,
    themeVariables: {
        primaryColor: '#464646',
        primaryTextColor: '#fff',
        // primaryBorderColor: '#7C0000',
        lineColor: '#84FFFF',
        secondaryColor: '#00E5FF',
        tertiaryColor: '#536DFE',
        noteBkgColor: '#84FFFF',
        noteTextColor: '#121212'
    },
    flowchart: {
        htmlLabels: true,
        curve: 'linear',
    },
    sequence: {
        diagramMarginX: 50,
        diagramMarginY: 10,
        actorMargin: 50,
        width: 150,
        height: 65,
        boxMargin: 10,
        boxTextMargin: 5,
        noteMargin: 10,
        messageMargin: 35,
        mirrorActors: true,
        bottomMarginAdj: 1,
        useMaxWidth: true,
    },
    gantt: {
        titleTopMargin: 25,
        barHeight: 20,
        barGap: 4,
        topPadding: 50,
        leftPadding: 75,
        gridLineStartPadding: 35,
        fontSize: 11,
        numberSectionStyles: 4,
        axisFormat: '%Y-%m-%d',
    },
};
const containerElt = document.createElement('div');
containerElt.className = 'hidden-rendering-container';
document.body.appendChild(containerElt);
let init = () => {
    mermaid.initialize(config);
    init = () => { };
};
const render = (elt, text) => new Promise(r => {
    init();
    const svgId = `mermaid-svg-${ulid()}`;
    // Trigger this slightly out-of sync to allow
    // the rest of the startup sequences to settle.
    setTimeout(() => {
        mermaid.mermaidAPI.renderAsync(svgId, text ?? elt.textContent, () => {
            while (elt?.firstChild) {
                elt.removeChild(elt.lastChild);
            }
            const el = containerElt.querySelector('#' + svgId);
            elt.appendChild(el);
        }, containerElt)
            .catch(e => {
            // In the event of an invalid mermaid chart, render the section with an error message.
            elt.innerHTML = `<pre>${e.message}</pre>`;
            // if (e.message == "Cannot read properties of null (reading 'firstChild')")
        });
    }, 0);
});
var mermaidExtension = (extensionSvc) => {
    extensionSvc.onGetOptions((options, properties) => {
        options.mermaid = properties.extensions.mermaid.enabled;
    });
    extensionSvc.onSectionPreview((elt) => {
        elt.querySelectorAll('.prism.language-mermaid')
            .forEach(diagramElt => render(diagramElt.parentNode));
    });
};
const RenderMermaid = render;

var mermaidExtension$1 = /*#__PURE__*/Object.freeze({
  __proto__: null,
  RenderMermaid: RenderMermaid,
  default: mermaidExtension
});

const allowDebounce = (action, wait) => {
    let timeoutId;
    return (doDebounce = false, ...params) => {
        clearTimeout(timeoutId);
        if (doDebounce) {
            timeoutId = setTimeout(() => action(...params), wait);
        }
        else {
            action(...params);
        }
    };
};
class SectionDesc {
    section;
    previewElt;
    tocElt;
    html;
    editorElt;
    editorDimension;
    previewDimension;
    tocDimension;
    previewText;
    textToPreviewDiffs;
    ulid = ulid();
    constructor(section, previewElt, tocElt, html) {
        this.section = section;
        this.previewElt = previewElt;
        this.tocElt = tocElt;
        this.html = html;
        this.editorElt = section.elt;
        previewElt?.setAttribute("ulid", this.ulid);
        tocElt?.setAttribute("ulid", this.ulid);
        section?.elt?.setAttribute("ulid", this.ulid);
    }
}
// Use a vue instance as an event bus
class Editor extends EventEmittingClass {
    ngEditor;
    editorElt;
    previewElt;
    tocElt;
    clEditor;
    diffMatchPatch = new DiffMatchPatch();
    instantPreview = true;
    tokens;
    // Other object;
    parsingCtx;
    conversionCtx;
    previewCtx = {
        sectionDescList: []
    };
    previewCtxMeasured;
    previewCtxWithDiffs;
    sectionList;
    selectionRange;
    converter;
    getOptionsListeners = [];
    initConverterListeners = [];
    sectionPreviewListeners = [];
    imageElementCache = {};
    overlay1;
    overlay2;
    underlay;
    focus;
    /**
     * Pass the elements to the store and initialize the editor.
     */
    constructor(ngEditor, editorElt, previewElt, tocElt) {
        super();
        this.ngEditor = ngEditor;
        this.editorElt = editorElt;
        this.previewElt = previewElt;
        this.tocElt = tocElt;
        this.overlay1 = editorElt.querySelector(".editor-overlay-1");
        this.overlay2 = editorElt.querySelector(".editor-overlay-2");
        this.underlay = editorElt.querySelector(".editor-underlay");
        // Enable standard markdown rendering support
        markdownGFM(this);
        Promise.all([
            // (!ngEditor.options.disableEmoji)
            //     ? import('./extensions/emojiExtension').then((ext) => ext.default(this))
            //     : null,
            (!ngEditor.options.disableMermaid)
                ? Promise.resolve().then(function () { return mermaidExtension$1; }).then((ext) => ext.default(this))
                : null,
        ].filter(e => !!e)).then((extensions) => {
            this.converter = markdownConversionSvc.createConverter();
            this.initConverter(this.converter, ngEditor.options.markdownIt);
            this.clEditor = new VanillaMirror(this.ngEditor, editorElt.querySelector('.editor-inner'), this.ngEditor.value);
            let scrollMode;
            let lastScrollEvent = 0;
            const scrollDebounceTime = 500;
            // Manually handle scroll events
            const onScroll = (e) => {
                e.preventDefault();
                this.restoreScrollPosition(this.getScrollPosition(scrollMode == 'editor' ? editorElt : previewElt));
            };
            editorElt.parentElement.parentElement.onscroll = evt => {
                if (scrollMode == "editor" || lastScrollEvent + scrollDebounceTime < Date.now()) {
                    scrollMode = "editor";
                    lastScrollEvent = Date.now();
                    onScroll(evt);
                }
            };
            previewElt.parentElement.parentElement.parentElement.onscroll = evt => {
                if (scrollMode == "preview" || lastScrollEvent + scrollDebounceTime < Date.now()) {
                    scrollMode = "preview";
                    lastScrollEvent = Date.now();
                    onScroll(evt);
                }
            };
            const refreshPreview = allowDebounce(() => {
                this.convert();
                if (this.instantPreview) {
                    this.refreshPreview();
                    this.measureSectionDimensions(false, true);
                }
                else {
                    setTimeout(() => this.refreshPreview(), 10);
                }
                this.instantPreview = false;
            }, 25);
            let newSectionList;
            let newSelectionRange;
            this.clEditor.on('contentChanged', (text, diffs, sectionList) => {
                this.parsingCtx.sectionList = sectionList;
                newSectionList = sectionList;
                onEditorChanged(!this.instantPreview);
            });
            const onEditorChanged = allowDebounce(() => {
                if (this.sectionList !== newSectionList) {
                    this.sectionList = newSectionList;
                    this.$trigger('sectionList', this.sectionList);
                    refreshPreview(!this.instantPreview);
                }
                if (this.selectionRange !== newSelectionRange) {
                    this.selectionRange = newSelectionRange;
                    this.$trigger('selectionRange', this.selectionRange);
                }
            }, 10);
            window.addEventListener('resize', this.refreshScrollSync);
            // Need to listen to focus because resize events that occur
            // when the tab isn't focused may not always fire.
            window.addEventListener('focus', this.refreshScrollSync);
            this.clEditor.selectionMgr.on('selectionChanged', (start, end, selectionRange) => {
                newSelectionRange = selectionRange;
                onEditorChanged(!this.instantPreview);
            });
            this.clEditor.highlighter.on('sectionHighlighted', (section) => this.onEditorRenderSection(section));
            this.measureSectionDimensions(false, true, true);
            this.initClEditor();
            this.clEditor.toggleEditable(true);
            this.$trigger('loaded');
        });
    }
    destroy() {
        this.clEditor.destroy();
        window.removeEventListener('resize', this.refreshScrollSync);
        window.removeEventListener('focus', this.refreshScrollSync);
    }
    onGetOptions(listener) {
        this.getOptionsListeners.push(listener);
    }
    onInitConverter(priority, listener) {
        this.initConverterListeners[priority] = listener;
    }
    onSectionPreview(listener) {
        this.sectionPreviewListeners.push(listener);
    }
    getOptions(properties, isCurrentFile) {
        return this.getOptionsListeners.reduce((options, listener) => {
            listener(options, properties, isCurrentFile);
            return options;
        }, {});
    }
    initConverter(markdown, options) {
        // Use forEach as it's a sparsed array
        this.initConverterListeners.forEach((listener) => {
            listener(markdown, options);
        });
    }
    sectionPreview(elt, options, isEditor) {
        this.sectionPreviewListeners.forEach((listener) => {
            listener(elt, options, isEditor);
        });
    }
    onEditorRenderSection(s) {
        const section = s;
        // Render images inline in the editor.
        section.elt.querySelectorAll('.token.img').forEach((imgTokenElt) => {
            const srcElt = imgTokenElt.querySelector('.img-src');
            if (!srcElt)
                return;
            // TODO: sanitize URIs?
            // Also add support for URI whitelists.
            // Create an img element before the .img.token and wrap both elements
            // into a .token.img-wrapper
            const imgElt = document.createElement('img');
            imgElt.style.display = 'none';
            const uri = srcElt.textContent;
            imgElt.onload = () => {
                imgElt.style.display = '';
                sectionUtils.measureSectionDimensions(this);
                this.previewCtxMeasured = this.previewCtx;
                this.sectionList?.forEach(s => s.monaco?.['_resize']());
                this.restoreScrollPosition();
                const width = imgElt.offsetWidth;
                const height = imgElt.offsetHeight;
                if (height > 30) {
                    imgElt.parentElement.classList.add("img-block");
                }
                const rsObserver = new ResizeObserver(() => {
                    this.restoreScrollPosition();
                });
                rsObserver.observe(imgElt, { box: 'border-box' });
            };
            imgElt.src = uri;
            // Take img size into account
            const sizeElt = imgTokenElt.querySelector('.size');
            if (sizeElt) {
                const match = sizeElt.textContent.match(/=(\d*)x(\d*)/);
                if (match[1]) {
                    imgElt.width = parseInt(match[1], 10);
                }
                if (match[2]) {
                    imgElt.height = parseInt(match[2], 10);
                }
            }
            this.imageElementCache[uri] = imgElt;
            const imgTokenWrapper = document.createElement('span');
            imgTokenWrapper.className = 'token img-wrapper';
            imgTokenElt.parentNode.insertBefore(imgTokenWrapper, imgTokenElt);
            imgTokenWrapper.appendChild(imgElt);
            imgTokenWrapper.appendChild(imgTokenElt);
        });
        let imgCache = {};
        this.clEditor.highlighter.on('highlighted', () => {
            Object.entries(this.imageElementCache).forEach(([key, imgElt]) => {
                const cachedImgElt = imgCache[key];
                if (cachedImgElt) {
                    // Found a previously loaded image that has just been released
                    imgElt.parentNode.replaceChild(cachedImgElt, imgElt);
                }
                else {
                    imgCache[key] = imgElt;
                }
            });
            this.imageElementCache = {};
        });
        section.elt.querySelectorAll('.image-spinner').forEach((fenceElement) => {
            const insertWrapper = document.createElement('div');
            insertWrapper.className = 'img-spinner';
            insertWrapper.innerHTML = `<div class="spinnerMax"><div class="spinnerMid"><div class="spinnerMin"><span>\`\`\`img-spinner\`\`\`</span></div></div></div>`;
            fenceElement.insertAdjacentElement('beforebegin', insertWrapper);
            fenceElement.remove();
        });
        // Run on next tick to allow for style updates to propagate
        setTimeout(() => {
            // return;
            section.elt.querySelectorAll('.code-block').forEach((cb) => {
                const codeBlock = cb;
                section.elt.classList.add("monaco-injected");
                const id = section.elt.getAttribute("ulid");
                const langEl = codeBlock.parentElement.querySelector('.code-language');
                const targetLang = langEl.textContent?.toLowerCase() || 'auto';
                // Map aliases to known monaco languages
                const language = MonacoAliasMap[targetLang] || targetLang;
                const monacoContainer = document.createElement('div');
                monacoContainer.setAttribute("ulid", section.elt.getAttribute("ulid"));
                monacoContainer.classList.add("monaco-container");
                let languages = [];
                switch (this.ngEditor.codeRunner) {
                    case "custom":
                        languages = this.ngEditor.customCodeLanguages;
                        break;
                    case "eval":
                        languages = ['javascript', 'js'];
                        break;
                    case "piston":
                        languages = window['root']?.utils.pistonRuntimes
                            .map(l => [l.language, ...l.aliases]).flat();
                        break;
                }
                if (this.ngEditor.showCodeRunButton && languages.includes(targetLang)) {
                    const runButton = document.createElement('mat-icon');
                    runButton.classList.add("material-icons");
                    runButton.classList.add("run-button");
                    runButton.innerHTML = "play_arrow";
                    runButton.onclick = async () => {
                        switch (this.ngEditor.codeRunner) {
                            case "custom": {
                                this.ngEditor.onCustomCodeExecute.next({
                                    content: codeBlock.textContent,
                                    language: targetLang
                                });
                                break;
                            }
                            case "eval": {
                                // TODO: run in worker thread to secure it, if even a little bit.
                                let res = eval(codeBlock.textContent);
                                if (typeof res == "function")
                                    res = await res();
                                break;
                            }
                            case "piston": {
                                const runtimes = await window['root']?.utils.getPistonRuntimes()
                                    .catch(e => []);
                                const lang = runtimes.find(r => r.language == language || r.aliases.includes(language));
                                window['root']?.utils.runPistonScript(lang, [{
                                        content: codeBlock.textContent,
                                        encoding: "utf-8",
                                        name: ulid()
                                    }]);
                            }
                        }
                        // ... Do something with the result
                    };
                    monacoContainer.append(runButton);
                }
                if (this.ngEditor.showCodeCopyButton) {
                    const copyButton = document.createElement('mat-icon');
                    copyButton.classList.add("material-icons");
                    copyButton.classList.add("copy-button");
                    copyButton.innerHTML = "content_copy";
                    copyButton.onclick = () => {
                        navigator.clipboard.writeText(section.text);
                    };
                    monacoContainer.append(copyButton);
                }
                // Lookup the closest actual style definition
                const originalStyles = (() => {
                    const styleOrder = [
                        window.getComputedStyle(codeBlock),
                        window.getComputedStyle(section.elt),
                        window.getComputedStyle(this.editorElt),
                        window.getComputedStyle(document.body)
                    ];
                    const obj = {};
                    Object.keys(styleOrder[0]).forEach(key => {
                        obj[key] = styleOrder[0][key] ||
                            styleOrder[1][key] ||
                            styleOrder[2][key] ||
                            styleOrder[3][key];
                    });
                    return obj;
                })();
                const settings = {
                    theme: "vs-dark",
                    automaticLayout: true,
                    colorDecorators: true,
                    lineHeight: 24,
                    folding: true,
                    // ! This _cannot_ be used reliably without testing on
                    // Windows, macOS, AND Linux
                    // fontFamily: 'var(--stackedit-font-family-mono)',
                    fontSize: parseInt(originalStyles?.fontSize?.replace('px', '')) || 16,
                    scrollbar: {
                        alwaysConsumeMouseWheel: false
                    },
                    minimap: {
                        enabled: false
                    },
                    smoothScrolling: true,
                    mouseWheelScrollSensitivity: 2,
                    scrollBeyondLastLine: false,
                    value: codeBlock.textContent,
                    language: language
                };
                const editor = section.monaco = monaco.editor.create(monacoContainer, settings);
                const model = editor.getModel();
                // ! Time for untyped bindings.
                monacoContainer['_editor'] = editor;
                codeBlock['_editor'] = editor;
                codeBlock['_monacoContainer'] = monacoContainer;
                codeBlock['_section'] = section;
                editor['_resize'] = () => {
                    // Add 1 extra line to accommodate the scroll bar and other pixel
                    // imperfect artifacts
                    monacoContainer.style.height = codeBlock.offsetHeight + (0) + "px";
                    monacoContainer.style.width = codeBlock.offsetWidth + "px";
                    monacoContainer.style.top = codeBlock.offsetTop + 'px';
                    monacoContainer.style.left = (codeBlock.offsetLeft - this.overlay1.offsetLeft) + 'px';
                    // monacoContainer.style.left = '12px';
                };
                editor['_resize']();
                const rsObserver = new ResizeObserver(editor['_resize']);
                rsObserver.observe(codeBlock, { box: 'border-box' });
                // Prevent editor click handler from deselecting the element
                monacoContainer.onclick = evt => {
                    evt.stopPropagation();
                    this.focus = "monaco";
                };
                let lastCursPos;
                const disposables = [
                    model.onDidChangeContent(() => {
                        const text = editor.getValue();
                        const cleanedText = text.replace(/\\n/gm, '\n')
                            .replace(/\\"/gm, '"');
                        section.text = cleanedText;
                        // Handle completely passively.
                        // Watcher will trigger a rebuild of monaco.
                        this.clEditor.watcher.noWatch(() => {
                            codeBlock.textContent = cleanedText;
                            const previewSection = this.previewElt.querySelector(`.cl-preview-section[ulid="${id}"]`);
                            const prismContainer = previewSection?.querySelector(".prism");
                            if (!previewSection)
                                return;
                            const mermaidElement = previewSection.querySelector(".language-mermaid");
                            if (mermaidElement) {
                                RenderMermaid(mermaidElement, cleanedText);
                            }
                            else {
                                const lang = prismContainer.classList.value
                                    .split(" ")
                                    .find(v => v.startsWith("language-"))
                                    ?.replace('language-', '') || "auto";
                                const updated = Prism.highlight(cleanedText, Prism.languages[lang]);
                                prismContainer.innerHTML = updated;
                            }
                        });
                    }),
                    editor.onDidChangeCursorPosition(e => {
                        lastCursPos = e.position;
                    }),
                    editor.onKeyDown(e => {
                        if (e.altKey || e.shiftKey || e.ctrlKey)
                            return;
                        if (e.code != "ArrowUp" && e.code != "ArrowDown")
                            return;
                        lastCursPos = lastCursPos || editor.getSelection().getPosition();
                        const gutter = editor.getDomNode().querySelector('.margin-view-overlays');
                        if (e.code == "ArrowUp" && lastCursPos.lineNumber <= 1) {
                            e.preventDefault();
                            const node = codeBlock.previousElementSibling.previousElementSibling;
                            const { left, top } = node.getBoundingClientRect();
                            this.clEditor.rebaseSelectionByPixel(left + gutter.offsetWidth, top);
                            this.clEditor.focus();
                            this.focus = "editorContentEditable";
                            return;
                        }
                        const text = editor.getValue();
                        const lines = text.match(/[\r\n]/g).length;
                        if (e.code == "ArrowDown" && lastCursPos.lineNumber >= lines + 1) {
                            e.preventDefault();
                            const node = codeBlock.nextElementSibling;
                            const { left, top } = node.getBoundingClientRect();
                            this.clEditor.rebaseSelectionByPixel(left + gutter.offsetWidth, top);
                            this.clEditor.focus();
                            this.focus = "editorContentEditable";
                            return;
                        }
                    })
                ];
                editor['_dispose'] = () => {
                    rsObserver.disconnect();
                    disposables.forEach(d => d.dispose());
                    editor.dispose();
                };
                this.overlay1.appendChild(monacoContainer);
            });
        });
    }
    /**
     * Get an object describing the position of the scroll bar in the file.
     */
    getScrollPosition(elt) {
        const dimensionKey = elt === this.editorElt
            ? 'editorDimension'
            : 'previewDimension';
        const { scrollTop } = dimensionKey == "editorDimension" ? elt.parentElement.parentElement : elt.parentElement.parentElement.parentElement;
        let result;
        this.previewCtxMeasured?.sectionDescList.find((sectionDesc, sectionIdx) => {
            if (!sectionDesc[dimensionKey])
                return false;
            if (scrollTop >= (sectionDesc[dimensionKey].topOffset + sectionDesc[dimensionKey].height)) {
                return false;
            }
            const posInSection = (scrollTop - sectionDesc[dimensionKey].topOffset) /
                (sectionDesc[dimensionKey].height || 1);
            result = {
                sectionDesc,
                sectionIdx,
                posInSection
            };
            return true;
        });
        return result;
    }
    /**
     * Restore the scroll position from the current file content state.
     */
    restoreScrollPosition(scrollPosition) {
        const sectionDesc = this.previewCtxMeasured?.sectionDescList[scrollPosition?.sectionIdx];
        if (!sectionDesc)
            return;
        const editorScroller = this.editorElt.parentElement.parentElement;
        const previewScroller = this.previewElt.parentElement.parentElement.parentElement;
        const editorScrollTop = sectionDesc.editorDimension.topOffset +
            (sectionDesc.editorDimension.height * scrollPosition.posInSection);
        editorScroller.scrollTo(0, editorScrollTop);
        const previewScrollTop = sectionDesc.previewDimension.topOffset +
            (sectionDesc.previewDimension.height * scrollPosition.posInSection);
        previewScroller.scrollTo(0, previewScrollTop);
    }
    /**
     * Get the offset in the preview corresponding to the offset of the markdown in the editor
     * @unused
     */
    getPreviewOffset(editorOffset, sectionDescList = (this.previewCtxWithDiffs || {}).sectionDescList) {
        if (!sectionDescList) {
            return null;
        }
        let offset = editorOffset;
        let previewOffset = 0;
        sectionDescList.find((sectionDesc) => {
            if (!sectionDesc.textToPreviewDiffs) {
                previewOffset = null;
                return true;
            }
            if (sectionDesc.section.text.length >= offset) {
                previewOffset += this.diffMatchPatch.diff_xIndex(sectionDesc.textToPreviewDiffs, offset);
                return true;
            }
            offset -= sectionDesc.section.text.length;
            previewOffset += sectionDesc.previewText.length;
            return false;
        });
        return previewOffset;
    }
    /**
     * Get the offset of the markdown in the editor corresponding to the offset in the preview
     * @unused
     */
    getEditorOffset(previewOffset, sectionDescList = (this.previewCtxWithDiffs || {}).sectionDescList) {
        if (!sectionDescList) {
            return null;
        }
        let offset = previewOffset;
        let editorOffset = 0;
        sectionDescList.find((sectionDesc) => {
            if (!sectionDesc.textToPreviewDiffs) {
                editorOffset = null;
                return true;
            }
            if (sectionDesc.previewText.length >= offset) {
                const previewToTextDiffs = sectionDesc.textToPreviewDiffs
                    .map(diff => [-diff[0], diff[1]]);
                editorOffset += this.diffMatchPatch.diff_xIndex(previewToTextDiffs, offset);
                return true;
            }
            offset -= sectionDesc.previewText.length;
            editorOffset += sectionDesc.section.text.length;
            return false;
        });
        return editorOffset;
    }
    /**
     * Get the coordinates of an offset in the preview
     * @unused
     *
     * ! Was used by discussions
     */
    getPreviewOffsetCoordinates(offset) {
        // TODO:
        const start = findContainer(this.previewElt, offset && offset - 1);
        const end = findContainer(this.previewElt, offset || offset + 1);
        const range = document.createRange();
        range.setStart(start.container, start.offsetInContainer);
        range.setEnd(end.container, end.offsetInContainer);
        const rect = range.getBoundingClientRect();
        const contentRect = this.previewElt.getBoundingClientRect();
        return {
            top: Math.round((rect.top - contentRect.top) + this.previewElt.scrollTop),
            height: Math.round(rect.height),
            left: Math.round((rect.right - contentRect.left) + this.previewElt.scrollLeft),
        };
    }
    /**
     * Scroll the preview (or the editor if preview is hidden) to the specified anchor
     * @unused
     */
    scrollToAnchor(anchor) {
        let scrollTop = 0;
        const scrollerElt = this.previewElt.parentElement.parentElement.parentElement;
        const elt = document.getElementById(anchor);
        if (!elt)
            return;
        scrollTop = Math.min(Math.max(elt.offsetTop, 0));
        const maxScrollTop = scrollerElt.scrollHeight - scrollerElt.offsetHeight;
        if (scrollTop < 0) {
            scrollTop = 0;
        }
        else if (scrollTop > maxScrollTop) {
            scrollTop = maxScrollTop;
        }
    }
    /**
     * Initialize the cledit editor with markdown-it section parser and Prism highlighter
     */
    initClEditor() {
        this.previewCtxMeasured = null;
        this.$trigger('previewCtxMeasured', null);
        this.previewCtxWithDiffs = null;
        this.$trigger('previewCtxWithDiffs', null);
        this.clEditor.init();
        this.restoreScrollPosition();
    }
    /**
     * Finish the conversion initiated by the section parser
     */
    convert() {
        this.conversionCtx = markdownConversionSvc.convert(this.parsingCtx, this.conversionCtx);
        this.$trigger('conversionCtx', this.conversionCtx);
        this.tokens = this.parsingCtx.markdownState?.tokens;
    }
    /**
     * Refresh the preview with the result of `convert()`
     */
    async refreshPreview() {
        const sectionDescList = [];
        let sectionIdx = 0;
        let sectionDescIdx = 0;
        let insertBeforePreviewElt = this.previewElt.firstChild;
        let insertBeforeTocElt = this.tocElt.firstChild;
        let previewHtml = '';
        let loadingImages = [];
        this.conversionCtx.htmlSectionDiff.forEach((item) => {
            if (!item)
                return;
            for (let i = 0; i < item[1]?.length; i++) {
                const section = this.conversionCtx.sectionList?.[sectionIdx];
                // In rare cases sections may fail to render and cause
                // the editor to spit out errors
                if (!item || !section)
                    continue;
                if (item[0] === 0) {
                    let sectionDesc = this.previewCtx.sectionDescList?.[sectionDescIdx];
                    // ??? This occurs sometimes
                    if (!sectionDesc)
                        continue;
                    // Trigger a resize event
                    sectionDesc.section?.monaco?.['_resize']();
                    sectionDescIdx++;
                    if (sectionDesc.editorElt !== section.elt) {
                        // Force textToPreviewDiffs computation
                        sectionDesc = new SectionDesc(section, sectionDesc.previewElt, sectionDesc.tocElt, sectionDesc.html);
                    }
                    sectionDescList.push(sectionDesc);
                    previewHtml += sectionDesc.html;
                    sectionIdx++;
                    insertBeforePreviewElt = insertBeforePreviewElt.nextSibling;
                    insertBeforeTocElt = insertBeforeTocElt.nextSibling;
                }
                else if (item[0] === -1) {
                    let sectionDesc = this.previewCtx.sectionDescList[sectionDescIdx];
                    // Dispose an injected monaco editor
                    sectionDesc?.section?.monaco?.['_dispose']();
                    sectionDescIdx++;
                    const sectionPreviewElt = insertBeforePreviewElt;
                    insertBeforePreviewElt = insertBeforePreviewElt.nextSibling;
                    this.previewElt.removeChild(sectionPreviewElt);
                    const sectionTocElt = insertBeforeTocElt;
                    insertBeforeTocElt = insertBeforeTocElt.nextSibling;
                    this.tocElt.removeChild(sectionTocElt);
                }
                else if (item[0] === 1) {
                    // const html = dompurify.sanitize(this.conversionCtx.htmlSectionList[sectionIdx], {
                    //     // URIs should always follow this format
                    //     ALLOWED_URI_REGEXP: /.*/i
                    //     // ALLOWED_URI_REGEXP: /^(?:(?:(?:f|ht)tps?|mailto|tel|callto|cid|xmpp|xxx):|[^a-z]|[a-z+.\-]+(?:[^a-z+.\-:]|$))/i
                    //     // ALLOWED_URI_REGEXP: /^(?<url>(?<host>(?<protocol>[A-Za-z]{3,9}:(?:\/\/)?)?(?<domain>(?:[a-z]+\.|[-;:&=\+\$,\w]+@)[A-Za-z0-9.\-:]+))?(?<path>(?:\/[\+~%\/.\w_\-]*)?\??(?:[\-\+=&;%@.\w_\/\[\] ]*)#?(?:[\w]*))?)/i
                    // });
                    let markdown = this.conversionCtx.htmlSectionList[sectionIdx];
                    // Run all before render hooks against the text
                    this.ngEditor.hooks?.filter(h => h?.kind == "beforeRender")
                        .forEach(hook => {
                        markdown = hook.fn(markdown);
                    });
                    const html = this.ngEditor.sanitizer.sanitize(SecurityContext.HTML, markdown);
                    sectionIdx++;
                    // Create preview section element
                    const sectionPreviewElt = document.createElement('div');
                    sectionPreviewElt.className = 'cl-preview-section';
                    sectionPreviewElt.innerHTML = html;
                    if (insertBeforePreviewElt) {
                        this.previewElt.insertBefore(sectionPreviewElt, insertBeforePreviewElt);
                    }
                    else {
                        this.previewElt.appendChild(sectionPreviewElt);
                    }
                    // Go through all extensions and render their HTML for the section
                    this.sectionPreview(sectionPreviewElt, this.ngEditor.options.markdownIt, true);
                    // Make some anchors external links
                    [...sectionPreviewElt.querySelectorAll('a')].forEach(el => {
                        const url = el.getAttribute('href');
                        // Make external links open in a new tab.
                        if (/^((https?|ftps?|ssh|wss?):\/\/|mailto:)/.test(url))
                            el.setAttribute("target", '_blank');
                    });
                    loadingImages = [
                        ...loadingImages,
                        ...Array.prototype.slice.call(sectionPreviewElt.getElementsByTagName('img')),
                    ];
                    // Create TOC section element
                    const sectionTocElt = document.createElement('div');
                    sectionTocElt.className = 'cl-toc-section';
                    const headingElt = sectionPreviewElt.querySelector('h1, h2, h3, h4, h5, h6');
                    sectionTocElt.onclick = () => {
                        sectionPreviewElt.scrollIntoView();
                        sectionPreviewElt.classList.add('focus-highlight');
                        sectionPreviewElt.style.setProperty('--focus-highlight-background-color', '#69f0ae88');
                        setTimeout(() => {
                            sectionPreviewElt.style.setProperty('--focus-highlight-background-color', '#0000');
                            setTimeout(() => {
                                sectionPreviewElt.classList.remove('focus-highlight');
                            }, 600);
                        }, 200);
                    };
                    if (headingElt) {
                        const clonedElt = headingElt.cloneNode(true);
                        clonedElt.removeAttribute('id');
                        sectionTocElt.appendChild(clonedElt);
                    }
                    if (insertBeforeTocElt) {
                        this.tocElt.insertBefore(sectionTocElt, insertBeforeTocElt);
                    }
                    else {
                        this.tocElt.appendChild(sectionTocElt);
                    }
                    previewHtml += html;
                    sectionDescList.push(new SectionDesc(section, sectionPreviewElt, sectionTocElt, html));
                }
            }
            // Mark the item as having been rastered
            // to prevent duplicate sections from being added
            item[0] = 0;
        });
        this.tocElt.classList[this.tocElt.querySelector('.cl-toc-section *') ? 'remove' : 'add']('toc-tab--empty');
        this.previewCtx = {
            markdown: this.conversionCtx.text,
            html: previewHtml.replace(/^\s+|\s+$/g, ''),
            text: this.previewElt.textContent,
            sectionDescList: sectionDescList,
        };
        this.$trigger('previewCtx', this.previewCtx);
        this.makeTextToPreviewDiffs();
        // Wait for images to load
        const loadedPromises = loadingImages.map(imgElt => new Promise((resolve) => {
            if (!imgElt.src) {
                resolve();
                return;
            }
            const img = new Image();
            img.onload = resolve;
            img.onerror = resolve;
            img.src = imgElt.src;
        }));
        await Promise.all(loadedPromises);
        // Debounce if sections have already been measured
        this.measureSectionDimensions(!!this.previewCtxMeasured, true);
    }
    /**
     * Refresh the stored heights of the preview
     * and editor elements
     */
    refreshScrollSync = (() => {
        this.refreshPreview();
        // this.measureSectionDimensions(false, true);
        // Trigger a scroll event
        this.editorElt.scrollBy(0, 0);
    }).bind(this);
    /**
     * Measure the height of each section in editor, preview and toc.
     */
    measureSectionDimensions = allowDebounce((restoreScrollPosition = false, force = false) => {
        if (!force && this.previewCtx === this.previewCtxMeasured)
            return;
        sectionUtils.measureSectionDimensions(this);
        this.previewCtxMeasured = this.previewCtx;
        if (restoreScrollPosition) {
            this.restoreScrollPosition();
        }
        this.sectionList?.forEach(s => s.monaco?.['_resize']());
        this.$trigger('previewCtxMeasured', this.previewCtxMeasured);
    }, 500);
    /**
     * Compute the diffs between editor's markdown and preview's html
     * asynchronously unless there is only one section to compute.
     */
    makeTextToPreviewDiffs() {
        if (this.previewCtx !== this.previewCtxWithDiffs) {
            const makeOne = () => {
                let hasOne = false;
                const hasMore = this.previewCtx.sectionDescList
                    .some((sectionDesc) => {
                    if (!sectionDesc.textToPreviewDiffs) {
                        if (hasOne) {
                            return true;
                        }
                        if (!sectionDesc.previewText) {
                            sectionDesc.previewText = sectionDesc.previewElt.textContent;
                        }
                        sectionDesc.textToPreviewDiffs = this.diffMatchPatch.diff_main(sectionDesc.section.text, sectionDesc.previewText);
                        hasOne = true;
                    }
                    return false;
                });
                if (hasMore) {
                    setTimeout(() => makeOne(), 5);
                }
                else {
                    this.previewCtxWithDiffs = this.previewCtx;
                    this.$trigger('previewCtxWithDiffs', this.previewCtxWithDiffs);
                }
            };
            makeOne();
        }
    }
}

class KeyCommands {
    element;
    commandPalette;
    stackEditor;
    dialog;
    get editor() { return this.stackEditor.editorSvc.clEditor; }
    get wrapSelection() {
        return this.editor.wrapSelection.bind(this.editor);
    }
    actions = new EditorActions();
    constructor(element, commandPalette, stackEditor, dialog) {
        this.element = element;
        this.commandPalette = commandPalette;
        this.stackEditor = stackEditor;
        this.dialog = dialog;
        commandPalette.initialize({
            keybind: "ctrl+p"
        });
        commandPalette.attachElementCommands(element, this.commands);
        this.actions.stackEditor = stackEditor;
        this.actions.dialog = dialog;
    }
    dispose() {
        this.commandPalette.detachElementCommands(this.element, this.commands);
    }
    commands = [
        {
            label: "Insert Comment",
            shortcutKey: "ctrl+slash",
            action: this.actions.insertComment.bind(this)
        },
        {
            label: "Bold Text",
            shortcutKey: "ctrl+b",
            action: this.actions.boldText.bind(this)
        },
        // {
        //     label: "Bold",
        //     shortcutKey: "ctrl+*",
        //     action: () => this.wrapSelection("**", "**")
        // },
        // {
        //     label: "Italic",
        //     shortcutKey: "ctrl+i",
        //     ctrl: true,
        //     action: this.italicizeText.bind(this)
        // },
        // {
        //     label: "Bold",
        //     shortcutKey: "ctrl+_",
        //     ctrl: true,
        //     action: this.italicizeText.bind(this)
        // },
        // {
        //     label: "Select All",
        //     key: "/",
        //     ctrl: true
        // action: this.insertComment.bind(this)
        // }
        {
            label: "Select Line",
            shortcutKey: "ctrl+l",
            action: () => {
                const text = this.editor.getContent();
                const { selectionStart, selectionEnd } = this.editor.selectionMgr;
                // select the current line
                if (selectionStart == selectionEnd) {
                    const line = this.editor.getLine(selectionStart, text);
                    this.editor.selectionMgr.setSelection(line.lineStart, line.lineEnd);
                }
                // Expand the selection to the start of the first line, and the end of the last line
                // If that is already the case, select the next line below the end.
                else {
                    const startLine = this.editor.getLine(selectionStart, text);
                    const endLine = this.editor.getLine(selectionEnd, text);
                    // Select the next line below the selection
                    if (startLine.lineStart == selectionStart && endLine.lineEnd == selectionEnd) {
                        const nextLine = this.editor.getLine(endLine.lineEnd + 1, text);
                        this.editor.selectionMgr.setSelection(startLine.lineStart, nextLine.lineEnd);
                    }
                    // Expand the selection to the start and end of the first and last lines.
                    else {
                        this.editor.selectionMgr.setSelection(startLine.lineStart, endLine.lineEnd);
                    }
                }
            }
        },
        {
            label: "Duplicate Current Line",
            shortcutKey: "ctrl+shift+d",
            action: () => {
                const text = this.editor.getContent();
                const { selectionStart, selectionEnd } = this.editor.selectionMgr;
                // Duplicate the current line
                if (selectionStart == selectionEnd) {
                    const line = this.editor.getLine(selectionStart, text);
                    const copy = '\n' + line.line;
                    const patched = text.slice(0, line.lineEnd) + copy + text.slice(line.lineEnd);
                    this.editor.setContent(patched);
                    // Run this on the next tick to give the browser time to settle things
                    // Observe an issue on duplicating content at the last line.
                    setTimeout(() => {
                        this.editor.setSelection(selectionStart + copy.length, selectionEnd + copy.length);
                    });
                }
                // Expand the selection to the start of the first line, and the end of the last line
                // Duplicate the contents through the start and the end.
                else {
                    const startLine = this.editor.getLine(selectionStart, text);
                    const endLine = this.editor.getLine(selectionEnd, text);
                    const copyLines = '\n' + text.slice(startLine.lineStart, endLine.lineEnd);
                    const patched = text.slice(0, endLine.lineEnd) + copyLines + text.slice(endLine.lineEnd);
                    this.editor.setContent(patched);
                    // Run this on the next tick to give the browser time to settle things
                    // Observe an issue on duplicating content at the last line.
                    setTimeout(() => {
                        this.editor.setSelection(selectionStart + copyLines.length, selectionEnd + copyLines.length);
                    });
                }
            }
        }
    ];
}

const defaults = {
    markdownIt: {
        "emoji": true,
        "emojiShortcuts": false,
        "abc": true,
        "math": true,
        "abbr": true,
        "breaks": true,
        "deflist": true,
        "del": true,
        "fence": true,
        "footnote": true,
        "imgsize": true,
        "linkify": true,
        "mark": true,
        "sub": true,
        "sup": true,
        "table": true,
        "tasklist": true,
        "typographer": true,
        "mermaid": true,
    }
};
const NGX_STACKEDIT_CONFIG = new InjectionToken('stackedit-config');
class ImageComponent {
    url;
    dialog;
    constructor(url, dialog) {
        this.url = url;
        this.dialog = dialog;
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "17.1.1", ngImport: i0, type: ImageComponent, deps: [{ token: MAT_DIALOG_DATA }, { token: i1.MatDialogRef }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "17.1.1", type: ImageComponent, isStandalone: true, selector: "ngx-stackedit-img-dialog", ngImport: i0, template: '<img [src]="url" (click)="dialog.close()">', isInline: true, styles: [":host{max-width:min(90vh,90vw);max-height:min(90vh,90vw)}img{border-radius:6px}\n"] });
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "17.1.1", ngImport: i0, type: ImageComponent, decorators: [{
            type: Component,
            args: [{ selector: 'ngx-stackedit-img-dialog', template: '<img [src]="url" (click)="dialog.close()">', standalone: true, styles: [":host{max-width:min(90vh,90vw);max-height:min(90vh,90vw)}img{border-radius:6px}\n"] }]
        }], ctorParameters: () => [{ type: undefined, decorators: [{
                    type: Inject,
                    args: [MAT_DIALOG_DATA]
                }] }, { type: i1.MatDialogRef }] });
class StackEditorComponent {
    viewContainer;
    lazyLoader;
    commandPalette;
    themeService;
    dialog;
    matDialog;
    sanitizer;
    config;
    toolbar;
    get $el() { return this.viewContainer.element.nativeElement; }
    /**
     * Dictates the theme of the editor.
     */
    theme;
    /**
     * What mode should the editor be in.
     * - Possible values are `edit` | `view` | `viewonly`
     * - Default `edit`
     * view mode **disables** the editor view & toolbar.
     */
    mode = "edit";
    /**
     * Should the table of contents be viewable?
     * `true` shown by default
     * `false` hidden by default
     * `"off"` disable the TOC altogether
     *
     * Default `false`
     */
    showToc = false;
    /**
     * Controls whether the preview is open on initialization
     * `true` visible
     * `false` hidden
     * `"off"` disabled
     * Default `true`
     */
    showPreview = true;
    /**
     * Controls whether a "run" button is shown for applicable
     * code blocks in the editor view.
     */
    showCodeRunButton = false;
    /**
     * Control the execution runtime for code blocks.
     * > only valid for `showCodeRunButton` = true.
     * - If set to `eval`, only javascript code blocks will have a run button
     * - If set to `piston`, a HTTP request will be made to check the
     *     available runtimes
     *  - If set to `custom`, you need to define the runnable languages in
     *     `customCodeLanguages` and hook onto `onCustomCodeExecute`.
     */
    codeRunner = null;
    /**
     * If `codeRunner` is set to true
     */
    customCodeLanguages = [];
    /**
     * Controls whether a "copy" button is shown for applicable
     * code blocks in the editor view.
     */
    showCodeCopyButton = true;
    /**
     * Controls whether the mermaid insert button is visible
     * `true` visible
     * `false` hidden
     * Default `true`
     */
    showMermaid = true;
    showLineNumbers = false;
    allowImageUpload = true;
    tabSize = 4;
    tabChar = ' ';
    /**
     * ! WIP -- this feature is not supported
     * Hide punctuation markings in the editor
     *
     * This requires improved editor table, mermaid,
     * and code block rendering
     */
    hideWritingSymbols = false;
    /**
     * Event hooks that may be provided to perform mutations
     */
    hooks = [];
    _value = '';
    /**
     * Initial value of the editor.
     * 2-way binding capable.
     */
    set value(value) {
        this._value = value;
        if (this.editorSvc) {
            this.editorSvc.clEditor.setContent(value, true);
        }
    }
    get value() { return this._value; }
    ;
    /**
     * Emits when the value of the editor changed.
     * Can be used standalone or in 2-way binding.
     */
    valueChange = new EventEmitter();
    /**
     * Emits when a file is pasted and needs to be uploaded.
     */
    onFileUpload = new EventEmitter();
    /**
     * Emits when the user uploads an image via file upload.
     */
    onImageUpload = new EventEmitter();
    /**
     *
     */
    onCustomCodeExecute = new EventEmitter();
    editorSvc;
    options = {};
    resizeChecker;
    width = 0;
    height = 0;
    subscriptions;
    keyCommands;
    constructor(viewContainer, lazyLoader, commandPalette, themeService, dialog, matDialog, sanitizer, config = {}) {
        this.viewContainer = viewContainer;
        this.lazyLoader = lazyLoader;
        this.commandPalette = commandPalette;
        this.themeService = themeService;
        this.dialog = dialog;
        this.matDialog = matDialog;
        this.sanitizer = sanitizer;
        this.config = config;
        this.options = {
            ...defaults,
            ...config
        };
        this.subscriptions = [
            this.themeService.subscribe(t => {
                window['monaco']?.editor.setTheme(t == "dark" ? "vs-dark" : "vs");
            })
        ];
        lazyLoader.registerComponent({
            id: "image-editor",
            group: "@dotglitch",
            load: () => import('./ngx-stackedit-image-editor.component-xwGLjlWw.mjs')
        });
    }
    ngOnChanges() {
        if (this.theme)
            this.themeService.setTheme(this.theme);
    }
    async ngAfterViewInit() {
        installMonaco();
        // This is only active in tauri mode.
        if (this.codeRunner == "piston") {
            await window['root']?.utils.getPistonRuntimes()
                .catch(e => null);
        }
        await waitForMonacoInstall();
        // This is replaced during automation.
        this.$el.setAttribute("version", "1.1.73");
        const editorElt = this.$el.querySelector('.editor');
        const previewElt = this.$el.querySelector('.preview__inner');
        const tocElt = this.$el.querySelector('.toc__inner');
        this.editorSvc = new Editor(this, editorElt, previewElt, tocElt);
        this.toolbar.bindEditorEvents();
        this.keyCommands = new KeyCommands(editorElt, this.commandPalette, this, this.matDialog);
        // Bind the 'value' property
        this.editorSvc.on("loaded", () => {
            this.editorSvc.clEditor.setContent(this.value);
            this.editorSvc.clEditor.on('contentChanged', (content, diffs, sectionList) => {
                this.valueChange.next(content);
            });
        });
        this.resizeChecker = setInterval(() => {
            if (this.height != 0 && this.height != this.$el.clientHeight ||
                this.width != 0 && this.width != this.$el.clientWidth) {
                this.triggerResize();
            }
            this.height = this.$el.clientHeight;
            this.width = this.$el.clientWidth;
        }, 300);
    }
    ngOnDestroy() {
        clearInterval(this.resizeChecker);
        this.subscriptions.forEach(s => s.unsubscribe());
        this.editorSvc?.destroy();
    }
    finalizeImageUpload({ label, link }) {
        const text = `![${label}](${link})`;
        this.editorSvc.clEditor.replaceAll(/```img-spinner```/gs, text);
    }
    triggerResize() {
    }
    toggleEditor() {
        this.mode = this.mode == 'view' ? 'edit' : 'view';
        if (this.mode == 'view' && !this.showPreview)
            this.showPreview = !this.showPreview;
    }
    onPointerDown(e) {
        if (e.target instanceof HTMLImageElement) {
            this.matDialog.open(ImageComponent, { data: e.target.src });
        }
    }
    static ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "17.1.1", ngImport: i0, type: StackEditorComponent, deps: [{ token: i0.ViewContainerRef }, { token: i2$1.LazyLoaderService }, { token: i2$1.CommandPaletteService }, { token: i2$1.ThemeService }, { token: i2$1.DialogService }, { token: i1.MatDialog }, { token: i3$1.DomSanitizer }, { token: NGX_STACKEDIT_CONFIG, optional: true }], target: i0.ɵɵFactoryTarget.Component });
    static ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "17.0.0", version: "17.1.1", type: StackEditorComponent, isStandalone: true, selector: "ngx-stackedit", inputs: { theme: "theme", mode: "mode", showToc: "showToc", showPreview: "showPreview", showCodeRunButton: "showCodeRunButton", codeRunner: "codeRunner", customCodeLanguages: "customCodeLanguages", showCodeCopyButton: "showCodeCopyButton", showMermaid: "showMermaid", showLineNumbers: "showLineNumbers", allowImageUpload: "allowImageUpload", tabSize: "tabSize", tabChar: "tabChar", hideWritingSymbols: "hideWritingSymbols", hooks: "hooks", value: "value" }, outputs: { valueChange: "valueChange", onFileUpload: "onFileUpload", onImageUpload: "onImageUpload", onCustomCodeExecute: "onCustomCodeExecute" }, host: { listeners: { "pointerdown": "onPointerDown($event)" } }, viewQueries: [{ propertyName: "toolbar", first: true, predicate: ToolbarComponent, descendants: true }], usesOnChanges: true, ngImport: i0, template: "<app-toolbar [style.flex]=\"'0 0 ' + (mode == 'edit' ? 44 : 0) + 'px'\"></app-toolbar>\n\n@if (mode == 'view') {\n    <mat-icon\n        class=\"edit_btn\"\n        (mousedown)=\"toggleEditor(); $event.preventDefault()\"\n        matTooltip=\"Edit Description\"\n    >\n        edit\n    </mat-icon>\n}\n\n<div\n    class=\"contents\"\n>\n    <ng-scrollbar\n        class=\"editor-container\"\n        [class.hidden]=\"mode != 'edit'\"\n        [class.expand]=\"showPreview == 'off' || !showPreview\"\n        [class.show-toc]=\"showToc && showToc != 'off'\"\n        style=\"background-color: var(--editor-background-color); cursor: text\"\n        (click)=\"editorSvc.clEditor.focus()\"\n    >\n        <div\n            class=\"editor markdown-highlighting\"\n            style=\"width: 100%\"\n            [class.linenumbers]=\"showLineNumbers\"\n        >\n            <div class=\"editor-underlay\"></div>\n            <div class=\"editor-inner\"></div>\n            <div class=\"editor-overlay-1\"></div>\n            <div class=\"editor-overlay-2\"></div>\n        </div>\n    </ng-scrollbar>\n\n    <ng-scrollbar\n        class=\"preview-container\"\n        [class.hidden]=\"showPreview == 'off' || !showPreview\"\n        [class.expand]=\"mode != 'edit'\"\n        [class.show-toc]=\"showToc && showToc != 'off'\"\n        style=\"background-color: var(--preview-background-color)\"\n    >\n        <div\n            class=\"preview\"\n            style=\"width: 100%\"\n        >\n            <div class=\"preview__inner\"></div>\n        </div>\n    </ng-scrollbar>\n\n    <!-- TODO: -->\n    <ng-scrollbar\n        class=\"toc-container\"\n        [style.width]=\"(showToc == 'off' || !showToc)  ? '0px' : '240px'\"\n    >\n        <div\n            class=\"toc\"\n        >\n            <div class=\"toc__inner\"></div>\n        </div>\n    </ng-scrollbar>\n</div>\n\n<!-- <app-statusbar [style.flex]=\"'0 0 ' + (mode != 'viewonly' ? 22 : 0) + 'px'\"></app-statusbar> -->\n", styles: [":host{display:flex;flex-direction:column;width:100%;height:100%;overflow:hidden}::ng-deep :root{--primary-color: #0c93e4;--stackedit-font-family: \"Fira Sans\", Arial;--stackedit-font-family-mono: \"Fira Mono\", \"Droid Sans Mono\", \"monospace\", monospace}::ng-deep .ngx-menu.mermaid-menu .mat-mdc-dialog-container .mdc-dialog__surface{background-color:var(--editor-background-color)}::ng-deep .dark{--editor-background-color: #1f1f1f;--preview-background-color: #1f2123;--text-color: #efefef;--text-header-color: #ceceff;--selection-color: #264f78;--code-background-color: #2b2b2b;--blockquote-background-color: #2b2b2b;--table-header-color: #0d47a1;--table-row-alt-color: #222;--table-row-hover-color: #444;--table-column-hover-color: #444;--md-border-color: #474747;--md-header-border-color: #000;--md-blockquote-color: #aaa;--md-blockquote-border-color: hsla(0, 0%, 100%, .1);--md-anchor-color: var(--primary-color);--prism-tag-color: #569cd6;--prism-property-color: #9cdcfe;--prism-punctuation-color: #808080;--prism-attribute-color: #ce9178;--prism-attribute-punctuation-color: #fff;--prism-attribute-value-color: #ce9178;--prism-attribute-value-punctuation-color: #fff;--prism-number-color: #b5cea8;--prism-comment-color: #6a9955;--prism-string-color: #ce9178;--prism-function-color: #dcdcaa;--prism-type-color: #4ec9b0;--prism-boolean-color: #569cd6;--prism-this-color: #569cd6;--prism-modifier-color: #569cd6;--prism-selector-color: #d7ba7d;--prism-builtin-color: #9cdcfe;--prism-ts-keyword-color: #c586c0;--prism-ts-punctuation-color: #ccc;--prism-url-color: #569cd6;--prism-table-header-color: #d7ba7d}::ng-deep .dark *::selection{background-color:#3a3d41!important}::ng-deep .dark *:focus *::selection{background-color:#264f78!important}::ng-deep .light{--editor-background-color: #ffffff;--preview-background-color: #f3f3f3;--text-color: #121212;--text-header-color: #121244;--selection-color: #42a5f5;--code-background-color: #ebebeb;--blockquote-background-color: #ebebeb;--table-header-color: #42a5f5;--table-row-alt-color: #f3f3f3;--table-row-hover-color: #ddd;--table-column-hover-color: #ddd;--md-border-color: #dcdcdc;--md-header-border-color: #fff;--md-blockquote-color: #444;--md-blockquote-border-color: rgba(0, 0, 0, .1);--md-anchor-color: var(--primary-color);--prism-tag-color: #800000;--prism-property-color: #e50000;--prism-punctuation-color: #800000;--prism-attribute-color: #0000ff;--prism-attribute-punctuation-color: #3b3b3b;--prism-attribute-value-color: #0000ff;--prism-attribute-value-punctuation-color: #3b3b3b;--prism-number-color: #098658;--prism-comment-color: #008000;--prism-string-color: #a31515;--prism-function-color: #795e26;--prism-type-color: #267f99;--prism-boolean-color: #0000ff;--prism-this-color: #0000ff;--prism-modifier-color: #0000ff;--prism-selector-color: #800000;--prism-builtin-color: #800000;--prism-ts-keyword-color: #af00db;--prism-ts-punctuation-color: #333;--prism-url-color: #0000ff;--prism-table-header-color: #800000}::ng-deep .light *::selection{background-color:#e5ebf1!important}::ng-deep .light *:focus *::selection{background-color:#add6ff!important}.contents{display:flex;flex:1;height:100%;width:100%;overflow:hidden;position:relative}.edit_btn{position:absolute;top:4px;right:4px;z-index:1}ng-scrollbar{width:100%;overflow:hidden}:host ::ng-deep{--line-height: 24px}:host ::ng-deep .editor-container,:host ::ng-deep .preview-container{width:calc(50% - 1px);position:absolute;transition:width .2s ease,left .2s ease,right .2s ease;contain:content}:host ::ng-deep .editor-container.expand,:host ::ng-deep .preview-container.expand{width:100%}:host ::ng-deep .editor-container.expand.show-toc,:host ::ng-deep .preview-container.expand.show-toc{width:calc(100% - 240px)}:host ::ng-deep .editor-container.show-toc,:host ::ng-deep .preview-container.show-toc{width:calc(50% - 121px)}:host ::ng-deep .editor-container{left:0}:host ::ng-deep .editor-container .hide{display:none}:host ::ng-deep .editor-container.hidden{left:-50%}:host ::ng-deep .preview-container{right:0}:host ::ng-deep .preview-container.hidden{right:-50%}:host ::ng-deep .preview-container.show-toc:not(.hidden){right:240px}:host ::ng-deep .toc-container{position:absolute;transition:width .2s ease;right:0;width:240px}:host ::ng-deep .toc-container.hidden{right:-240px}:host ::ng-deep .editor{font-family:var(--stackedit-font-family-mono);flex-direction:column;padding:10px 24px 0;margin:0;white-space:pre-wrap;word-break:break-word;word-wrap:break-word;height:100%}:host ::ng-deep .editor>div{max-width:960px;margin:0 auto}:host ::ng-deep .editor.linenumbers{padding:10px 24px 38px 64px}:host ::ng-deep .editor.linenumbers .lf:before{content:attr(data-linenumber);position:absolute;left:6px;color:#6e7681;font-family:var(--stackedit-font-family-mono)}:host ::ng-deep .editor.monospaced{font-family:var(--stackedit-font-family-mono);font-size:.85em!important}:host ::ng-deep .editor.monospaced *{font-size:inherit!important}:host ::ng-deep .editor img::selection{background-color:var(--selection-color)}:host ::ng-deep .editor *{line-height:var(--line-height, 1.4)}:host ::ng-deep .editor .colorpicker-color-decoration,:host ::ng-deep .editor .hc-light .colorpicker-color-decoration{line-height:.8em}:host ::ng-deep .editor .cledit-section{font-family:var(--stackedit-font-family-mono)}:host ::ng-deep .editor .cledit-section span{display:inline}:host ::ng-deep .editor .cledit-section .injection-portal{contain:content;overflow:auto}:host ::ng-deep .editor .cledit-section .injection-portal>div{display:flex;flex-direction:column}:host ::ng-deep .editor .cledit-section .injection-portal div{display:block}:host ::ng-deep .editor .editor-underlay,:host ::ng-deep .editor .editor-overlay-1,:host ::ng-deep .editor .editor-overlay-2{position:absolute;top:0;right:0;left:0}:host ::ng-deep .editor .editor-inner{min-height:100%}:host ::ng-deep .editor .code-block{display:block!important;overflow:hidden;white-space:pre;padding-bottom:calc(19px + var(--line-height));line-height:var(--line-height)}:host ::ng-deep .editor .editor-overlay-1 .monaco-container{position:absolute;display:block}:host ::ng-deep .editor .editor-overlay-1 .monaco-container mat-icon{position:absolute;top:4px;right:4px;padding:6px;z-index:1;font-size:20px;background-color:var(--blockquote-background-color);border-radius:50%;opacity:.4;transition:opacity .2s ease;cursor:pointer}:host ::ng-deep .editor .editor-overlay-1 .monaco-container mat-icon:hover{opacity:1}:host ::ng-deep .editor .editor-overlay-1 .monaco-container .run-button{right:44px}:host ::ng-deep .editor .editor-overlay-1 .monaco-editor{border-radius:6px}:host ::ng-deep .editor .editor-overlay-1 .monaco-editor .overflow-guard .margin,:host ::ng-deep .editor .editor-overlay-1 .monaco-editor .margin-view-overlays{border-bottom-left-radius:6px;border-top-left-radius:6px}:host ::ng-deep .editor .editor-overlay-1 .monaco-editor .monaco-scrollable-element.editor-scrollable,:host ::ng-deep .editor .editor-overlay-1 .monaco-editor .view-lines.monaco-mouse-cursor-text,:host ::ng-deep .editor .editor-overlay-1 .monaco-editor .decorationsOverviewRuler{border-bottom-right-radius:6px;border-top-right-radius:6px}:host ::ng-deep .preview{line-height:24px;height:100%}:host ::ng-deep .preview .cl-preview-section{min-width:100%;overflow-x:auto;position:relative}:host ::ng-deep .preview .cl-preview-section pre[class^=language]{position:relative}:host ::ng-deep .preview .cl-preview-section mat-icon{position:absolute;top:4px;right:4px;padding:6px;font-size:20px;z-index:1;background-color:var(--blockquote-background-color);border-radius:50%;opacity:.4;transition:opacity .2s ease;cursor:pointer}:host ::ng-deep .preview .cl-preview-section mat-icon:hover{opacity:1}:host ::ng-deep .preview .focus-highlight{position:relative;overflow:visible}:host ::ng-deep .preview .focus-highlight:before{content:\"\";border-radius:3px;position:absolute;inset:0 -12px;background-color:var(--focus-highlight-background-color);transition:background-color .4s ease}:host ::ng-deep .icon-provider{width:100%;height:100%;background-position:50%;background-repeat:no-repeat;background-size:contain}:host ::ng-deep .spinnerMax,:host ::ng-deep .spinnerMid,:host ::ng-deep .spinnerMin{align-items:center;border:.3em solid transparent;border-top:.3em solid var(--primary-color);border-right:.3em solid var(--primary-color);border-radius:100%;display:flex;justify-content:center}:host ::ng-deep .spinnerMax{animation:spinnerOne 3s linear infinite;height:3em;width:3em}:host ::ng-deep .spinnerMid{animation:spinnerOne 5s linear infinite;height:2.4em;width:2.4em}:host ::ng-deep .spinnerMin{animation:spinnerOne 5s linear infinite;height:1.8em;width:1.8em}@keyframes spinnerOne{0%{transform:rotate(0)}to{transform:rotate(360deg)}}:host ::ng-deep .preview article,:host ::ng-deep .preview aside,:host ::ng-deep .preview footer,:host ::ng-deep .preview header,:host ::ng-deep .preview nav,:host ::ng-deep .preview section{display:block}:host ::ng-deep .preview h1{font-size:2em;margin:.67em 0}:host ::ng-deep .preview figcaption,:host ::ng-deep .preview figure{display:block}:host ::ng-deep .preview figure{margin:1em 40px}:host ::ng-deep .preview hr{box-sizing:content-box;height:0;overflow:visible}:host ::ng-deep .preview abbr[title]{border-bottom:none;text-decoration:underline;-webkit-text-decoration:underline dotted;text-decoration:underline dotted}:host ::ng-deep .preview b,:host ::ng-deep .preview strong{font-weight:inherit;font-weight:bolder}:host ::ng-deep .preview code,:host ::ng-deep .preview kbd,:host ::ng-deep .preview samp{font-family:var(--stackedit-font-family-mono);font-size:1em;background-color:var(--code-background-color)}:host ::ng-deep .preview img{border-style:none}:host ::ng-deep .preview h1:after,:host ::ng-deep .preview h2:after{content:\"\";display:block;position:relative;top:.33em;border-bottom:1px solid hsla(0,0%,50%,.33)}:host ::ng-deep .preview ol ol,:host ::ng-deep .preview ol ul,:host ::ng-deep .preview ul ol,:host ::ng-deep .preview ul ul{margin:0}:host ::ng-deep .preview dt{font-weight:700}:host ::ng-deep .preview a{color:var(--md-anchor-color);text-decoration:underline;-webkit-text-decoration-skip:ink;text-decoration-skip:ink}:host ::ng-deep .preview a:focus,:host ::ng-deep .preview a:hover{text-decoration:none}:host ::ng-deep .preview code,:host ::ng-deep .preview pre,:host ::ng-deep .preview samp{font-family:var(--stackedit-font-family-mono)}:host ::ng-deep .preview code *,:host ::ng-deep .preview pre *,:host ::ng-deep .preview samp *{font-size:inherit}:host ::ng-deep .preview pre>code,:host ::ng-deep .preview blockquote{padding:6px 12px;border-radius:5px;background-color:var(--blockquote-background-color)}:host ::ng-deep .preview blockquote{color:var(--md-blockquote-color);border-left:7px solid var(--md-blockquote-border-color);margin-inline-start:0;margin-inline-end:0}:host ::ng-deep .preview blockquote blockquote{margin-inline-start:12px;margin-inline-end:12px}:host ::ng-deep .preview blockquote p{margin:0}:host ::ng-deep .preview img{border-radius:6px}:host ::ng-deep .preview input[type=checkbox]{position:absolute;left:-500vw}:host ::ng-deep .preview input[type=checkbox]+label{position:relative;padding-left:32px;cursor:pointer}:host ::ng-deep .preview input[type=checkbox]+label:before{content:\"\";position:absolute;left:0;top:0;width:18px;height:18px;border:1px solid var(--md-border-color);border-radius:3px;background:var(--blockquote-background-color)}:host ::ng-deep .preview input[type=checkbox]+label:after{content:\"check\";position:absolute;top:0;left:0;width:20px;height:20px;display:inline-block;overflow:hidden;font-family:Material Symbols Outlined,Material Icons Outlined,Material Symbols,Material Icons;font-weight:600;font-size:19px;line-height:20px;text-align:center;color:var(--primary-color);transition:all .2s}:host ::ng-deep .preview input[type=checkbox]:not(:checked)+label:after{opacity:0;transform:scale(0)}:host ::ng-deep .preview input[type=checkbox]:checked+label:after{opacity:1;transform:scale(1)}:host ::ng-deep .preview input[type=checkbox]:focus+label:before{border:1px dotted var(--primary-color)}:host ::ng-deep .preview label:hover:before{border:1px solid var(--primary-color)!important}:host ::ng-deep .preview hr{border:0;border-top:1px solid hsla(0,0%,50%,.33);margin:2em 0}:host ::ng-deep .preview pre>code{display:block;-webkit-text-size-adjust:none;overflow-x:auto;white-space:pre}:host ::ng-deep .preview .toc ul{list-style-type:none;padding-left:20px}:host ::ng-deep .preview table{border-collapse:collapse;overflow:hidden;box-shadow:0 0 20px #0000001a;border-radius:5px;position:relative;z-index:0}:host ::ng-deep .preview table:before{content:\"\";background-color:var(--blockquote-background-color);position:absolute;inset:0;z-index:-5}:host ::ng-deep .preview th,:host ::ng-deep .preview td{padding:8px 14px;color:var(--text-header-color)}:host ::ng-deep .preview thead th{background-color:var(--table-header-color);text-align:left}:host ::ng-deep .preview tbody tr:hover{background-color:var(--table-row-hover-color)!important}:host ::ng-deep .preview tbody tr:nth-of-type(2n) td:first-of-type:before{content:\"\";position:absolute;inset:0 -100vw;background-color:var(--table-row-alt-color);z-index:-4}:host ::ng-deep .preview tbody td{position:relative}:host ::ng-deep .preview tbody td:hover:after{content:\"\";position:absolute;inset:-100vh 0;background-color:var(--table-column-hover-color);z-index:-1}:host ::ng-deep .preview abbr[title]{border-bottom:1px dotted #777;cursor:help}:host ::ng-deep .preview img{max-width:100%}:host ::ng-deep .preview .task-list-item{list-style-type:none}:host ::ng-deep .preview .footnote{font-size:.8em;position:relative;top:-.25em;vertical-align:top}:host ::ng-deep .preview .page-break-after{page-break-after:always}:host ::ng-deep .preview .abc-notation-block{overflow-x:auto!important}:host ::ng-deep .markdown-highlighting{color:var(--text-color);caret-color:var(--text-color);font-family:inherit;font-size:inherit;font-weight:400}:host ::ng-deep .markdown-highlighting .code_custom,:host ::ng-deep .markdown-highlighting .tag,:host ::ng-deep .markdown-highlighting .pre,:host ::ng-deep .markdown-highlighting .entity,:host ::ng-deep .markdown-highlighting .table{font-family:var(--stackedit-font-family-mono)}:host ::ng-deep .markdown-highlighting .code_custom:not(.code-snippet),:host ::ng-deep .markdown-highlighting .pre,:host ::ng-deep .markdown-highlighting .table-block,:host ::ng-deep .markdown-highlighting .blockquote{background-color:var(--code-background-color);padding:6px 12px;border-radius:5px;display:inline-block!important}:host ::ng-deep .markdown-highlighting .code_custom:not(.code-snippet),:host ::ng-deep .markdown-highlighting .blockquote{width:100%}:host ::ng-deep .markdown-highlighting .blockquote{color:var(--md-blockquote-color);border-left:7px solid var(--md-blockquote-border-color)}:host ::ng-deep .markdown-highlighting .pre{color:#000c}:host ::ng-deep .markdown-highlighting .pre,:host ::ng-deep .markdown-highlighting .pre *{line-height:1.33}:host ::ng-deep .markdown-highlighting .entity{color:var(--text-color)}:host ::ng-deep .markdown-highlighting .img-block{text-wrap:wrap;word-break:break-all;position:relative}:host ::ng-deep .markdown-highlighting .img-block .img-button{position:absolute;top:4px;right:4px;width:32px;height:32px;padding:4px;border-radius:50%;color:#fff8;background-color:#0000;transition:background-color .2s ease,opacity .2s ease,color .2s ease;cursor:pointer}:host ::ng-deep .markdown-highlighting .img-block .img-button:hover{opacity:1;color:#000;background-color:#69f0ae}:host ::ng-deep .markdown-highlighting .img-block .img-button.delete:before{content:\"delete\"}:host ::ng-deep .markdown-highlighting .img-block .img-button.edit:before{content:\"edit\"}:host ::ng-deep .markdown-highlighting .img-block .img-wrapper{position:relative;width:-moz-fit-content;width:fit-content;-webkit-user-select:none;user-select:none;display:inline-block}:host ::ng-deep .markdown-highlighting .img-block .img-wrapper img{border-radius:6px}:host ::ng-deep .markdown-highlighting .img-block .img-wrapper:after{content:\"\\a\"}:host ::ng-deep .markdown-highlighting .img-block img:after{content:\"\";width:64px;height:64px}:host ::ng-deep .markdown-highlighting .img-block img{cursor:default}:host ::ng-deep .markdown-highlighting .cl-toc{font-size:2.8em;padding:.15em}:host ::ng-deep .markdown-highlighting .blockquote{color:var(--md-blockquote-color)}:host ::ng-deep .markdown-highlighting .h1,:host ::ng-deep .markdown-highlighting .h2,:host ::ng-deep .markdown-highlighting .h3,:host ::ng-deep .markdown-highlighting .h4,:host ::ng-deep .markdown-highlighting .h5,:host ::ng-deep .markdown-highlighting .h6,:host ::ng-deep .markdown-highlighting .h11,:host ::ng-deep .markdown-highlighting .h22{font-weight:600}:host ::ng-deep .markdown-highlighting .h1,:host ::ng-deep .markdown-highlighting .h1 *,:host ::ng-deep .markdown-highlighting .h2,:host ::ng-deep .markdown-highlighting .h2 *,:host ::ng-deep .markdown-highlighting .h3,:host ::ng-deep .markdown-highlighting .h3 *,:host ::ng-deep .markdown-highlighting .h4,:host ::ng-deep .markdown-highlighting .h4 *,:host ::ng-deep .markdown-highlighting .h5,:host ::ng-deep .markdown-highlighting .h5 *,:host ::ng-deep .markdown-highlighting .h6,:host ::ng-deep .markdown-highlighting .h6 *,:host ::ng-deep .markdown-highlighting .h11,:host ::ng-deep .markdown-highlighting .h11 *,:host ::ng-deep .markdown-highlighting .h22,:host ::ng-deep .markdown-highlighting .h22 *{line-height:1.33}:host ::ng-deep .markdown-highlighting .h1,:host ::ng-deep .markdown-highlighting .h11{font-size:2em}:host ::ng-deep .markdown-highlighting .h2,:host ::ng-deep .markdown-highlighting .h22{font-size:1.5em}:host ::ng-deep .markdown-highlighting .h3{font-size:1.17em}:host ::ng-deep .markdown-highlighting .h4{font-size:1em}:host ::ng-deep .markdown-highlighting .h5{font-size:.83em}:host ::ng-deep .markdown-highlighting .h6{font-size:.75em}:host ::ng-deep .markdown-highlighting .hr{font-style:normal;font-weight:400}:host ::ng-deep .markdown-highlighting .em{font-style:italic}:host ::ng-deep .markdown-highlighting .strong,:host ::ng-deep .markdown-highlighting .term{font-weight:600}:host ::ng-deep .markdown-highlighting .strikethrough-text{text-decoration:line-through}:host ::ng-deep .markdown-highlighting .underlined-text,:host ::ng-deep .markdown-highlighting .email{text-decoration:underline}:host ::ng-deep .markdown-highlighting .fn,:host ::ng-deep .markdown-highlighting .inlinefn,:host ::ng-deep .markdown-highlighting .sup{font-size:smaller;position:relative;top:-.5em}:host ::ng-deep .markdown-highlighting .sub{bottom:-.25em;font-size:smaller;position:relative}:host ::ng-deep :focus{outline:none}:host ::ng-deep .hidden-rendering-container{position:absolute;width:900px;min-height:400px;left:-100vw}:host ::ng-deep .toc__inner{position:relative;color:var(--text-header-color);cursor:pointer;font-size:12px;padding:10px 20px 40px;white-space:nowrap;-webkit-user-select:none;user-select:none}:host ::ng-deep .toc__inner *{font-weight:inherit}:host ::ng-deep .toc__inner .cl-toc-section h1:after,:host ::ng-deep .toc__inner .cl-toc-section h2:after{display:none}:host ::ng-deep .toc__inner .cl-toc-section h1{margin:1rem 0}:host ::ng-deep .toc__inner .cl-toc-section h2{margin:.5rem 0;margin-left:8px}:host ::ng-deep .toc__inner .cl-toc-section h3{margin:.33rem 0;margin-left:16px}:host ::ng-deep .toc__inner .cl-toc-section h4{margin:.22rem 0;margin-left:24px}:host ::ng-deep .toc__inner .cl-toc-section h5{margin:.11rem 0;margin-left:32px}:host ::ng-deep .toc__inner .cl-toc-section h6{margin:0 0 0 40px}:host ::ng-deep .preview__inner{margin:0;padding:24px}:host ::ng-deep .preview__inner>:first-child>:first-child{margin-top:0}:host ::ng-deep .preview__corner{position:absolute;top:0;right:0}:host ::ng-deep .prism.language-css{color:var(--prism-string-color)}:host ::ng-deep .prism.language-ts .token.subject,:host ::ng-deep .prism.language-js .token.subject{color:var(--prism-builtin-color)}:host ::ng-deep .prism.language-ts .token.import,:host ::ng-deep .prism.language-js .token.import{color:var(--prism-ts-keyword-color)}:host ::ng-deep .prism.language-ts .token.punctuation,:host ::ng-deep .prism.language-js .token.punctuation{color:var(--prism-ts-punctuation-color)}:host ::ng-deep .prism .img-spinner{align-items:center;background:#222;border-radius:50%;box-shadow:0 5px 20px #0003;display:inline-flex!important;justify-content:center}:host ::ng-deep .prism .img-spinner *{display:flex}:host ::ng-deep .prism .img-spinner span{display:none}:host ::ng-deep .prism .token.italic{font-style:italic}:host ::ng-deep .prism .token.image-spinner{color:#0000}:host ::ng-deep .prism .token.table-block .header-row{color:var(--prism-table-header-color);font-weight:600}:host ::ng-deep .prism .namespace{opacity:.7}:host ::ng-deep .prism .token.boolean,:host ::ng-deep .prism .token.constant,:host ::ng-deep .prism .token.deleted,:host ::ng-deep .prism .token.symbol{color:#569cd6}:host ::ng-deep .prism .token.builtin{color:var(--prism-builtin-color)}:host ::ng-deep .prism .token.char,:host ::ng-deep .prism .token.inserted{color:#690}:host ::ng-deep .prism .token.selector{color:var(--prism-selector-color)}:host ::ng-deep .prism .token.string{color:var(--prism-string-color)}:host ::ng-deep .prism .language-css .token.string,:host ::ng-deep .prism .style .token.string,:host ::ng-deep .prism .token.entity,:host ::ng-deep .prism .token.operator{color:#a67f59}:host ::ng-deep .prism .token.img-src,:host ::ng-deep .prism .token.src{color:var(--prism-url-color);text-decoration:underline;text-decoration-color:#40a6ff88}:host ::ng-deep .prism .token.dash,:host ::ng-deep .prism .token.colon,:host ::ng-deep .prism .token.pipe,:host ::ng-deep .prism .token.punctuation,:host ::ng-deep .prism .token.hash,:host ::ng-deep .prism .token.hr{color:var(--prism-punctuation-color)}:host ::ng-deep .prism .token.atrule{color:var(--prism-builtin-color)}:host ::ng-deep .prism .token.attr-value{color:var(--prism-string-color)}:host ::ng-deep .prism .token.code-snippet{color:var(--prism-string-color);background-color:var(--code-background-color);border-radius:3px}:host ::ng-deep .prism .token.function{color:var(--prism-function-color)}:host ::ng-deep .prism .token.important,:host ::ng-deep .prism .token.regex,:host ::ng-deep .prism .token.variable{color:#e90}:host ::ng-deep .prism .token.tag{color:var(--prism-tag-color)}:host ::ng-deep .prism .token.attr-name,:host ::ng-deep .prism .token.property{color:var(--prism-property-color)}:host ::ng-deep .prism .token.attr-value>.punctuation{color:var(--prism-attribute-color)}:host ::ng-deep .prism .token.attr-value>.punctuation.attr-equals{color:var(--prism-attribute-punctuation-color)}:host ::ng-deep .prism .token.attr-value>.value{color:var(--prism-attribute-value-color)}:host ::ng-deep .prism .token.attr-value>.value .punctuation{color:var(--prism-attribute-value-punctuation-color)}:host ::ng-deep .prism .token.number{color:var(--prism-number-color)}:host ::ng-deep .prism .token.cdata,:host ::ng-deep .prism .token.doctype,:host ::ng-deep .prism .token.prolog,:host ::ng-deep .prism .token.comment{color:var(--prism-comment-color)}:host ::ng-deep .prism .token.bold,:host ::ng-deep .prism .token.important{font-weight:500}:host ::ng-deep .prism .token.indent-space{letter-spacing:.45em}:host ::ng-deep .ng-scroll-content{width:100%}\n"], dependencies: [{ kind: "ngmodule", type: MatIconModule }, { kind: "component", type: i2.MatIcon, selector: "mat-icon", inputs: ["color", "inline", "svgIcon", "fontSet", "fontIcon"], exportAs: ["matIcon"] }, { kind: "ngmodule", type: MatTooltipModule }, { kind: "directive", type: i3.MatTooltip, selector: "[matTooltip]", inputs: ["matTooltipPosition", "matTooltipPositionAtOrigin", "matTooltipDisabled", "matTooltipShowDelay", "matTooltipHideDelay", "matTooltipTouchGestures", "matTooltip", "matTooltipClass"], exportAs: ["matTooltip"] }, { kind: "component", type: 
                // TooltipDirective,
                // MenuDirective,
                ToolbarComponent, selector: "app-toolbar", inputs: ["colorList"] }, { kind: "ngmodule", type: NgScrollbarModule }, { kind: "component", type: i6$1.NgScrollbar, selector: "ng-scrollbar", inputs: ["disabled", "sensorDisabled", "pointerEventsDisabled", "viewportPropagateMouseMove", "autoHeightDisabled", "autoWidthDisabled", "viewClass", "trackClass", "thumbClass", "minThumbSize", "trackClickScrollDuration", "pointerEventsMethod", "track", "visibility", "appearance", "position", "sensorDebounce", "scrollAuditTime"], outputs: ["updated"], exportAs: ["ngScrollbar"] }] });
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "17.1.1", ngImport: i0, type: StackEditorComponent, decorators: [{
            type: Component,
            args: [{ selector: 'ngx-stackedit', imports: [
                        MatIconModule,
                        MatTooltipModule,
                        // TooltipDirective,
                        // MenuDirective,
                        ToolbarComponent,
                        NgScrollbarModule,
                        // AngularSplitModule
                    ], host: {
                        "(pointerdown)": "onPointerDown($event)"
                    }, standalone: true, template: "<app-toolbar [style.flex]=\"'0 0 ' + (mode == 'edit' ? 44 : 0) + 'px'\"></app-toolbar>\n\n@if (mode == 'view') {\n    <mat-icon\n        class=\"edit_btn\"\n        (mousedown)=\"toggleEditor(); $event.preventDefault()\"\n        matTooltip=\"Edit Description\"\n    >\n        edit\n    </mat-icon>\n}\n\n<div\n    class=\"contents\"\n>\n    <ng-scrollbar\n        class=\"editor-container\"\n        [class.hidden]=\"mode != 'edit'\"\n        [class.expand]=\"showPreview == 'off' || !showPreview\"\n        [class.show-toc]=\"showToc && showToc != 'off'\"\n        style=\"background-color: var(--editor-background-color); cursor: text\"\n        (click)=\"editorSvc.clEditor.focus()\"\n    >\n        <div\n            class=\"editor markdown-highlighting\"\n            style=\"width: 100%\"\n            [class.linenumbers]=\"showLineNumbers\"\n        >\n            <div class=\"editor-underlay\"></div>\n            <div class=\"editor-inner\"></div>\n            <div class=\"editor-overlay-1\"></div>\n            <div class=\"editor-overlay-2\"></div>\n        </div>\n    </ng-scrollbar>\n\n    <ng-scrollbar\n        class=\"preview-container\"\n        [class.hidden]=\"showPreview == 'off' || !showPreview\"\n        [class.expand]=\"mode != 'edit'\"\n        [class.show-toc]=\"showToc && showToc != 'off'\"\n        style=\"background-color: var(--preview-background-color)\"\n    >\n        <div\n            class=\"preview\"\n            style=\"width: 100%\"\n        >\n            <div class=\"preview__inner\"></div>\n        </div>\n    </ng-scrollbar>\n\n    <!-- TODO: -->\n    <ng-scrollbar\n        class=\"toc-container\"\n        [style.width]=\"(showToc == 'off' || !showToc)  ? '0px' : '240px'\"\n    >\n        <div\n            class=\"toc\"\n        >\n            <div class=\"toc__inner\"></div>\n        </div>\n    </ng-scrollbar>\n</div>\n\n<!-- <app-statusbar [style.flex]=\"'0 0 ' + (mode != 'viewonly' ? 22 : 0) + 'px'\"></app-statusbar> -->\n", styles: [":host{display:flex;flex-direction:column;width:100%;height:100%;overflow:hidden}::ng-deep :root{--primary-color: #0c93e4;--stackedit-font-family: \"Fira Sans\", Arial;--stackedit-font-family-mono: \"Fira Mono\", \"Droid Sans Mono\", \"monospace\", monospace}::ng-deep .ngx-menu.mermaid-menu .mat-mdc-dialog-container .mdc-dialog__surface{background-color:var(--editor-background-color)}::ng-deep .dark{--editor-background-color: #1f1f1f;--preview-background-color: #1f2123;--text-color: #efefef;--text-header-color: #ceceff;--selection-color: #264f78;--code-background-color: #2b2b2b;--blockquote-background-color: #2b2b2b;--table-header-color: #0d47a1;--table-row-alt-color: #222;--table-row-hover-color: #444;--table-column-hover-color: #444;--md-border-color: #474747;--md-header-border-color: #000;--md-blockquote-color: #aaa;--md-blockquote-border-color: hsla(0, 0%, 100%, .1);--md-anchor-color: var(--primary-color);--prism-tag-color: #569cd6;--prism-property-color: #9cdcfe;--prism-punctuation-color: #808080;--prism-attribute-color: #ce9178;--prism-attribute-punctuation-color: #fff;--prism-attribute-value-color: #ce9178;--prism-attribute-value-punctuation-color: #fff;--prism-number-color: #b5cea8;--prism-comment-color: #6a9955;--prism-string-color: #ce9178;--prism-function-color: #dcdcaa;--prism-type-color: #4ec9b0;--prism-boolean-color: #569cd6;--prism-this-color: #569cd6;--prism-modifier-color: #569cd6;--prism-selector-color: #d7ba7d;--prism-builtin-color: #9cdcfe;--prism-ts-keyword-color: #c586c0;--prism-ts-punctuation-color: #ccc;--prism-url-color: #569cd6;--prism-table-header-color: #d7ba7d}::ng-deep .dark *::selection{background-color:#3a3d41!important}::ng-deep .dark *:focus *::selection{background-color:#264f78!important}::ng-deep .light{--editor-background-color: #ffffff;--preview-background-color: #f3f3f3;--text-color: #121212;--text-header-color: #121244;--selection-color: #42a5f5;--code-background-color: #ebebeb;--blockquote-background-color: #ebebeb;--table-header-color: #42a5f5;--table-row-alt-color: #f3f3f3;--table-row-hover-color: #ddd;--table-column-hover-color: #ddd;--md-border-color: #dcdcdc;--md-header-border-color: #fff;--md-blockquote-color: #444;--md-blockquote-border-color: rgba(0, 0, 0, .1);--md-anchor-color: var(--primary-color);--prism-tag-color: #800000;--prism-property-color: #e50000;--prism-punctuation-color: #800000;--prism-attribute-color: #0000ff;--prism-attribute-punctuation-color: #3b3b3b;--prism-attribute-value-color: #0000ff;--prism-attribute-value-punctuation-color: #3b3b3b;--prism-number-color: #098658;--prism-comment-color: #008000;--prism-string-color: #a31515;--prism-function-color: #795e26;--prism-type-color: #267f99;--prism-boolean-color: #0000ff;--prism-this-color: #0000ff;--prism-modifier-color: #0000ff;--prism-selector-color: #800000;--prism-builtin-color: #800000;--prism-ts-keyword-color: #af00db;--prism-ts-punctuation-color: #333;--prism-url-color: #0000ff;--prism-table-header-color: #800000}::ng-deep .light *::selection{background-color:#e5ebf1!important}::ng-deep .light *:focus *::selection{background-color:#add6ff!important}.contents{display:flex;flex:1;height:100%;width:100%;overflow:hidden;position:relative}.edit_btn{position:absolute;top:4px;right:4px;z-index:1}ng-scrollbar{width:100%;overflow:hidden}:host ::ng-deep{--line-height: 24px}:host ::ng-deep .editor-container,:host ::ng-deep .preview-container{width:calc(50% - 1px);position:absolute;transition:width .2s ease,left .2s ease,right .2s ease;contain:content}:host ::ng-deep .editor-container.expand,:host ::ng-deep .preview-container.expand{width:100%}:host ::ng-deep .editor-container.expand.show-toc,:host ::ng-deep .preview-container.expand.show-toc{width:calc(100% - 240px)}:host ::ng-deep .editor-container.show-toc,:host ::ng-deep .preview-container.show-toc{width:calc(50% - 121px)}:host ::ng-deep .editor-container{left:0}:host ::ng-deep .editor-container .hide{display:none}:host ::ng-deep .editor-container.hidden{left:-50%}:host ::ng-deep .preview-container{right:0}:host ::ng-deep .preview-container.hidden{right:-50%}:host ::ng-deep .preview-container.show-toc:not(.hidden){right:240px}:host ::ng-deep .toc-container{position:absolute;transition:width .2s ease;right:0;width:240px}:host ::ng-deep .toc-container.hidden{right:-240px}:host ::ng-deep .editor{font-family:var(--stackedit-font-family-mono);flex-direction:column;padding:10px 24px 0;margin:0;white-space:pre-wrap;word-break:break-word;word-wrap:break-word;height:100%}:host ::ng-deep .editor>div{max-width:960px;margin:0 auto}:host ::ng-deep .editor.linenumbers{padding:10px 24px 38px 64px}:host ::ng-deep .editor.linenumbers .lf:before{content:attr(data-linenumber);position:absolute;left:6px;color:#6e7681;font-family:var(--stackedit-font-family-mono)}:host ::ng-deep .editor.monospaced{font-family:var(--stackedit-font-family-mono);font-size:.85em!important}:host ::ng-deep .editor.monospaced *{font-size:inherit!important}:host ::ng-deep .editor img::selection{background-color:var(--selection-color)}:host ::ng-deep .editor *{line-height:var(--line-height, 1.4)}:host ::ng-deep .editor .colorpicker-color-decoration,:host ::ng-deep .editor .hc-light .colorpicker-color-decoration{line-height:.8em}:host ::ng-deep .editor .cledit-section{font-family:var(--stackedit-font-family-mono)}:host ::ng-deep .editor .cledit-section span{display:inline}:host ::ng-deep .editor .cledit-section .injection-portal{contain:content;overflow:auto}:host ::ng-deep .editor .cledit-section .injection-portal>div{display:flex;flex-direction:column}:host ::ng-deep .editor .cledit-section .injection-portal div{display:block}:host ::ng-deep .editor .editor-underlay,:host ::ng-deep .editor .editor-overlay-1,:host ::ng-deep .editor .editor-overlay-2{position:absolute;top:0;right:0;left:0}:host ::ng-deep .editor .editor-inner{min-height:100%}:host ::ng-deep .editor .code-block{display:block!important;overflow:hidden;white-space:pre;padding-bottom:calc(19px + var(--line-height));line-height:var(--line-height)}:host ::ng-deep .editor .editor-overlay-1 .monaco-container{position:absolute;display:block}:host ::ng-deep .editor .editor-overlay-1 .monaco-container mat-icon{position:absolute;top:4px;right:4px;padding:6px;z-index:1;font-size:20px;background-color:var(--blockquote-background-color);border-radius:50%;opacity:.4;transition:opacity .2s ease;cursor:pointer}:host ::ng-deep .editor .editor-overlay-1 .monaco-container mat-icon:hover{opacity:1}:host ::ng-deep .editor .editor-overlay-1 .monaco-container .run-button{right:44px}:host ::ng-deep .editor .editor-overlay-1 .monaco-editor{border-radius:6px}:host ::ng-deep .editor .editor-overlay-1 .monaco-editor .overflow-guard .margin,:host ::ng-deep .editor .editor-overlay-1 .monaco-editor .margin-view-overlays{border-bottom-left-radius:6px;border-top-left-radius:6px}:host ::ng-deep .editor .editor-overlay-1 .monaco-editor .monaco-scrollable-element.editor-scrollable,:host ::ng-deep .editor .editor-overlay-1 .monaco-editor .view-lines.monaco-mouse-cursor-text,:host ::ng-deep .editor .editor-overlay-1 .monaco-editor .decorationsOverviewRuler{border-bottom-right-radius:6px;border-top-right-radius:6px}:host ::ng-deep .preview{line-height:24px;height:100%}:host ::ng-deep .preview .cl-preview-section{min-width:100%;overflow-x:auto;position:relative}:host ::ng-deep .preview .cl-preview-section pre[class^=language]{position:relative}:host ::ng-deep .preview .cl-preview-section mat-icon{position:absolute;top:4px;right:4px;padding:6px;font-size:20px;z-index:1;background-color:var(--blockquote-background-color);border-radius:50%;opacity:.4;transition:opacity .2s ease;cursor:pointer}:host ::ng-deep .preview .cl-preview-section mat-icon:hover{opacity:1}:host ::ng-deep .preview .focus-highlight{position:relative;overflow:visible}:host ::ng-deep .preview .focus-highlight:before{content:\"\";border-radius:3px;position:absolute;inset:0 -12px;background-color:var(--focus-highlight-background-color);transition:background-color .4s ease}:host ::ng-deep .icon-provider{width:100%;height:100%;background-position:50%;background-repeat:no-repeat;background-size:contain}:host ::ng-deep .spinnerMax,:host ::ng-deep .spinnerMid,:host ::ng-deep .spinnerMin{align-items:center;border:.3em solid transparent;border-top:.3em solid var(--primary-color);border-right:.3em solid var(--primary-color);border-radius:100%;display:flex;justify-content:center}:host ::ng-deep .spinnerMax{animation:spinnerOne 3s linear infinite;height:3em;width:3em}:host ::ng-deep .spinnerMid{animation:spinnerOne 5s linear infinite;height:2.4em;width:2.4em}:host ::ng-deep .spinnerMin{animation:spinnerOne 5s linear infinite;height:1.8em;width:1.8em}@keyframes spinnerOne{0%{transform:rotate(0)}to{transform:rotate(360deg)}}:host ::ng-deep .preview article,:host ::ng-deep .preview aside,:host ::ng-deep .preview footer,:host ::ng-deep .preview header,:host ::ng-deep .preview nav,:host ::ng-deep .preview section{display:block}:host ::ng-deep .preview h1{font-size:2em;margin:.67em 0}:host ::ng-deep .preview figcaption,:host ::ng-deep .preview figure{display:block}:host ::ng-deep .preview figure{margin:1em 40px}:host ::ng-deep .preview hr{box-sizing:content-box;height:0;overflow:visible}:host ::ng-deep .preview abbr[title]{border-bottom:none;text-decoration:underline;-webkit-text-decoration:underline dotted;text-decoration:underline dotted}:host ::ng-deep .preview b,:host ::ng-deep .preview strong{font-weight:inherit;font-weight:bolder}:host ::ng-deep .preview code,:host ::ng-deep .preview kbd,:host ::ng-deep .preview samp{font-family:var(--stackedit-font-family-mono);font-size:1em;background-color:var(--code-background-color)}:host ::ng-deep .preview img{border-style:none}:host ::ng-deep .preview h1:after,:host ::ng-deep .preview h2:after{content:\"\";display:block;position:relative;top:.33em;border-bottom:1px solid hsla(0,0%,50%,.33)}:host ::ng-deep .preview ol ol,:host ::ng-deep .preview ol ul,:host ::ng-deep .preview ul ol,:host ::ng-deep .preview ul ul{margin:0}:host ::ng-deep .preview dt{font-weight:700}:host ::ng-deep .preview a{color:var(--md-anchor-color);text-decoration:underline;-webkit-text-decoration-skip:ink;text-decoration-skip:ink}:host ::ng-deep .preview a:focus,:host ::ng-deep .preview a:hover{text-decoration:none}:host ::ng-deep .preview code,:host ::ng-deep .preview pre,:host ::ng-deep .preview samp{font-family:var(--stackedit-font-family-mono)}:host ::ng-deep .preview code *,:host ::ng-deep .preview pre *,:host ::ng-deep .preview samp *{font-size:inherit}:host ::ng-deep .preview pre>code,:host ::ng-deep .preview blockquote{padding:6px 12px;border-radius:5px;background-color:var(--blockquote-background-color)}:host ::ng-deep .preview blockquote{color:var(--md-blockquote-color);border-left:7px solid var(--md-blockquote-border-color);margin-inline-start:0;margin-inline-end:0}:host ::ng-deep .preview blockquote blockquote{margin-inline-start:12px;margin-inline-end:12px}:host ::ng-deep .preview blockquote p{margin:0}:host ::ng-deep .preview img{border-radius:6px}:host ::ng-deep .preview input[type=checkbox]{position:absolute;left:-500vw}:host ::ng-deep .preview input[type=checkbox]+label{position:relative;padding-left:32px;cursor:pointer}:host ::ng-deep .preview input[type=checkbox]+label:before{content:\"\";position:absolute;left:0;top:0;width:18px;height:18px;border:1px solid var(--md-border-color);border-radius:3px;background:var(--blockquote-background-color)}:host ::ng-deep .preview input[type=checkbox]+label:after{content:\"check\";position:absolute;top:0;left:0;width:20px;height:20px;display:inline-block;overflow:hidden;font-family:Material Symbols Outlined,Material Icons Outlined,Material Symbols,Material Icons;font-weight:600;font-size:19px;line-height:20px;text-align:center;color:var(--primary-color);transition:all .2s}:host ::ng-deep .preview input[type=checkbox]:not(:checked)+label:after{opacity:0;transform:scale(0)}:host ::ng-deep .preview input[type=checkbox]:checked+label:after{opacity:1;transform:scale(1)}:host ::ng-deep .preview input[type=checkbox]:focus+label:before{border:1px dotted var(--primary-color)}:host ::ng-deep .preview label:hover:before{border:1px solid var(--primary-color)!important}:host ::ng-deep .preview hr{border:0;border-top:1px solid hsla(0,0%,50%,.33);margin:2em 0}:host ::ng-deep .preview pre>code{display:block;-webkit-text-size-adjust:none;overflow-x:auto;white-space:pre}:host ::ng-deep .preview .toc ul{list-style-type:none;padding-left:20px}:host ::ng-deep .preview table{border-collapse:collapse;overflow:hidden;box-shadow:0 0 20px #0000001a;border-radius:5px;position:relative;z-index:0}:host ::ng-deep .preview table:before{content:\"\";background-color:var(--blockquote-background-color);position:absolute;inset:0;z-index:-5}:host ::ng-deep .preview th,:host ::ng-deep .preview td{padding:8px 14px;color:var(--text-header-color)}:host ::ng-deep .preview thead th{background-color:var(--table-header-color);text-align:left}:host ::ng-deep .preview tbody tr:hover{background-color:var(--table-row-hover-color)!important}:host ::ng-deep .preview tbody tr:nth-of-type(2n) td:first-of-type:before{content:\"\";position:absolute;inset:0 -100vw;background-color:var(--table-row-alt-color);z-index:-4}:host ::ng-deep .preview tbody td{position:relative}:host ::ng-deep .preview tbody td:hover:after{content:\"\";position:absolute;inset:-100vh 0;background-color:var(--table-column-hover-color);z-index:-1}:host ::ng-deep .preview abbr[title]{border-bottom:1px dotted #777;cursor:help}:host ::ng-deep .preview img{max-width:100%}:host ::ng-deep .preview .task-list-item{list-style-type:none}:host ::ng-deep .preview .footnote{font-size:.8em;position:relative;top:-.25em;vertical-align:top}:host ::ng-deep .preview .page-break-after{page-break-after:always}:host ::ng-deep .preview .abc-notation-block{overflow-x:auto!important}:host ::ng-deep .markdown-highlighting{color:var(--text-color);caret-color:var(--text-color);font-family:inherit;font-size:inherit;font-weight:400}:host ::ng-deep .markdown-highlighting .code_custom,:host ::ng-deep .markdown-highlighting .tag,:host ::ng-deep .markdown-highlighting .pre,:host ::ng-deep .markdown-highlighting .entity,:host ::ng-deep .markdown-highlighting .table{font-family:var(--stackedit-font-family-mono)}:host ::ng-deep .markdown-highlighting .code_custom:not(.code-snippet),:host ::ng-deep .markdown-highlighting .pre,:host ::ng-deep .markdown-highlighting .table-block,:host ::ng-deep .markdown-highlighting .blockquote{background-color:var(--code-background-color);padding:6px 12px;border-radius:5px;display:inline-block!important}:host ::ng-deep .markdown-highlighting .code_custom:not(.code-snippet),:host ::ng-deep .markdown-highlighting .blockquote{width:100%}:host ::ng-deep .markdown-highlighting .blockquote{color:var(--md-blockquote-color);border-left:7px solid var(--md-blockquote-border-color)}:host ::ng-deep .markdown-highlighting .pre{color:#000c}:host ::ng-deep .markdown-highlighting .pre,:host ::ng-deep .markdown-highlighting .pre *{line-height:1.33}:host ::ng-deep .markdown-highlighting .entity{color:var(--text-color)}:host ::ng-deep .markdown-highlighting .img-block{text-wrap:wrap;word-break:break-all;position:relative}:host ::ng-deep .markdown-highlighting .img-block .img-button{position:absolute;top:4px;right:4px;width:32px;height:32px;padding:4px;border-radius:50%;color:#fff8;background-color:#0000;transition:background-color .2s ease,opacity .2s ease,color .2s ease;cursor:pointer}:host ::ng-deep .markdown-highlighting .img-block .img-button:hover{opacity:1;color:#000;background-color:#69f0ae}:host ::ng-deep .markdown-highlighting .img-block .img-button.delete:before{content:\"delete\"}:host ::ng-deep .markdown-highlighting .img-block .img-button.edit:before{content:\"edit\"}:host ::ng-deep .markdown-highlighting .img-block .img-wrapper{position:relative;width:-moz-fit-content;width:fit-content;-webkit-user-select:none;user-select:none;display:inline-block}:host ::ng-deep .markdown-highlighting .img-block .img-wrapper img{border-radius:6px}:host ::ng-deep .markdown-highlighting .img-block .img-wrapper:after{content:\"\\a\"}:host ::ng-deep .markdown-highlighting .img-block img:after{content:\"\";width:64px;height:64px}:host ::ng-deep .markdown-highlighting .img-block img{cursor:default}:host ::ng-deep .markdown-highlighting .cl-toc{font-size:2.8em;padding:.15em}:host ::ng-deep .markdown-highlighting .blockquote{color:var(--md-blockquote-color)}:host ::ng-deep .markdown-highlighting .h1,:host ::ng-deep .markdown-highlighting .h2,:host ::ng-deep .markdown-highlighting .h3,:host ::ng-deep .markdown-highlighting .h4,:host ::ng-deep .markdown-highlighting .h5,:host ::ng-deep .markdown-highlighting .h6,:host ::ng-deep .markdown-highlighting .h11,:host ::ng-deep .markdown-highlighting .h22{font-weight:600}:host ::ng-deep .markdown-highlighting .h1,:host ::ng-deep .markdown-highlighting .h1 *,:host ::ng-deep .markdown-highlighting .h2,:host ::ng-deep .markdown-highlighting .h2 *,:host ::ng-deep .markdown-highlighting .h3,:host ::ng-deep .markdown-highlighting .h3 *,:host ::ng-deep .markdown-highlighting .h4,:host ::ng-deep .markdown-highlighting .h4 *,:host ::ng-deep .markdown-highlighting .h5,:host ::ng-deep .markdown-highlighting .h5 *,:host ::ng-deep .markdown-highlighting .h6,:host ::ng-deep .markdown-highlighting .h6 *,:host ::ng-deep .markdown-highlighting .h11,:host ::ng-deep .markdown-highlighting .h11 *,:host ::ng-deep .markdown-highlighting .h22,:host ::ng-deep .markdown-highlighting .h22 *{line-height:1.33}:host ::ng-deep .markdown-highlighting .h1,:host ::ng-deep .markdown-highlighting .h11{font-size:2em}:host ::ng-deep .markdown-highlighting .h2,:host ::ng-deep .markdown-highlighting .h22{font-size:1.5em}:host ::ng-deep .markdown-highlighting .h3{font-size:1.17em}:host ::ng-deep .markdown-highlighting .h4{font-size:1em}:host ::ng-deep .markdown-highlighting .h5{font-size:.83em}:host ::ng-deep .markdown-highlighting .h6{font-size:.75em}:host ::ng-deep .markdown-highlighting .hr{font-style:normal;font-weight:400}:host ::ng-deep .markdown-highlighting .em{font-style:italic}:host ::ng-deep .markdown-highlighting .strong,:host ::ng-deep .markdown-highlighting .term{font-weight:600}:host ::ng-deep .markdown-highlighting .strikethrough-text{text-decoration:line-through}:host ::ng-deep .markdown-highlighting .underlined-text,:host ::ng-deep .markdown-highlighting .email{text-decoration:underline}:host ::ng-deep .markdown-highlighting .fn,:host ::ng-deep .markdown-highlighting .inlinefn,:host ::ng-deep .markdown-highlighting .sup{font-size:smaller;position:relative;top:-.5em}:host ::ng-deep .markdown-highlighting .sub{bottom:-.25em;font-size:smaller;position:relative}:host ::ng-deep :focus{outline:none}:host ::ng-deep .hidden-rendering-container{position:absolute;width:900px;min-height:400px;left:-100vw}:host ::ng-deep .toc__inner{position:relative;color:var(--text-header-color);cursor:pointer;font-size:12px;padding:10px 20px 40px;white-space:nowrap;-webkit-user-select:none;user-select:none}:host ::ng-deep .toc__inner *{font-weight:inherit}:host ::ng-deep .toc__inner .cl-toc-section h1:after,:host ::ng-deep .toc__inner .cl-toc-section h2:after{display:none}:host ::ng-deep .toc__inner .cl-toc-section h1{margin:1rem 0}:host ::ng-deep .toc__inner .cl-toc-section h2{margin:.5rem 0;margin-left:8px}:host ::ng-deep .toc__inner .cl-toc-section h3{margin:.33rem 0;margin-left:16px}:host ::ng-deep .toc__inner .cl-toc-section h4{margin:.22rem 0;margin-left:24px}:host ::ng-deep .toc__inner .cl-toc-section h5{margin:.11rem 0;margin-left:32px}:host ::ng-deep .toc__inner .cl-toc-section h6{margin:0 0 0 40px}:host ::ng-deep .preview__inner{margin:0;padding:24px}:host ::ng-deep .preview__inner>:first-child>:first-child{margin-top:0}:host ::ng-deep .preview__corner{position:absolute;top:0;right:0}:host ::ng-deep .prism.language-css{color:var(--prism-string-color)}:host ::ng-deep .prism.language-ts .token.subject,:host ::ng-deep .prism.language-js .token.subject{color:var(--prism-builtin-color)}:host ::ng-deep .prism.language-ts .token.import,:host ::ng-deep .prism.language-js .token.import{color:var(--prism-ts-keyword-color)}:host ::ng-deep .prism.language-ts .token.punctuation,:host ::ng-deep .prism.language-js .token.punctuation{color:var(--prism-ts-punctuation-color)}:host ::ng-deep .prism .img-spinner{align-items:center;background:#222;border-radius:50%;box-shadow:0 5px 20px #0003;display:inline-flex!important;justify-content:center}:host ::ng-deep .prism .img-spinner *{display:flex}:host ::ng-deep .prism .img-spinner span{display:none}:host ::ng-deep .prism .token.italic{font-style:italic}:host ::ng-deep .prism .token.image-spinner{color:#0000}:host ::ng-deep .prism .token.table-block .header-row{color:var(--prism-table-header-color);font-weight:600}:host ::ng-deep .prism .namespace{opacity:.7}:host ::ng-deep .prism .token.boolean,:host ::ng-deep .prism .token.constant,:host ::ng-deep .prism .token.deleted,:host ::ng-deep .prism .token.symbol{color:#569cd6}:host ::ng-deep .prism .token.builtin{color:var(--prism-builtin-color)}:host ::ng-deep .prism .token.char,:host ::ng-deep .prism .token.inserted{color:#690}:host ::ng-deep .prism .token.selector{color:var(--prism-selector-color)}:host ::ng-deep .prism .token.string{color:var(--prism-string-color)}:host ::ng-deep .prism .language-css .token.string,:host ::ng-deep .prism .style .token.string,:host ::ng-deep .prism .token.entity,:host ::ng-deep .prism .token.operator{color:#a67f59}:host ::ng-deep .prism .token.img-src,:host ::ng-deep .prism .token.src{color:var(--prism-url-color);text-decoration:underline;text-decoration-color:#40a6ff88}:host ::ng-deep .prism .token.dash,:host ::ng-deep .prism .token.colon,:host ::ng-deep .prism .token.pipe,:host ::ng-deep .prism .token.punctuation,:host ::ng-deep .prism .token.hash,:host ::ng-deep .prism .token.hr{color:var(--prism-punctuation-color)}:host ::ng-deep .prism .token.atrule{color:var(--prism-builtin-color)}:host ::ng-deep .prism .token.attr-value{color:var(--prism-string-color)}:host ::ng-deep .prism .token.code-snippet{color:var(--prism-string-color);background-color:var(--code-background-color);border-radius:3px}:host ::ng-deep .prism .token.function{color:var(--prism-function-color)}:host ::ng-deep .prism .token.important,:host ::ng-deep .prism .token.regex,:host ::ng-deep .prism .token.variable{color:#e90}:host ::ng-deep .prism .token.tag{color:var(--prism-tag-color)}:host ::ng-deep .prism .token.attr-name,:host ::ng-deep .prism .token.property{color:var(--prism-property-color)}:host ::ng-deep .prism .token.attr-value>.punctuation{color:var(--prism-attribute-color)}:host ::ng-deep .prism .token.attr-value>.punctuation.attr-equals{color:var(--prism-attribute-punctuation-color)}:host ::ng-deep .prism .token.attr-value>.value{color:var(--prism-attribute-value-color)}:host ::ng-deep .prism .token.attr-value>.value .punctuation{color:var(--prism-attribute-value-punctuation-color)}:host ::ng-deep .prism .token.number{color:var(--prism-number-color)}:host ::ng-deep .prism .token.cdata,:host ::ng-deep .prism .token.doctype,:host ::ng-deep .prism .token.prolog,:host ::ng-deep .prism .token.comment{color:var(--prism-comment-color)}:host ::ng-deep .prism .token.bold,:host ::ng-deep .prism .token.important{font-weight:500}:host ::ng-deep .prism .token.indent-space{letter-spacing:.45em}:host ::ng-deep .ng-scroll-content{width:100%}\n"] }]
        }], ctorParameters: () => [{ type: i0.ViewContainerRef }, { type: i2$1.LazyLoaderService }, { type: i2$1.CommandPaletteService }, { type: i2$1.ThemeService }, { type: i2$1.DialogService }, { type: i1.MatDialog }, { type: i3$1.DomSanitizer }, { type: undefined, decorators: [{
                    type: Optional
                }, {
                    type: Inject,
                    args: [NGX_STACKEDIT_CONFIG]
                }] }], propDecorators: { toolbar: [{
                type: ViewChild,
                args: [ToolbarComponent]
            }], theme: [{
                type: Input
            }], mode: [{
                type: Input
            }], showToc: [{
                type: Input
            }], showPreview: [{
                type: Input
            }], showCodeRunButton: [{
                type: Input
            }], codeRunner: [{
                type: Input
            }], customCodeLanguages: [{
                type: Input
            }], showCodeCopyButton: [{
                type: Input
            }], showMermaid: [{
                type: Input
            }], showLineNumbers: [{
                type: Input
            }], allowImageUpload: [{
                type: Input
            }], tabSize: [{
                type: Input
            }], tabChar: [{
                type: Input
            }], hideWritingSymbols: [{
                type: Input
            }], hooks: [{
                type: Input
            }], value: [{
                type: Input
            }], valueChange: [{
                type: Output
            }], onFileUpload: [{
                type: Output
            }], onImageUpload: [{
                type: Output
            }], onCustomCodeExecute: [{
                type: Output
            }] } });
const renderMarkdown = (input) => {
    // const converter = markdownConversionSvc.createConverter();
    // this.initConverter(converter, defaults.markdownIt);
};

/**
 * Generated bundle index. Do not edit.
 */

export { NGX_STACKEDIT_CONFIG, StackEditorComponent, renderMarkdown };
//# sourceMappingURL=ngx-stackedit.mjs.map
